﻿note
	description: "Implementation of {STS_BINARY_RELATION}"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date$"
	revision: "$Revision$"

class
	STI_BINARY_RELATION [
		A, B,
		EQ_A -> STS_EQUALITY [A]
			create default_create end,
		EQ_B -> STS_EQUALITY [B]
			create default_create end
		]

--inherit

--	STS_BINARY_RELATION [A, B, EQ_A, EQ_B]
--		undefine
--			out
--		redefine
--			departure_anchor,
--			arrival_anchor,
--			graph_anchor,
--			relation_anchor,
--			superrelation_anchor,
--			inverse_anchor
--		end

--	STI_ORDERED_TRIPLE [
--		STS_SET [A, EQ_A], STS_SET [B, EQ_B], STS_SET [STS_ORDERED_PAIR [A, B, EQ_A, EQ_B], STS_PAIR_EQUALITY [A, B, EQ_A, EQ_B]],
--		STS_SET_EQUALITY [A, EQ_A], STS_SET_EQUALITY [B, EQ_B], STS_SET_EQUALITY [STS_ORDERED_PAIR [A, B, EQ_A, EQ_B], STS_PAIR_EQUALITY [A, B, EQ_A, EQ_B]]
--		]
--		rename
--			make as triple_make,
--			inverse as pair_inverse,
--			composed_with_homogeneous as pair_composed_with_homogeneous,
--			composed_with_inverse_like as pair_composed_with_inverse_like,
--			front as related_sets,
--			first as departure,
--			second as arrival,
--			c as g,
--			third as graph,
--			eq_c as eq_g,
--			front_out as related_sets_out,
--			third_out as graph_out
--		redefine
--			triple_make,
--			pair_make,
--			make_from_pair,
--			make_from_triple,
--			a, departure,
--			b, arrival,
--			g
--		select
--			pair_out
--		end

--create
--	make

--feature {NONE} -- Initialization

--	make (a_departure: STS_SET [A, EQ_A]; a_arrival: STS_SET [B, EQ_B]; a_graph: STS_SET [STS_ORDERED_PAIR [A, B, EQ_A, EQ_B], STS_PAIR_EQUALITY [A, B, EQ_A, EQ_B]])
--			-- Create the binary relation (`a_departure`, `a_arrival`, `a_graph`)
--		require
--			within_product: a_graph ⊆ {STI_RELATION_PRODUCER [A, B, EQ_A, EQ_B]}.cartesian_product (a_departure, a_arrival)
--		do
--			create ab.make (a_departure, a_arrival)
--			create g.make_empty
--			g := g.converted (a_graph)
--		ensure
--			departure: a ≍ a_departure
--			arrival: b ≍ a_arrival
--			graph: g ≍ a_graph
--		end

--	pair_make (
--		a_related_sets: STS_ORDERED_PAIR [STS_SET [A, EQ_A], STS_SET [B, EQ_B], STS_SET_EQUALITY [A, EQ_A], STS_SET_EQUALITY [B, EQ_B]]
--		a_graph: STS_SET [STS_ORDERED_PAIR [A, B, EQ_A, EQ_B], STS_PAIR_EQUALITY [A, B, EQ_A, EQ_B]]
--		)
--			-- Create the binary relation (`a_related_sets`.`a', `a_related_sets`.`b', `a_graph`)
--		do
--			check
--					-- NOTICE: make it hold!
--				within_product: a_graph ⊆ {STI_RELATION_PRODUCER [A, B, EQ_A, EQ_B]}.cartesian_product (a_related_sets.a, a_related_sets.b)
--			then
--				if attached {like ab} a_related_sets as l_ab then
--					ab := l_ab
--				else
--					ab := a_related_sets
--				end
--				create g.make_empty
--				g := g.converted (a_graph)
--			end
--		end

--	triple_make (a_first: STS_SET [A, EQ_A]; a_second: STS_SET [B, EQ_B]; a_third: STS_SET [STS_ORDERED_PAIR [A, B, EQ_A, EQ_B], STS_PAIR_EQUALITY [A, B, EQ_A, EQ_B]])
--			-- <Precursor>
--		do
--			check
--					-- NOTICE: make it hold!
--				within_product: a_third ⊆ {STI_RELATION_PRODUCER [A, B, EQ_A, EQ_B]}.cartesian_product (a_first, a_second)
--			then
--				make (a_first, a_second, a_third)
--			end
--		end

--	make_from_pair (
--		abg: STS_ORDERED_PAIR [
--			STS_ORDERED_PAIR [STS_SET [A, EQ_A], STS_SET [B, EQ_B], STS_SET_EQUALITY [A, EQ_A], STS_SET_EQUALITY [B, EQ_B]],
--			STS_SET [STS_ORDERED_PAIR [A, B, EQ_A, EQ_B], STS_PAIR_EQUALITY [A, B, EQ_A, EQ_B]],
--			STS_PAIR_EQUALITY [STS_SET [A, EQ_A], STS_SET [B, EQ_B], STS_SET_EQUALITY [A, EQ_A], STS_SET_EQUALITY [B, EQ_B]],
--			STS_SET_EQUALITY [STS_ORDERED_PAIR [A, B, EQ_A, EQ_B], STS_PAIR_EQUALITY [A, B, EQ_A, EQ_B]]
--			]
--		)
--			-- Create the binary relation (`abg'.`a'.`a', `abg'.`a'.`b', `abg'.`b')
--		do
--			check
--					-- NOTICE: make it hold!
--				within_product: abg.b ⊆ {STI_RELATION_PRODUCER [A, B, EQ_A, EQ_B]}.cartesian_product (abg.a.a, abg.a.b)
--			then
--				if attached {like ab} abg.a as l_ab then
--					ab := l_ab
--				else
--					ab := abg.a
--				end
--				create g.make_empty
--				g := g.converted (abg.b)
--			end
--		end

--	make_from_triple (
--		abg: STS_ORDERED_TRIPLE [
--			STS_SET [A, EQ_A], STS_SET [B, EQ_B],
--			STS_SET [STS_ORDERED_PAIR [A, B, EQ_A, EQ_B], STS_PAIR_EQUALITY [A, B, EQ_A, EQ_B]],
--			STS_SET_EQUALITY [A, EQ_A], STS_SET_EQUALITY [B, EQ_B],
--			STS_SET_EQUALITY [STS_ORDERED_PAIR [A, B, EQ_A, EQ_B], STS_PAIR_EQUALITY [A, B, EQ_A, EQ_B]]
--			]
--		)
--			-- Create the binary relation (`abg`.a. `abg`.b, `abg`.`c`).
--		do
--			check
--					-- NOTICE: make it hold!
--				within_product: abg.c ⊆ {STI_RELATION_PRODUCER [A, B, EQ_A, EQ_B]}.cartesian_product (abg.a, abg.b)
--			then
--				if attached {like ab} abg.ab as l_ab then
--					ab := l_ab
--				else
--					ab := abg.ab
--				end
--				create g.make_empty
--				g := g.converted (abg.c)
--			end
--		end

--feature -- Access

--	a,
--	departure: like departure_anchor
--			-- <Precursor>
--		do
--			if attached {like departure_anchor} ab.a as l_departure then
--				Result := l_departure
--			else
--				create Result.make_empty
--				Result := Result.converted (ab.a)
--			end
--		end

--	b,
--	arrival: like arrival_anchor
--			-- <Precursor>
--		do
--			if attached {like arrival_anchor} ab.b as l_arrival then
--				Result := l_arrival
--			else
--				create Result.make_empty
--				Result := Result.converted (ab.b)
--			end
--		end

--feature -- Primitive

--	g: like graph_anchor
--			-- <Precursor>

--feature -- Operation

--	complemented alias "∁": like relation_anchor
--			-- <Precursor>
--		do
--				check
--					is_subset: g ⊆ (a × b) -- class invariant
--					within_product: g ∁ (a × b) ⊆ {STI_RELATION_PRODUCER [A, B, EQ_A, EQ_B]}.cartesian_product (a, b) -- `∁' definition
--				end
--			create Result.make (a, b, g ∁ (a × b))
--		end

--	united alias "∪" (r: STS_BINARY_RELATION [A, B, EQ_A, EQ_B]): like superrelation_anchor
--			-- <Precursor>
--		do
--				check
--					within_product: g ∪ r.g ⊆ {STI_RELATION_PRODUCER [A, B, EQ_A, EQ_B]}.cartesian_product (a ∪ r.a, b ∪ r.b) -- `∪' definition
--				end
--			create Result.make (a ∪ r.a, b ∪ r.b, g ∪ r.g)
--		end

--	intersected alias "∩" (r: STS_BINARY_RELATION [A, B, EQ_A, EQ_B]): like superrelation_anchor
--			-- <Precursor>
--		do
--				check
--					within_product: g ∩ r.g ⊆ {STI_RELATION_PRODUCER [A, B, EQ_A, EQ_B]}.cartesian_product (a ∪ r.a, b ∪ r.b) -- `∩' definition
--				end
--			create Result.make (a ∪ r.a, b ∪ r.b, g ∩ r.g)
--		end

--	subtracted alias "∖" (r: STS_BINARY_RELATION [A, B, EQ_A, EQ_B]): like superrelation_anchor
--			-- <Precursor>
--		do
--				check
--					within_product: g ∖ r.g ⊆ {STI_RELATION_PRODUCER [A, B, EQ_A, EQ_B]}.cartesian_product (a ∪ r.a, b ∪ r.b) -- `∖' definition
--				end
--			create Result.make (a ∪ r.a, b ∪ r.b, g ∖ r.g)
--		end

--	subtracted_symmetricaly alias "⊖" (r: STS_BINARY_RELATION [A, B, EQ_A, EQ_B]): like superrelation_anchor
--			-- <Precursor>
--		do
--				check
--					within_product: g ⊖ r.g ⊆ {STI_RELATION_PRODUCER [A, B, EQ_A, EQ_B]}.cartesian_product (a ∪ r.a, b ∪ r.b) -- `⊖' definition
--				end
--			create Result.make (a ∪ r.a, b ∪ r.b, g ⊖ r.g)
--		end

--	inverse alias "⁻¹": like inverse_anchor
--			-- <Precursor>
--		do
--				check
--					within_product: ⁻¹g ⊆ {STI_RELATION_PRODUCER [B, A, EQ_B, EQ_A]}.cartesian_product (b, a) -- ⁻¹`g' definition
--				end
--			create Result.make (b, a, ⁻¹g)
--		end

--feature -- Transformer

--	composer_with_homogeneous: STI_RELATION_COMPOSER [A, A, B, EQ_A, EQ_A, EQ_B]
--			-- <Precursor>
--		do
--			create Result
--		end

--	composer_with_inverse_like: STI_RELATION_COMPOSER [B, A, B, EQ_B, EQ_A, EQ_B]
--			-- <Precursor>
--		do
--			create Result
--		end

--feature -- Anchor

--	departure_anchor: STI_RELATABLE_SET [A, B, EQ_A, EQ_B]
--			-- <Precursor>
--		do
--			Result := a
--		end

--	arrival_anchor: STI_RELATABLE_SET  [B, A, EQ_B, EQ_A]
--			-- <Precursor>
--		do
--			Result := b
--		end

--	graph_anchor: STI_GRAPH [A, B, EQ_A, EQ_B]
--			-- <Precursor>
--		do
--			Result := g
--		end

--	relation_anchor,
--	superrelation_anchor: STI_BINARY_RELATION [A, B, EQ_A, EQ_B]
--			-- <Precursor>
--		do
--			Result := Current
--		end

--	inverse_anchor: STI_BINARY_RELATION [B, A, EQ_B, EQ_A]
--			-- <Precursor>
--		do
--			Result := ⁻¹ Current
--		end

note
	copyright: "Copyright (c) 2012-2019, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"
end
