﻿note
	description: "Implementation of {STS_RELATION_AWARE_SET}"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date$"
	revision: "$Revision$"

class
	STI_RELATION_AWARE_SET [A, EQ -> STS_EQUALITY [A] create default_create end]

--inherit

--	STS_RELATION_AWARE_SET [A, EQ]
--		undefine
--				-- Construction
--			with,
--			without,
--				-- Measurement
--			cardinality,
--				-- Output
--			out,
--				-- Comparison
--			equals,
--			is_strict_subset,
--			is_trivial_subset,
--			is_proper_subset,
--			is_disjoint,
--				-- Quantifier
--			exists,
--			exists_unique,
--			exists_pair,
--			exists_distinct_pair,
--			for_all,
--			for_all_pairs,
--			for_all_distinct_pairs,
--				-- Operation
--			trivial_subsets,
--			subtracted_symmetricaly,
--			diagonal,
--			crossed_tuples,
--				-- Predicate
--			equality_holds,
--			equality_does_not_hold,
--				-- Anchor
--			tuple_anchor
--		redefine
--				-- Anchor
--			set_anchor,
--			subset_anchor,
--			superset_anchor,
--			product_anchor,
--			square_anchor,
--			diagonal_anchor
--		end

--	STI_SET [A, EQ]
--		redefine
--			element_to_element,
--			element_to_natural,
--			element_to_boolean,
--			element_to_tuple,
--			element_to_sets,
--			tuple_extensor,
--			set_anchor,
--			subset_anchor,
--			superset_anchor,
--			product_anchor,
--			square_anchor,
--			diagonal_anchor
--		end

--create
--	make_empty, make_singleton, make_extended, make_from_set

--convert
--	make_from_set ({
--		STS_SET [A, EQ],
--		STI_SET [A, EQ],

--		STS_TRANSFORMABLE_SET [A, A, EQ, EQ],
--		STI_TRANSFORMABLE_SET [A, A, EQ, EQ],
--		
--		STS_RELATION_AWARE_SET [A, EQ],
--		STS_RELATABLE_SET [A, A, EQ, EQ]
--		})

--feature -- Operation

--	identity_relation alias "𝐼": STS_IDENTITY_RELATION [A, EQ]
--			-- <Precursor>
--		do
--			Result := 𝐼 Current
--		end

--feature -- Transformer

--	element_to_element: STI_ENDORELATION_PRODUCER [A, EQ]
--			-- <Precursor>
--		do
--			create Result
--		end

--	element_to_natural: STI_RELATION_PRODUCER [A, NATURAL, EQ, STS_OBJECT_EQUALITY [NATURAL]]
--			-- <Precursor>
--		do
--			create Result
--		end

--	element_to_boolean: STI_RELATION_PRODUCER [A, BOOLEAN, EQ, STS_OBJECT_EQUALITY [BOOLEAN]]
--			-- <Precursor>
--		do
--			create Result
--		end

--	element_to_tuple: STI_RELATION_PRODUCER [A, STS_N_TUPLE [A, EQ], EQ, STS_N_TUPLE_EQUALITY [A, EQ]]
--			-- <Precursor>
--		do
--			create Result
--		end

--	element_to_sets: STI_RELATION_PRODUCER [A, STS_SET [STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ]], EQ, STS_SET_EQUALITY [STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ]]]
--			-- <Precursor>
--		do
--			create Result
--		end

--	tuple_extensor: STI_RELATION_PRODUCER [STS_ORDERED_PAIR [A, STS_N_TUPLE [A, EQ], EQ, STS_N_TUPLE_EQUALITY [A, EQ]], STS_N_TUPLE [A, EQ], STS_PAIR_EQUALITY [A, STS_N_TUPLE [A, EQ], EQ, STS_N_TUPLE_EQUALITY [A, EQ]], STS_N_TUPLE_EQUALITY [A, EQ]]
--			-- <Precursor>
--		do
--			create Result
--		end

--feature -- Anchor

--	set_anchor,
--	subset_anchor,
--	superset_anchor: STI_RELATION_AWARE_SET [A, EQ]
--			-- <Precursor>
--		do
--			Result := Current
--		end

--	product_anchor,
--	square_anchor,
--	diagonal_anchor: STI_HOMOGENEOUS_GRAPH [A, EQ]
--			-- <Precursor>
--		do
--			Result := ²o
--		end

note
	copyright: "Copyright (c) 2012-2019, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"
end
