﻿note
	description: "Implementation of {STS_RELATION_PRODUCER}"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date$"
	revision: "$Revision$"

class
	STI_RELATION_PRODUCER [
		A, B,
		EQ_A -> STS_EQUALITY [A]
			create default_create end,
		EQ_B -> STS_EQUALITY [B]
			create default_create end
		]

--inherit

--	STS_RELATION_PRODUCER [A, B, EQ_A, EQ_B]

--	STI_TRANSFORMER [A, B, EQ_A, EQ_B]
--		undefine
--				-- Transformation
--			set_reduction,
--			tuple_left_reduction,
--			tuple_indexed_left_reduction,
--			tuple_right_reduction,
--			tuple_indexed_right_reduction
--		redefine
--			product_anchor
--		end

--feature -- Operation

--	binary_relations (xs: STS_SET [A, EQ_A]; ys: STS_SET [B, EQ_B]): STI_SET [STS_BINARY_RELATION [A, B, EQ_A, EQ_B], STS_RELATION_EQUALITY [A, B, EQ_A, EQ_B]]
--			-- Set of all binary relations between `xs' and `ys'
--		local
--			graphs: like cartesian_product.powerset
--		do
--			graphs := 𝒫 cartesian_product (xs, ys)
--			Result := {
--				STI_RELATION_PRODUCER [
--					STS_SET [STS_ORDERED_PAIR [A, B, EQ_A, EQ_B], STS_PAIR_EQUALITY [A, B, EQ_A, EQ_B]],
--					STS_BINARY_RELATION [A, B, EQ_A, EQ_B],
--					STS_SET_EQUALITY [STS_ORDERED_PAIR [A, B, EQ_A, EQ_B], STS_PAIR_EQUALITY [A, B, EQ_A, EQ_B]],
--					STS_RELATION_EQUALITY [A, B, EQ_A, EQ_B]
--					]
--				}.set_map (
--					graphs, agent (
--						ia_xs: STS_SET [A, EQ_A]; ia_ys: STS_SET [B, EQ_B]
--						g: STS_SET [STS_ORDERED_PAIR [A, B, EQ_A, EQ_B], STS_PAIR_EQUALITY [A, B, EQ_A, EQ_B]]
--						): STI_BINARY_RELATION [A, B, EQ_A, EQ_B]
--						do
--								check
--										-- g ∈ 𝒫 cartesian_product (ia_xs, ia_ys)
--									within_product: g ⊆ {STI_RELATION_PRODUCER [A, B, EQ_A, EQ_B]}.cartesian_product (ia_xs, ia_ys)
--								end
--							create Result.make (ia_xs, ia_ys, g)
--						end (xs, ys, ?)
--					)
--		end

--feature -- Transformer

--	relation_to_graph: STI_RELATION_PRODUCER [
--		STS_BINARY_RELATION [A, B, EQ_A, EQ_B], STS_SET [STS_ORDERED_PAIR [A, B, EQ_A, EQ_B], STS_PAIR_EQUALITY [A, B, EQ_A, EQ_B]],
--		STS_RELATION_EQUALITY [A, B, EQ_A, EQ_B], STS_SET_EQUALITY [STS_ORDERED_PAIR [A, B, EQ_A, EQ_B], STS_PAIR_EQUALITY [A, B, EQ_A, EQ_B]]
--		]
--			-- <Precursor>
--		do
--			create Result
--		end

--feature -- Anchor

--	product_anchor: STI_GRAPH [A, B, EQ_A, EQ_B]
--			-- <Precursor>
--		do
--			Result := o
--		end

note
	copyright: "Copyright (c) 2012-2019, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"
end
