﻿note
	description: "Object that checks whether the properties verified within set theory hold for an implementation of {STS_COMPLEX_SET}"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date$"
	revision: "$Revision$"

deferred class
	COMPLEX_SET_PROPERTIES

inherit
	NUMERIC_SET_PROPERTIES [STS_COMPLEX_NUMBER, STS_COMPLEX_EQUALITY]
		rename
			current_universe as c,
			universe_anchor as c_anchor
		end

feature -- Access

--	zero: like integer_anchor
--			-- The natural number 0
--		deferred
--		end

feature -- Anchor

--	integer_anchor: STS_INTEGER_NUMBER
--			-- Anchor for integer numbers
--		deferred
--		end

	c_anchor: STS_COMPLEX_SET
			-- Anchor for `c`
		deferred
		end

note
	copyright: "Copyright (c) 2012-2022, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"
end
