﻿note
	description: "Equality that compares integer numbers according to {INTEGER_NUMBER}.equals, i.e. the integer ≍ operator."
	author: "Rosivaldo Fernandes Alves"
	date: "$Date$"
	revision: "$Revision$"

class
	INTEGER_EQUALITY

inherit
	NUMERIC_EQUALITY [INTEGER_NUMBER]
		redefine
			holds
		end

feature -- Relationship

	holds alias "()" (i, j: INTEGER_NUMBER): BOOLEAN
			-- Does this equality hold for `i` and `j`?
		do
			Result := i ≍ j
		end

note
	copyright: "Copyright (c) 2012-2021, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"

end
