﻿note
	description: "Equality that compares real numbers according to {REAL_NUMBER}.equals, i.e. the real ≍ operator."
	author: "Rosivaldo Fernandes Alves"
	date: "$Date$"
	revision: "$Revision$"

class
	REAL_EQUALITY

inherit
	NUMERIC_EQUALITY [REAL_NUMBER]
		redefine
			holds
		end

feature -- Relationship

	holds alias "()" (x, y: REAL_NUMBER): BOOLEAN
			-- Does current equality hold for `x` and `y`?
		do
			Result := x ≍ y
		end

note
	copyright: "Copyright (c) 2012-2022, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"

end
