﻿note
	description: "Universe of all complex numbers, i.e. ℂ."
	author: "Rosivaldo Fernandes Alves"
	date: "$Date$"
	revision: "$Revision$"

deferred class
	COMPLEX_UNIVERSE

inherit
	COMPLEX_SET
		rename
			superset_anchor as itself
		undefine
			has
		end

	UNIVERSE [COMPLEX_NUMBER, COMPLEX_EQUALITY]

feature -- Anchor

	set_anchor,
	subset_anchor: COMPLEX_SET
			-- <Precursor>
		deferred
		end

	itself: like Current
			-- <Precursor>
		deferred
		end

note
	copyright: "Copyright (c) 2012-2021, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"

end
