﻿note
	description: "Set that has every element of a given type"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date$"
	revision: "$Revision$"

deferred class
	UNIVERSE [A, EQ -> EQUALITY [A]]

inherit
	SET [A, EQ]
		rename
			superset_anchor as itself
		redefine
			has
		end

feature -- Membership

	has alias "∋" (a: A): BOOLEAN
			-- <Precursor>
		do
			Result := True
		ensure then
			has_everything: Result
		end

feature -- Anchor

	itself: like Current
			-- <Precursor>
		deferred
		end

note
	copyright: "Copyright (c) 2012-2021, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"

end
