﻿note
	description: "todo: describe."
	author: "Rosivaldo Fernandes Alves"
	date: "$Date$"
	revision: "$Revision$"

deferred class
	STS_BINARY_RELATION [A, B, EQ_A -> STS_EQUALITY [A], EQ_B -> STS_EQUALITY [B]]

--inherit

--	STS_ORDERED_TRIPLE [
--		STS_SET [A, EQ_A], STS_SET [B, EQ_B], STS_SET [STS_ORDERED_PAIR [A, B, EQ_A, EQ_B], STS_PAIR_EQUALITY [A, B, EQ_A, EQ_B]],
--		STS_SET_EQUALITY [A, EQ_A], STS_SET_EQUALITY [B, EQ_B], STS_SET_EQUALITY [STS_ORDERED_PAIR [A, B, EQ_A, EQ_B], STS_PAIR_EQUALITY [A, B, EQ_A, EQ_B]]
--		]
--		rename
--			inverse as pair_inverse,
--			composed_with_homogeneous as pair_composed_with_homogeneous,
--			composed_with_inverse_like as pair_composed_with_inverse_like,
--			front as related_sets,
--			first as departure,
--			second as arrival,
--			c as g,
--			third as graph,
--			eq_c as eq_g
--		undefine
--			a, departure,
--			b, arrival
--		end

--feature -- Access

--	a,
--	departure: like departure_anchor
--			-- Departure set of this relation, i.e. set that includes the definition set of its `graph'.
--		deferred
--		end

--	b,
--	arrival: like arrival_anchor
--			-- Arrival set of this relation, i.e. set that includes the values set of its `graph'.
--		deferred
--		end

--	domain alias "𝐝𝐨𝐦": like graph.first_projection
--			-- The left projection of the `graph' of this relation
--		do
--			Result := π₁ g
--		ensure
--			definition: Result ≍ π₁ g
--		end

--	range alias "𝐫𝐚𝐧": like graph.second_projection
--			-- The right projection of the `graph' of this relation
--		do
--			Result := π₂ g
--		ensure
--			definition: Result ≍ π₂ g
--		end

--feature -- Primitive

--	g,
--	graph: like graph_anchor
--			-- Graph of this relation, i.e. the set that has the pairs which this relation holds for.
--		deferred
--		end

--feature -- Relationship

--	holds alias "()" (x: A; y: B): BOOLEAN
--			-- Does this relation hold for `x' and `y'?
--		do
--			Result := g (x, y)
--		ensure
--			definition: Result = g (x, y)
--		end

--	does_not_hold (x: A; y: B): BOOLEAN
--			-- Does not this relation hold for `x' and `y'?
--		do
--			Result := not holds (x, y)
--		ensure
--			definition: Result = not holds (x, y)
--		end

--feature -- Operation

--	complemented alias "∁": like relation_anchor
--			-- Complement of this relation, i.e. the relation (`a', `b', `g' ∁ (`a' × `b'))
--		deferred
--		ensure
--			departure: Result.a ≍ a
--			arrival: Result.b ≍ b
--			is_subset: g ⊆ (a × b) -- class invariant
--			graph: Result.g ≍ (g ∁ (a × b))
--		end

--	united alias "∪" (r: STS_BINARY_RELATION [A, B, EQ_A, EQ_B]): like superrelation_anchor
--			-- Union of this relatioin and `r', i.e. the relation (`a' ∪ `r'.`a', `b' ∪ `r'.`b', `g' ∪ `r'.`g').
--		deferred
--		ensure
--			departure: Result.a ≍ (a ∪ r.a)
--			arrival: Result.b ≍ (b ∪ r.b)
--			graph: Result.g ≍ (g ∪ r.g)
--		end

--	intersected alias "∩" (r: STS_BINARY_RELATION [A, B, EQ_A, EQ_B]): like superrelation_anchor
--			-- Intersection of this relatioin and `r', i.e. the relation (`a' ∪ `r'.`a', `b' ∪ `r'.`b', `g' ∩ `r'.`g').
--		deferred
--		ensure
--			departure: Result.a ≍ (a ∪ r.a)
--			arrival: Result.b ≍ (b ∪ r.b)
--			graph: Result.g ≍ (g ∩ r.g)
--		end

--	subtracted alias "∖" (r: STS_BINARY_RELATION [A, B, EQ_A, EQ_B]): like superrelation_anchor
--			-- Difference of this relatioin and `r', i.e. the relation (`a' ∪ `r'.`a', `b' ∪ `r'.`b', `g' ∖ `r'.`g').
--		deferred
--		ensure
--			departure: Result.a ≍ (a ∪ r.a)
--			arrival: Result.b ≍ (b ∪ r.b)
--			graph: Result.g ≍ (g ∖ r.g)
--		end

--	subtracted_symmetricaly alias "⊖" (r: STS_BINARY_RELATION [A, B, EQ_A, EQ_B]): like superrelation_anchor
--			-- Symmetric difference of this relatioin and `r', i.e. the relation (`a' ∪ `r'.`a', `b' ∪ `r'.`b', `g' ⊖ `r'.`g').
--		deferred
--		ensure
--			departure: Result.a ≍ (a ∪ r.a)
--			arrival: Result.b ≍ (b ∪ r.b)
--			graph: Result.g ≍ (g ⊖ r.g)
--		end

--	inverse alias "⁻¹": like inverse_anchor
--			-- Relation that holds for the inverse of every pair this relation holds for, i.e. the relation (`b', `a', ⁻¹`g').
--		deferred
--		ensure
--			departure: Result.a ≍ b
--			arrival: Result.b ≍ a
--			graph: Result.g ≍ ⁻¹g
--		end

--	image alias "[]" (s: STS_SET [A, EQ_A]): like graph.image
--			-- Image of `s' by the `graph'  of this relation
--		do
--			Result := g [s]
--		ensure
--			definition: Result ≍ g [s]
--		end

--	inverse_image (s: STS_SET [B, EQ_B]): like inverse.image
--			-- Image of `s' by `inverse'
--		do
--			Result := (⁻¹ Current) [s]
--		ensure
--		    definition: Result ≍ (⁻¹ Current) [s]
--		end

--	composed_with_homogeneous alias "₁∘₁"
--		(r: STS_BINARY_RELATION [A, A, EQ_A, EQ_A]): like composer_with_homogeneous.composite_relation
--			-- This relation composed with `r'
--		do
--			Result := composer_with_homogeneous.composite_relation (Current, r)
--		ensure
--			definition: Result ≍ composer_with_homogeneous.composite_relation (Current, r)
--		end

--	composed_with_inverse_like alias "₂∘₁"
--		(r: STS_BINARY_RELATION [B, A, EQ_B, EQ_A]): like composer_with_inverse_like.composite_relation
--			-- This relation composed with `r'
--		do
--			Result := composer_with_inverse_like.composite_relation (Current, r)
--		ensure
--			definition: Result ≍ composer_with_inverse_like.composite_relation (Current, r)
--		end

--feature -- Transformer

--	composer_with_homogeneous: STS_RELATION_COMPOSER [A, A, B, EQ_A, EQ_A, EQ_B]
--			-- Composer for relations like this one and those that hold for pairs that have elements of kind {A}
--			-- only
--		deferred
--		end

--	composer_with_inverse_like: STS_RELATION_COMPOSER [B, A, B, EQ_B, EQ_A, EQ_B]
--			-- Composer for relations like this one and those that hold for pairs are like inverses of those
--			-- this one holds for
--		deferred
--		end

--feature -- Anchor

--	departure_anchor: STS_RELATABLE_SET [A, B, EQ_A, EQ_B]
--			-- Anchor for sets like `departure'
--		do
--			Result := a
--		end

--	arrival_anchor: STS_RELATABLE_SET  [B, A, EQ_B, EQ_A]
--			-- Anchor for sets like `arrival'
--		do
--			Result := b
--		end

--	graph_anchor: STS_GRAPH [A, B, EQ_A, EQ_B]
--			-- Anchor for graphs
--		do
--			Result := g
--		end

--	relation_anchor: STS_BINARY_RELATION [A, B, EQ_A, EQ_B]
--			-- Anchor for relations like this one
--		do
--			Result := Current
--		end

--	superrelation_anchor: STS_BINARY_RELATION [A, B, EQ_A, EQ_B]
--			-- Anchor for relations whose departure and arrival sets may include those of this relation
--		do
--			Result := Current
--		end

--	inverse_anchor: STS_BINARY_RELATION [B, A, EQ_B, EQ_A]
--			-- Anchor for relations like `inverse'
--		do
--			Result := ⁻¹ Current
--		end

--invariant
--	within_product: g ⊆ (a × b)

note
	copyright: "Copyright (c) 2012-2020, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"
end
