﻿note
	description: "[
		Graph equipped with a composition operation with graphs whose first-element type is possibly
		unrelated to the types of elements in this graph
	]"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date$"
	revision: "$Revision$"

deferred class
	STS_COMPOSABLE_GRAPH [
		W, A, B,
		EQ_W -> STS_EQUALITY [W], EQ_A -> STS_EQUALITY [A], EQ_B -> STS_EQUALITY [B]
		]

--inherit

--	STS_GRAPH [A, B, EQ_A, EQ_B]
--		redefine
--				-- Anchor
--			graph_anchor,
--			subgraph_anchor,
--			supergraph_anchor,
--			inverse_anchor,
--			pair_anchor
--		end

--feature -- Operation

--	composed alias "∘" (g: STS_GRAPH [W, A, EQ_W, EQ_A]): like composer.composite_graph
--			-- This graph composed with `g'
--		do
--			Result := composer.composite_graph (Current, g)
--		ensure
--			definition: Result ≍ composer.composite_graph (Current, g)
--		end

--feature -- Transformer

--	composer: STS_RELATION_COMPOSER [W, A, B, EQ_W, EQ_A, EQ_B]
--			-- Composer for graphs like this one and those of pairs in the form ({W}, {A})
--		deferred
--		end

--feature -- Anchor

--	graph_anchor,
--	subgraph_anchor,
--	supergraph_anchor: STS_COMPOSABLE_GRAPH [W, A, B, EQ_W, EQ_A, EQ_B]
--			-- <Precursor>
--		do
--			Result := Current
--		end

--	inverse_anchor: STS_COMPOSABLE_GRAPH [W, B, A, EQ_W, EQ_B, EQ_A]
--			-- <Precursor>
--		do
--			Result := ⁻¹ Current
--		end

--	pair_anchor (a: A; b: B): STS_COMPOSABLE_PAIR [W, A, B, EQ_W, EQ_A, EQ_B]
--			-- <Precursor>
--		do
--			Result := pair (a, b)
--		end

note
	copyright: "Copyright (c) 2012-2020, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"
end
