﻿note
	description: "[
		Binary relation equipped with a composition operation with relations whose departure-element type is possibly
		unrelated to the types of elements related by this relation
	]"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date$"
	revision: "$Revision$"

deferred class
	STS_COMPOSABLE_RELATION [
		W, A, B,
		EQ_W -> STS_EQUALITY [W], EQ_A -> STS_EQUALITY [A], EQ_B -> STS_EQUALITY [B]
		]

--inherit

--	STS_BINARY_RELATION [A, B, EQ_A, EQ_B]
--		redefine
--			graph_anchor,
--			relation_anchor,
--			inverse_anchor
--		end

--feature -- Operation

--	composed alias "∘" (r: STS_BINARY_RELATION [W, A, EQ_W, EQ_A]): like composer.composite_relation
--			-- This relation composed with `r'
--		do
--			Result := composer.composite_relation (Current, r)
--		ensure
--			definition: Result ≍ composer.composite_relation (Current, r)
--		end

--feature -- Transformer

--	composer: STS_RELATION_COMPOSER [W, A, B, EQ_W, EQ_A, EQ_B]
--			-- Composer for relations like this one and those that hold for pairs in the form ({W}, {A})
--		deferred
--		end

--feature -- Anchor

--	graph_anchor: STS_COMPOSABLE_GRAPH [W, A, B, EQ_W, EQ_A, EQ_B]
--			-- <Precursor>
--		do
--			Result := g
--		end

--	relation_anchor: STS_COMPOSABLE_RELATION [W, A, B, EQ_W, EQ_A, EQ_B]
--			-- <Precursor>
--		do
--			Result := Current
--		end

--	inverse_anchor: STS_COMPOSABLE_RELATION [W, B, A, EQ_W, EQ_B, EQ_A]
--			-- <Precursor>
--		do
--			Result := ⁻¹ Current
--		end

note
	copyright: "Copyright (c) 2012-2020, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"
end
