﻿note
	description: "[
		Object able to relate objects derived from a generic parameter to objects derived from
		the same generic parameter.
	]"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date$"
	revision: "$Revision$"

deferred class
	STS_ENDORELATION_PRODUCER [A, EQ -> STS_EQUALITY [A]]

--inherit

--	STS_RELATION_PRODUCER [A, A, EQ, EQ]
--		redefine
--				-- Anchor
--			product_anchor
--		end

--feature -- Operation

--	endorelations (s: STS_SET [A, EQ]): STS_SET [STS_ENDORELATION [A, EQ], STS_ENDORELATION_EQUALITY [A, EQ]]
--			-- Set of all endorelations upon `s'
--		deferred
--		ensure
--			underlying_set: Result ∀ agent lies_upon (?, s)
--			graphs: endorelation_to_graph.set_map (Result, agent {STS_ENDORELATION [A, EQ]}.g) ≍ 𝒫 ²s
--		end

--feature -- Predicate

--	lies_upon (r: STS_ENDORELATION [A, EQ]; s: STS_SET [A, EQ]): BOOLEAN
--			-- Is `s' the underlying set of `r'?
--		do
--			Result := r.a ≍ s
--		ensure
--			class
--			definition: Result = r.a ≍ s
--		end

--feature -- Transformer

--	endorelation_to_graph: STS_RELATION_PRODUCER [
--		STS_ENDORELATION [A, EQ], STS_SET [STS_ORDERED_PAIR [A, A, EQ, EQ], STS_PAIR_EQUALITY [A, A, EQ, EQ]],
--		STS_ENDORELATION_EQUALITY [A, EQ], STS_SET_EQUALITY [STS_ORDERED_PAIR [A, A, EQ, EQ], STS_PAIR_EQUALITY [A, A, EQ, EQ]]
--		]
--			-- Producer of relations between endorelations and sets like their graphs
--		deferred
--		end

--feature -- Anchor

--	product_anchor: STS_HOMOGENEOUS_GRAPH [A, EQ]
--			-- <Precursor>
--		deferred
--		end

note
	copyright: "Copyright (c) 2012-2020, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"
end
