﻿note
	description: "Graph whose pairs have elements of the same kind"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date$"
	revision: "$Revision$"

deferred class
	STS_HOMOGENEOUS_GRAPH [A, EQ -> STS_EQUALITY [A]]

--inherit

--	STS_GRAPH [A, A, EQ, EQ]
--		rename
--			eq_b as eq_a
--		redefine
--				-- Anchor
--			graph_anchor,
--			subgraph_anchor,
--			supergraph_anchor,
--			inverse_anchor,
--			pair_anchor
--		end

--feature -- Quality

--	is_symmetric: BOOLEAN
--			-- Does this graph equal its inverse?
--		do
--			Result := Current ≍ ⁻¹ Current
--		ensure
--			definition: Result = Current ≍ ⁻¹ Current
--		end

--feature -- Operation

--	composed alias "∘" (g: STS_GRAPH [A, A, EQ, EQ]): STS_HOMOGENEOUS_GRAPH [A, EQ]
--			-- This graph composed with `g'
--		deferred
--		ensure
--			definition: Result ≍ (Current ₁∘₁ g)
--		end

--feature -- Anchor

--	graph_anchor,
--	subgraph_anchor,
--	supergraph_anchor: STS_HOMOGENEOUS_GRAPH [A, EQ]
--			-- <Precursor>
--		do
--			Result := Current
--		end

--	inverse_anchor: STS_HOMOGENEOUS_GRAPH [A, EQ]
--			-- <Precursor>
--		do
--			Result := ⁻¹ Current
--		end

--	pair_anchor (a: A; b: A): STS_HOMOGENEOUS_PAIR [A, EQ]
--			-- <Precursor>
--		do
--			Result := pair (a, b)
--		end

note
	copyright: "Copyright (c) 2012-2020, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"
end
