﻿note
	description: "Set aware of binary relations"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date$"
	revision: "$Revision$"

deferred class
	STS_RELATION_AWARE_SET [A, EQ -> STS_EQUALITY [A]]

--inherit
--	STS_SET [A, EQ]
--		redefine
--				-- Anchor
--			set_anchor,
--			subset_anchor,
--			superset_anchor,
--			product_anchor,
--			square_anchor,
--			diagonal_anchor
--		end

--feature -- Quantifier

--	exists_triple alias "∃³" (p: PREDICATE [A, A, A]): BOOLEAN
--			-- Does `p' hold for some triple of elements in this set?
--		do
--			Result := (Current ^ 3) ∃ agent predicate_holds_for_triple (p, ?)
--		ensure
--			definition: Result = ((Current ^ 3) ∃ agent predicate_holds_for_triple (p, ?))
--		end

--	for_all_triples alias "∀³" (p: PREDICATE [A, A, A]): BOOLEAN
--			-- Does `p' hold for every triple of elements in this set?
--		do
--			Result := (Current ^ 3) ∀ agent predicate_holds_for_triple (p, ?)
--		ensure
--			definition: Result = ((Current ^ 3) ∀ agent predicate_holds_for_triple (p, ?))
--		end

--feature -- Operation

--	identity_relation alias "𝐼": STS_IDENTITY_RELATION [A, EQ]
--			-- Identity relation upon this set
--		deferred
--		ensure
--			underlying_set: Result.a ≍ Current
--		end

--	relations alias "↔" (s: STS_SET [A, EQ]): like element_to_element.binary_relations
--			-- Set of all binary relations between this set and `s'
--		do
--			Result := element_to_element.binary_relations (Current, s)
--		ensure
--			definition: Result ≍ element_to_element.binary_relations (Current, s)
--		end

--	endorelations alias "↔": like element_to_element.endorelations
--			-- Set of all endorelations upon this set
--		do
--			Result := element_to_element.endorelations (Current)
--		ensure
--			definition: Result ≍ element_to_element.endorelations (Current)
--		end

--feature -- Predicate

--	predicate_holds_for_triple (p: PREDICATE [A, A, A]; t: STS_N_TUPLE [A, EQ]): BOOLEAN
--			-- Does `p' (`t' [1], `t' [2], `t' [3]) hold?
--		do
--			Result := t.n = 3 and then p (t [1], t [2], t [3])
--		ensure
--			class
--			definition: Result = (t.n = 3 and then p (t [1], t [2], t [3]))
--		end

--feature -- Transformer

--	element_to_element: STS_ENDORELATION_PRODUCER [A, EQ]
--			-- Producer of relations between types derived from {A}
--		deferred
--		end

--	element_to_natural: STS_RELATION_PRODUCER [A, NATURAL, EQ, STS_OBJECT_EQUALITY [NATURAL]]
--			-- Producer of relations between types derived from {A} and {NATURAL}
--		deferred
--		end

--	element_to_boolean: STS_RELATION_PRODUCER [A, BOOLEAN, EQ, STS_OBJECT_EQUALITY [BOOLEAN]]
--			-- Producer of relations between types derived from {A} and BOOLEAN
--		deferred
--		end

--	element_to_tuple: STS_RELATION_PRODUCER [A, STS_N_TUPLE [A, EQ], EQ, STS_N_TUPLE_EQUALITY [A, EQ]]
--			-- Producer of relations between types derived from {A} and {STS_N_TUPLE [A, EQ]}
--		deferred
--		end

--	element_to_sets: STS_RELATION_PRODUCER [A, STS_SET [STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ]], EQ, STS_SET_EQUALITY [STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ]]]
--			-- Producer of relations between types derived from {A} and
--			-- {STS_SET [STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ]]}
--		deferred
--		end

--	tuple_extensor: STS_RELATION_PRODUCER [STS_ORDERED_PAIR [A, STS_N_TUPLE [A, EQ], EQ, STS_N_TUPLE_EQUALITY [A, EQ]], STS_N_TUPLE [A, EQ], STS_PAIR_EQUALITY [A, STS_N_TUPLE [A, EQ], EQ, STS_N_TUPLE_EQUALITY [A, EQ]], STS_N_TUPLE_EQUALITY [A, EQ]]
--			-- Producer of relations between types derived from
--			-- {STS_ORDERED_PAIR [A, STS_N_TUPLE [A, EQ], EQ, STS_N_TUPLE_EQUALITY [A, EQ]]} and
--			-- {STS_N_TUPLE_EQUALITY [A, EQ]}
--		deferred
--		end

--feature -- Anchor

--	set_anchor,
--	subset_anchor,
--	superset_anchor: STS_RELATION_AWARE_SET [A, EQ]
--			-- <Precursor>
--		do
--			Result := Current
--		end

--	product_anchor,
--	square_anchor,
--	diagonal_anchor: STS_HOMOGENEOUS_GRAPH [A, EQ]
--			-- <Precursor>
--		do
--			Result := ²o
--		end

note
	copyright: "Copyright (c) 2012-2020, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"
end
