﻿note
	description: "[
		Equality that compares binary relations according to {STS_BINARY_RELATION}.equals, i.e. the
		binary relation ≍ operator.
	]"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date$"
	revision: "$Revision$"

class
	STS_RELATION_EQUALITY [A, B, EQ_A -> STS_EQUALITY [A], EQ_B -> STS_EQUALITY [B]]

--inherit

--	STS_INSTANCE_FREE_EQUALITY [STS_BINARY_RELATION [A, B, EQ_A, EQ_B]]

--feature -- Relationship

--	holds alias "()" (r1, r2: STS_BINARY_RELATION [A, B, EQ_A, EQ_B]): BOOLEAN
--			-- Does this equality hold for `r1` and `r2`?
--		do
--			Result := r1 ≍ r2
--		ensure then
--			definition: Result = (r1 ≍ r2)
--		end

note
	copyright: "Copyright (c) 2012-2020, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"
end
