﻿note
	description: "[
		Descendant of {STI_INTEGER_NUMBER} whose features with restricted
		access are available to be tested. Notice that inheriting from an
		expanded class is a non-conformant inheritance.
		]"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date$"
	revision: "$Revision$"

expanded class
	INTEGER_NUMBER

inherit
	STI_INTEGER_NUMBER
		export {NUMBERS_TESTS_RESOURCES}
			stored_value,
			Native_min_value,
			Native_max_value,
			Stored_value_bits,
			Stored_value_mask
		end

create
	default_create,
	make,
	make_from_native_integer_ref,
	make_from_integer,
	make_from_native_natural,
	make_from_native_natural_ref
	--	make_from_natural

create {NUMBERS_TESTS_RESOURCES}
	make_from_stored_value

convert
	make ({INTEGER}),
	make_from_native_integer_ref ({INTEGER_REF}),
	make_from_integer ({STS_INTEGER_NUMBER, STI_INTEGER_NUMBER}),
	make_from_native_natural ({NATURAL}),
	make_from_native_natural_ref ({NATURAL_32_REF}),
		--	make_from_natural ({STS_NATURAL}),
	value: {INTEGER, INTEGER_REF, NUMERIC, COMPARABLE, HASHABLE},
		--	as_rational: {STI_RATIONAL},
	as_real: {STI_REAL_NUMBER},
	real_value: {REAL, REAL_REF},
		--	real_value: {REAL, REAL_REF},
	as_complex: {STI_COMPLEX_NUMBER}

note
	copyright: "Copyright (c) 2012-2021, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"
end
