note
	description: "Descendant of {STI_COMPLEX_UNIVERSE} whose features with restricted access are available to be tested"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date$"
	revision: "$Revision$"

class
	COMPLEX_UNIVERSE

inherit
	STI_COMPLEX_UNIVERSE
		export {COMPLEX_UNIVERSE_PROPERTIES, COMPLEX_UNIVERSE_TESTS}
			make_empty,
			make_singleton,
			make_extended,
			make_from_set,
			make_from_numeric_set
		end

create
	default_create,
	make_from_universe

convert
	make_from_universe ({
		STS_UNIVERSE [STS_COMPLEX_NUMBER, STS_NUMERIC_EQUALITY [STS_COMPLEX_NUMBER]],
		STI_UNIVERSE [STS_COMPLEX_NUMBER, STS_NUMERIC_EQUALITY [STS_COMPLEX_NUMBER]],

		STS_UNIVERSE [STS_COMPLEX_NUMBER, STS_COMPLEX_EQUALITY],
		STI_UNIVERSE [STS_COMPLEX_NUMBER, STS_COMPLEX_EQUALITY],

		STS_COMPLEX_UNIVERSE,
		STI_COMPLEX_UNIVERSE
		}),
	as_set_of_pairs: {
		STI_SET_OF_ORDERED_PAIRS [STS_REAL_NUMBER, STS_REAL_NUMBER, STS_REAL_EQUALITY, STS_REAL_EQUALITY],
		STS_SET_OF_ORDERED_PAIRS [STS_REAL_NUMBER, STS_REAL_NUMBER, STS_REAL_EQUALITY, STS_REAL_EQUALITY],

		STI_SET_OF_ORDERED_PAIRS [STS_REAL_NUMBER, STS_REAL_NUMBER, STS_NUMERIC_EQUALITY [STS_REAL_NUMBER], STS_NUMERIC_EQUALITY [STS_REAL_NUMBER]],
		STS_SET_OF_ORDERED_PAIRS [STS_REAL_NUMBER, STS_REAL_NUMBER, STS_NUMERIC_EQUALITY [STS_REAL_NUMBER], STS_NUMERIC_EQUALITY [STS_REAL_NUMBER]]
		}

note
	copyright: "Copyright (c) 2012-2021, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"
end
