note
	description: "Descendant of {STI_REAL_UNIVERSE} adapted to allow testing of (partially) non-exported features and/or for better performance on testings."
	author: "Rosivaldo Fernandes Alves"
	date: "$Date$"
	revision: "$Revision$"

class
	REAL_UNIVERSE

inherit
	STI_REAL_UNIVERSE
		export
			{STI_REAL_UNIVERSE, REAL_UNIVERSE_PROPERTIES, REAL_UNIVERSE_TESTS}
				n_is_within_interval
			{REAL_UNIVERSE_PROPERTIES, REAL_UNIVERSE_TESTS}
				make_empty,
				make_singleton,
				make_extended,
				make_from_set,
				make_from_numeric_set,
				bit_pattern_interval,
				real_from_bit_pattern
		end

create
	default_create,
	make_from_universe

convert
	make_from_universe ({
		STS_UNIVERSE [STS_REAL_NUMBER, STS_NUMERIC_EQUALITY [STS_REAL_NUMBER]],
		STI_UNIVERSE [STS_REAL_NUMBER, STS_NUMERIC_EQUALITY [STS_REAL_NUMBER]],

		STS_UNIVERSE [STS_REAL_NUMBER, STS_REAL_EQUALITY],
		STI_UNIVERSE [STS_REAL_NUMBER, STS_REAL_EQUALITY],

		STS_REAL_UNIVERSE,
		STI_REAL_UNIVERSE
		}),
	as_complex_set: {
		STI_COMPLEX_SET,
		STS_COMPLEX_SET,

		STI_NUMERIC_SET [STS_COMPLEX_NUMBER, STS_COMPLEX_EQUALITY],
		STS_NUMERIC_SET [STS_COMPLEX_NUMBER, STS_COMPLEX_EQUALITY]
		}

note
	copyright: "Copyright (c) 2012-2021, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"
end
