note
	description: "(Partial) implementation of {STP_ORDERED_NUMERIC_SET_PROPERTIES}"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date$"
	revision: "$Revision$"

deferred class
	ORDERED_NUMERIC_SET_PROPERTIES [A -> STS_REAL_NUMBER, EQ -> STS_NUMERIC_EQUALITY [A] create default_create end]

inherit
	STP_ORDERED_NUMERIC_SET_PROPERTIES [A, EQ]
		undefine
			default_create,
			has_ok,
			with_ok,
			without_ok,
			subsets_ok,
			powerset_ok,
			sp_united_ok,
			sp_intersected_ok,
			sp_subtracted_ok,
			sp_subtracted_symmetricaly_ok,
			mapped_ok,
			singleton_ok
		end

	NUMERIC_SET_PROPERTIES [A, EQ]
		rename
			zero_ok as numeric_zero_ok
		end

feature -- Anchor

	set_anchor,
	universe_anchor: STI_ORDERED_NUMERIC_SET [A, EQ]
			-- <Precursor>
		deferred
		end

note
	copyright: "Copyright (c) 2012-2021, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"
end
