note
	description: "[
		{SETS_TESTS_RESOURCES_UNARY_SA} whose generic parameters is a set
		]"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date$"
	revision: "$Revision$"

deferred class
	SETS_TESTS_RESOURCES_UNARY_SSA [A, EQ -> STS_EQUALITY [A] create default_create end]

inherit
	SETS_TESTS_RESOURCES_UNARY_SA [STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ]]
		rename
			eq_sa as eq_ssa,
			resources_a as resources_sa,
			new_eq_sa as new_eq_ssa,
			new_n_tuple_equality_sa as new_n_tuple_equality_ssa,
			new_object_equality_sa as new_object_equality_ssa,
			new_object_equality_sa_sa as new_object_equality_ssa_ssa,
			new_object_equality_ssa as new_object_equality_sssa,
			new_object_equality_tsa as new_object_equality_tssa,
			new_pair_equality_sa_sa as new_pair_equality_ssa_ssa,
			new_reference_equality_sa as new_reference_equality_ssa,
			new_reference_equality_sa_sa as new_reference_equality_ssa_ssa,
			new_reference_equality_ssa as new_reference_equality_sssa,
			new_reference_equality_tsa as new_reference_equality_tssa,
			new_set_equality_sa as new_set_equality_ssa,
			new_n_tuple_sa as new_n_tuple_ssa,
			new_n_tuple_ssa as new_n_tuple_sssa,
			new_set_tuple_sa as new_set_tuple_ssa,
			new_transformable_tuple_sa_sa as new_transformable_tuple_ssa_ssa,
			new_transformable_tuple_ssa_tsa as new_transformable_tuple_sssa_tssa,
			same_n_tuple_sa as same_n_tuple_ssa,
			some_n_tuple_sa as some_n_tuple_ssa,
			set_twin_a as set_twin_sa,
			some_object_a as some_set_a,
			new_composable_pair_sa_sa_sa as new_composable_pair_ssa_ssa_ssa,
			new_homogeneous_pair_sa as new_homogeneous_pair_ssa,
			new_pair_sa_tsa as new_pair_ssa_tssa,
			new_pair_sa_sa as new_pair_ssa_ssa,
			some_pair_sa_sa as some_pair_ssa_ssa,
			new_pair_composer_sa_sa_sa as new_pair_composer_ssa_ssa_ssa,
			new_math_set_sa_sa as new_math_set_ssa_ssa,
			new_math_set_ssa as new_math_set_sssa,
			new_math_set_tsa as new_math_set_tssa,
			new_objects_sa as new_objects_ssa,
			new_objects_sa_sa as new_objects_ssa_ssa,
			new_objects_ssa as new_objects_sssa,
			new_objects_tsa as new_objects_tssa,
			new_references_sa as new_references_ssa,
			new_references_sa_sa as new_references_ssa_ssa,
			new_references_ssa as new_references_sssa,
			new_references_tsa as new_references_tssa,
			new_set_sa as new_set_ssa,
			new_set_family_sa as new_set_family_ssa,
			new_set_of_pairs_sa_sa as new_set_of_pairs_ssa_ssa,
			new_set_partition_sa as new_set_partition_ssa,
			new_subset_family_sa as new_subset_family_ssa,
			new_transformable_set_sa_sa as new_transformable_set_ssa_ssa,
			new_transformable_set_sa_sa_sa as new_transformable_set_ssa_ssa_ssa,
			new_transformable_set_ssa_tsa as new_transformable_set_sssa_tssa,
			new_transformable_set_tsa_ssa as new_transformable_set_tssa_sssa,
			partitioned_set_sa as partitioned_set_ssa,
			same_set_sa as same_set_ssa,
			same_set_a as same_set_sa,
			same_subset_family_sa as same_subset_family_ssa,
			some_direct_set_family_sa as some_direct_set_family_ssa,
			some_direct_set_partition_sa as some_direct_set_partition_ssa,
			some_direct_subset_family_sa as some_direct_subset_family_ssa,
			some_direct_subset_family_structure_sa as some_direct_subset_family_structure_ssa,
			new_subset_family_structure_sa as new_subset_family_structure_ssa,
			some_math_set_ssa as some_math_set_sssa,
			some_math_set_tsa as some_math_set_tssa,
			some_objects_ssa as some_objects_sssa,
			some_objects_tsa as some_objects_tssa,
			some_references_ssa as some_references_sssa,
			some_references_tsa as some_references_tssa,
			some_set_a as some_set_sa,
			some_set_sa as some_set_ssa,
			some_set_family_sa as some_set_family_ssa,
			some_set_of_sets_sa as some_set_of_sets_ssa,
			some_set_partition_sa as some_set_partition_ssa,
			some_set_ssa as some_set_sssa,
			some_set_tsa as some_set_tssa,
			some_subset_family_sa as some_subset_family_ssa,
			some_subset_family_structure_sa as some_subset_family_structure_ssa,
			new_transformer_sa_sa as new_transformer_ssa_ssa
		end

feature -- Access

	resources_sa: SETS_TESTS_RESOURCES_UNARY_SA [A, EQ]
			-- Pool of features for sets of elements like {A}
		deferred
		end

note
	copyright: "Copyright (c) 2012-2021, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"
end
