note
	description: "[
		{SETS_TESTS_RESOURCES_UNARY_SSA}, derived for {detachable INTEGER_REF} generic parameter, compared by object value.
		]"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date$"
	revision: "$Revision$"

class
	SETS_TESTS_RESOURCES_UNARY_SSI

inherit
	SETS_TESTS_RESOURCES_UNARY_SSA [detachable INTEGER_REF, STS_OBJECT_EQUALITY [detachable INTEGER_REF]]
		redefine
			on_prepare
		end

feature {NONE} -- Events

	on_prepare
			-- <Precursor>
		do
			create resources_sa
			create eq_ssa
		end


feature -- Access

	resources_sa: SETS_TESTS_RESOURCES_UNARY_SI
			-- Pool of features for sets of integer references

feature {SET_PROPERTIES} -- Implementation

	max_asserted_elements: NATURAL = 41_943 -- 2 ^ 20 // (Max_count ^ 2)
			-- <Precursor>

note
	copyright: "Copyright (c) 2012-2021, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"
end
