note
	description: "[
		{ELEMENT_TESTS}, made effective by inheriting {SETS_TESTS_RESOURCES_TERNARY_NIC}.
		]"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date: Sat 2018-11-10 18:52:01 -0300 $"
	revision: "$Revision$"
	testing: "type/manual"

class
	ELEMENT_TESTS_NIC -- TODO: .ecf bug!

inherit
	ELEMENT_TESTS
		redefine
			on_prepare,
			test_is_in,
			test_is_not_in
		end

	SETS_TESTS_RESOURCES_TERNARY_NIC
		redefine
			on_prepare
		end

feature -- Access

	properties: STP_ELEMENT_PROPERTIES
			-- <Precursor>
--		once
--			create Result
--		ensure then
--			class
--		end

feature {NONE} -- Events

	on_prepare
			-- <Precursor>
		do
			Precursor {SETS_TESTS_RESOURCES_TERNARY_NIC}
			create properties
		end

feature -- Test routines (Membership)

	test_is_in
			-- <Precursor>
		note
			testing: "covers/{STS_ELEMENT}.is_in"
		do
			Precursor {ELEMENT_TESTS}
		end

	test_is_not_in
			-- <Precursor>
		note
			testing: "covers/{STS_ELEMENT}.is_not_in"
		do
			Precursor {ELEMENT_TESTS}
		end

note
	copyright: "Copyright (c) 2012-2021, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"

end
