note
	description: "[
		Test suite for {STI_ORDERED_PAIR_COMPOSER [NATURAL, detachable INTEGER_REF, detachable separate CHARACTER_REF, ...]}
		]"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date: Sat 2018-11-10 18:52:01 -0300 $"
	revision: "$Revision$"
	testing: "type/manual"

class
	ORDERED_PAIR_COMPOSER_TESTS_NIC

inherit
	ORDERED_PAIR_COMPOSER_TESTS [
		NATURAL, detachable INTEGER_REF, detachable separate CHARACTER_REF,
		STS_OBJECT_EQUALITY [NATURAL],
		STS_OBJECT_EQUALITY [detachable INTEGER_REF],
		STS_REFERENCE_EQUALITY [detachable separate CHARACTER_REF]
		]
		rename
			some_object_a as some_integer_ref
		undefine
			on_prepare
		redefine
			test_is_in,
			test_is_not_in,
			test_composite_pair
		end

	ELEMENT_TESTS_NIC
		rename
			element_to_be_tested as composer_to_be_tested
		undefine
			composer_to_be_tested
		redefine
			properties,
			test_is_in,
			test_is_not_in
		end

feature -- Access

	properties: ORDERED_PAIR_COMPOSER_PROPERTIES [
		NATURAL, detachable INTEGER_REF, detachable separate CHARACTER_REF,
		STS_OBJECT_EQUALITY [NATURAL],
		STS_OBJECT_EQUALITY [detachable INTEGER_REF],
		STS_REFERENCE_EQUALITY [detachable separate CHARACTER_REF]
		]
			-- <Precursor>
--		once
--			create Result
--		end

feature -- Test routines (Membership)

	test_is_in
			-- Test {STS_ELEMENT}.is_in.
			-- Test {STS_ORDERED_PAIR_COMPOSER}.is_in.
			-- Test {STI_ORDERED_PAIR_COMPOSER}.is_in.
		note
			testing: "covers/{STS_ELEMENT}.is_in"
			testing: "covers/{STS_ORDERED_PAIR_COMPOSER}.is_in"
			testing: "covers/{STI_ORDERED_PAIR_COMPOSER}.is_in"
		do
			Precursor {ORDERED_PAIR_COMPOSER_TESTS}
		end

	test_is_not_in
			-- Test {STS_ELEMENT}.is_not_in.
			-- Test {STS_ORDERED_PAIR_COMPOSER}.is_not_in.
			-- Test {STI_ORDERED_PAIR_COMPOSER}.is_not_in.
		note
			testing: "covers/{STS_ELEMENT}.is_not_in"
			testing: "covers/{STS_ORDERED_PAIR_COMPOSER}.is_not_in"
			testing: "covers/{STI_ORDERED_PAIR_COMPOSER}.is_not_in"
		do
			Precursor {ORDERED_PAIR_COMPOSER_TESTS}
		end

feature -- Test routines (Operation)

	test_composite_pair
			-- <Precursor>
		note
			testing: "covers/{STI_ORDERED_PAIR_COMPOSER}.composite_pair"
		do
			Precursor {ORDERED_PAIR_COMPOSER_TESTS}
		end

note
	copyright: "Copyright (c) 2012-2021, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"

end
