﻿note
	description: "[
		Equality that compares complex numbers according to {STS_COMPLEX}.equals, i.e. the complex number ≍ operator.
		]"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date$"
	revision: "$Revision$"

class
	STS_COMPLEX_EQUALITY [C -> STS_COMPLEX]

inherit

	STS_INSTANCE_FREE_EQUALITY [C]

feature -- Relationship

	holds alias "()" (z1, z2: C): BOOLEAN
			-- Does this equality hold for `z1` and `z2`?
		do
			Result := z1 ≍ z2
		ensure then
			definition: Result = (z1 ≍ z2)
		end

note
	copyright: "Copyright (c) 2012-2019, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"
end
