﻿note
	description: "[
		Equality that compares rational numbers according to {STS_RATIONAL}.equals, i.e. the ordered pair ≍ operator.
		]"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date$"
	revision: "$Revision$"

class
	STS_RATIONAL_EQUALITY [Q -> STS_RATIONAL]

inherit

	STS_INSTANCE_FREE_EQUALITY [Q]

feature -- Relationship

	holds alias "()" (r1, r2: Q): BOOLEAN
			-- <Precursor>
		do
			Result := r1 ≍ r2
		ensure then
			definition: Result = (r1 ≍ r2)
		end

note
	copyright: "Copyright (c) 2012-2019, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"
end
