﻿note
	description: "[
		Equality that compares rational numbers according to {STS_REAL}.equals, i.e. the real ≍ operator.
		]"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date$"
	revision: "$Revision$"

class
	STS_REAL_EQUALITY [R -> STS_REAL]

inherit

	STS_INSTANCE_FREE_EQUALITY [R]

feature -- Relationship

	holds alias "()" (r1, r2: R): BOOLEAN
			-- Does this equality hold for `r1` and `r2`?
		do
			Result := r1 ≍ r2
		ensure then
			definition: Result = (r1 ≍ r2)
		end

note
	copyright: "Copyright (c) 2012-2019, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"
end
