﻿note
	description: "Universe of complex numbers, i.e. ℂ."
	author: "Rosivaldo Fernandes Alves"
	date: "$Date$"
	revision: "$Revision$"

deferred class
	STS_COMPLEX_UNIVERSE [C -> STS_COMPLEX, EQ -> STS_COMPLEX_EQUALITY [C]]

inherit

	STS_COMPLEX_SET [C, EQ]
		rename
				-- Anchor
			superset_anchor as itself
		undefine
				-- Membership
			has,
				-- Anchor
			itself
		end

	STS_UNIVERSE [C, EQ]
		undefine
				-- Anchor
			set_anchor,
			subset_anchor
		end

note
	copyright: "Copyright (c) 2012-2019, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"

end
