﻿note
	description: "Set of natural numbers, i.e. a subset of ℕ."
	author: "Rosivaldo Fernandes Alves"
	date: "$Date$"
	revision: "$Revision$"

deferred class
	STS_NATURAL_SET [N -> STS_NATURAL, EQ -> STS_NATURAL_EQUALITY [N]]

inherit

	STS_ORDERED_NUMERIC_SET [N, EQ]
		redefine
				-- Anchor
			set_anchor,
			subset_anchor,
			superset_anchor
		end

feature -- Anchor

	set_anchor,
	subset_anchor,
	superset_anchor: STS_NATURAL_SET [N, EQ]
			-- <Precursor>
		do
			Result := Current
		end

note
	copyright: "Copyright (c) 2012-2019, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"
end
