﻿note
	description: "Set of rational numbers, i.e. a subset of ℚ."
	author: "Rosivaldo Fernandes Alves"
	date: "$Date$"
	revision: "$Revision$"

deferred class
	STS_RATIONAL_SET [Q -> STS_RATIONAL, EQ -> STS_RATIONAL_EQUALITY [Q]]

inherit

	STS_SIGNED_NUMERIC_SET [Q, EQ]
		redefine
				-- Anchor
			set_anchor,
			subset_anchor,
			superset_anchor
		end

feature -- Anchor

	set_anchor,
	subset_anchor,
	superset_anchor: STS_RATIONAL_SET [Q, EQ]
			-- <Precursor>
		do
			Result := Current
		end

note
	copyright: "Copyright (c) 2012-2019, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"
end
