﻿note
	description: "Universe of rational numbers, i.e. ℚ."
	author: "Rosivaldo Fernandes Alves"
	date: "$Date$"
	revision: "$Revision$"

deferred class
	STS_RATIONAL_UNIVERSE [Q -> STS_RATIONAL, EQ -> STS_RATIONAL_EQUALITY [Q]]

inherit

	STS_RATIONAL_SET [Q, EQ]
		rename
				-- Anchor
			superset_anchor as itself
		undefine
				-- Membership
			has,
				-- Anchor
			itself
		end

	STS_UNIVERSE [Q, EQ]
		undefine
				-- Anchor
			set_anchor,
			subset_anchor
		end

note
	copyright: "Copyright (c) 2012-2019, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"
end
