﻿note
	description: "Universe of all real numbers, i.e. ℝ."
	author: "Rosivaldo Fernandes Alves"
	date: "$Date$"
	revision: "$Revision$"

deferred class
	STS_REAL_UNIVERSE [R -> STS_REAL, EQ -> STS_REAL_EQUALITY [R]]

inherit

	STS_REAL_SET [R, EQ]
		rename
				-- Anchor
			superset_anchor as itself
		undefine
				-- Membership
			has,
				-- Anchor
			itself
		end

	STS_UNIVERSE [R, EQ]
		undefine
				-- Anchor
			set_anchor,
			subset_anchor
		end

note
	copyright: "Copyright (c) 2012-2019, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"

end
