﻿note
	description: "Set that has every element of a given type"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date$"
	revision: "$Revision$"

deferred class
	STS_UNIVERSE [A, EQ -> STS_EQUALITY [A]]

inherit
	STS_SET [A, EQ]
		rename
				-- Anchor
			superset_anchor as itself
		redefine
				-- Membership
			has,
				-- Anchor
			itself
		end

feature -- Membership

	has alias "∋" (a: A): BOOLEAN
			-- <Precursor>
		do
			Result := True
		ensure then
			has_everything: Result
		end

feature -- Anchor

	itself: like Current
			-- <Precursor>
		do
			Result := Current
		end

note
	copyright: "Copyright (c) 2012-2019, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"

end
