note
	description: "Test suite for {STS_COMPLEX_EQUALITY}"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date$"
	revision: "$Revision$"
	testing: "type/manual"

deferred class
	STT_COMPLEX_EQUALITY_TESTS [
		X, B,
		EQ_X -> STS_EQUALITY [X]
			create
				default_create
			end,
		EQ_B -> STS_EQUALITY [B]
			create
				default_create
			end
		]

--inherit
--	STT_EQUALITY_TESTS [X, STS_COMPLEX, B, EQ_X, STS_COMPLEX_EQUALITY [STS_COMPLEX], EQ_B]
--		rename
--				-- Factory (test element)
--			test_equality as test_complex_equality,
--				-- Factory (object)
--			some_object_a as some_complex,
--			some_natural as some_native_natural,
--			some_integer as some_native_integer
--		undefine
--				-- Factory (element)
--			some_element,
--				-- Factory (object)
--			some_object
--		redefine
--				-- Access
--			properties,
--				-- Test routines (Relationship)
--			test_holds,
--			test_holds_successively,
--				-- Factory (test element)
--			test_complex_equality
--		end

--	STT_NUMBERS_ELEMENT_TESTS [X, STS_COMPLEX, B, EQ_X, STS_COMPLEX_EQUALITY [STS_COMPLEX], EQ_B]
--		rename
--				-- Factory (test element)
--			element_to_be_tested as test_complex_equality,
--				-- Factory (element)
--			some_object_a as some_complex
--		redefine
--				-- Access
--			properties,
--				-- Factory (test element)
--			test_complex_equality
--		end

--feature {NONE} -- Access

--	properties: STT_EQUALITY_PROPERTIES [STS_COMPLEX, STS_COMPLEX_EQUALITY [STS_COMPLEX]]
--			-- Object that checks the set-theory properties of {STS_COMPLEX_EQUALITY}

--feature -- Test routines (Relationship)

--	test_holds
--			-- Test {STS_COMPLEX_EQUALITY}.holds.
--		note
--			testing: "covers/{STS_COMPLEX_EQUALITY}.holds"
--		local
--			eq: like test_complex_equality
--			z1, z2: like some_complex
--		do
--			Precursor {STT_EQUALITY_TESTS}

--			eq := test_complex_equality
--			z1 := some_complex
--			z2 := same_complex (z1)
--			assert ("same_complex", eq (z1, z2))
--			assert ("same_complex_ok", properties.holds_ok (z1, z2, eq))
--		end

--	test_holds_successively
--			-- Test {STS_COMPLEX_EQUALITY}.holds_successively.
--		note
--			testing: "covers/{STS_COMPLEX_EQUALITY}.holds_successively"
--		local
--			eq: like test_complex_equality
--			z1, z2, z3: like some_complex
--		do
--			Precursor {STT_EQUALITY_TESTS}

--			eq := test_complex_equality
--			z1 := some_complex
--			z2 := same_complex (z1)
--			z3 := same_complex (z2)
--			assert ("same_complex", eq.holds_successively (z1, z2, z3))
--			assert (
--				"same_complex_ok",
--				properties.holds_successively_ok (z1, z2, z3, eq)
--				)
--		end

--feature {NONE} -- Factory (test element)

--	test_complex_equality: STS_COMPLEX_EQUALITY [STS_COMPLEX]
--			-- Complex equality meant to be under tests
--		do
--			create Result
--		end

note
	copyright: "Copyright (c) 2012-2019, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"
end
