﻿note
	description: "Test suite for {STI_COMPLEX_SET}"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date$"
	revision: "$Revision$"
	testing: "type/manual"

deferred class
	STT_STRICT_COMPLEX_SET_TESTS [
		X, B,
		EQ_X -> STS_EQUALITY [X]
			create
				default_create
			end,
		EQ_B -> STS_EQUALITY [B]
			create
				default_create
			end
		]

--inherit
--	STT_COMPLEX_SET_TESTS [X, STI_COMPLEX, B, EQ_X, STS_COMPLEX_EQUALITY [STI_COMPLEX], EQ_B]
--		rename
--				 -- Factory (object)
--			some_object_a as some_strict_complex
--		redefine
--				-- Access
--			properties,
--				-- Factory (test element)
----			test_complex_set,
--			-- Factory (set [A])
--			some_set_a,
--			same_set_a
--		end

--	STT_SET_TESTS [X, STI_COMPLEX, B, EQ_X, STS_COMPLEX_EQUALITY [STI_COMPLEX], EQ_B]
--		rename
--				-- Factory (test element)
--			test_set as test_complex_set,
--				-- Factory (object)
--			some_object_a as some_strict_complex,
--			some_integer as some_native_integer,
--			some_natural as some_native_natural
--		undefine
--				-- Factory (element)
--			some_element,
--				-- Factory (object)
--			some_object
--		redefine
--				-- Access
--			properties,
--				-- Factory (test element)
--			test_complex_set,
--			-- Factory (set [A])
--			some_set_a,
--			same_set_a
--		end

--feature {NONE} -- Access

--	properties: STT_SET_PROPERTIES  [STI_COMPLEX, STS_COMPLEX_EQUALITY [STI_COMPLEX]]
--			-- Object that checks the set-theory properties of {STI_SET}

----feature -- Test routines (Access)

----	test_zero
----			-- Test {STI_COMPLEX_SET}.zero.
----		note
----			testing: "covers/{STI_COMPLEX_SET}.zero"
----		do
----			assert ("zero", attached {like test_complex_set}.Zero)
----		end

----feature -- Test routines (Restriction)

----	test_without_zero
----			-- Test {STI_COMPLEX_SET}.without_zero.
----		note
----			testing: "covers/{STI_COMPLEX_SET}.without_zero"
----		do
----			assert ("without_zero", attached test_complex_set.without_zero)
----		end

--feature {NONE} -- Factory (test element)

--	test_complex_set: STI_COMPLEX_SET
--			-- Complex set meant to be under tests
--		do
--			across
--				1 |..| some_count.as_integer_32 as i
--			from
--				create Result.make_empty
--			loop
--				Result := Result & some_strict_complex
--			end
--		end

--feature {NONE} -- Factory (set [A])

--	some_set_a: STI_SET [STI_COMPLEX, STS_COMPLEX_EQUALITY [STI_COMPLEX]]
--			-- <Precursor>
--		do
--			inspect
--				next_random_item \\ 2
--			when 0 then
--				Result := Precursor {STT_SET_TESTS}
----				Precursor {STT_NUMBERS_ELEMENT_TESTS}
--			else -- when 1 then
--				Result := some_complex_set
--			end
--		end

--	same_set_a (s: STI_SET [STI_COMPLEX, STS_COMPLEX_EQUALITY [STI_COMPLEX]]): STI_SET [STI_COMPLEX, STS_COMPLEX_EQUALITY [STI_COMPLEX]]
--			-- <Precursor>
--		local
--			l_s: STI_SET [STI_COMPLEX, STS_COMPLEX_EQUALITY [STI_COMPLEX]]
--		do
--			inspect
--				next_random_item \\ 2
--			when 0 then
--				Result := Precursor {STT_SET_TESTS}(s)
----				Precursor {STT_NUMBERS_ELEMENT_TESTS}(s)
--			else -- when 1 then
--				from
--					create {like some_complex_set} Result.make_empty
--					l_s := s
--				invariant
--					building_up: Result ≍ (s - l_s)
--				until
--					l_s.is_empty
--				loop
--						check
--							does_not_have: not Result.has (l_s.any) -- Result ≍ (s - l_s)
--						end
--					Result := Result.extended (l_s.any)
--					l_s := l_s.others
--				variant
--					cardinality: (# l_s).as_integer_64
--				end
--			end
--		end

note
	copyright: "Copyright (c) 2012-2019, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"
end
