note
	description: "Test suite for {STI_COMPLEX}"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date$"
	revision: "$Revision$"
	testing: "type/manual"

deferred class
	STT_STRICT_COMPLEX_TESTS [
		X, B,
		EQ_X -> STS_EQUALITY [X]
			create
				default_create
			end,
		EQ_B -> STS_EQUALITY [B]
			create
				default_create
			end
		]

--inherit
--	STT_COMPLEX_TESTS  [X, STS_COMPLEX, B, EQ_X, STS_COMPLEX_EQUALITY [STS_COMPLEX], EQ_B]
--		rename
--				-- Factory (object)
--			some_object_a as some_complex
--		end
--		
--feature -- Test routines (Initialization)

--	test_default_create
--			-- Test {STI_COMPLEX}.default_create.
--		note
--			testing: "covers/{STI_COMPLEX}.default_create"
--		do
--			assert ("default_create", attached (create {like test_complex}))
--		end

--	test_make
--			-- Test {STI_COMPLEX}.make.
--		note
--			testing: "covers/{STI_COMPLEX}.make"
--		do
--			assert (
--				"make",
--				attached (
--					create {like test_complex}.make (some_strict_real, some_strict_real)
--					)
--				)
--		end

--	test_make_from_real
--			-- Test {STI_COMPLEX}.make_from_real.
--		note
--			testing: "covers/{STI_COMPLEX}.make_from_real"
--		do
--			assert (
--				"make_from_real",
--				attached (
--					create {like test_complex}.make_from_real (some_strict_real)
--					)
--				)
--		end

--	test_make_from_native_real
--			-- Test {STI_COMPLEX}.make_from_native_real.
--		note
--			testing: "covers/{STI_COMPLEX}.make_from_native_real"
--		local
--			l_converted: FUNCTION [REAL, like test_complex]
--		do
--			assert (
--				"make_from_native_real",
--				attached (
--					create {like test_complex}.make_from_native_real (some_native_real)
--					)
--				)

--			l_converted := agent (v: REAL): like test_complex
--				do
--					Result := v
--				end
--			assert ("convert_from_native_real", attached (l_converted (some_native_real)))
--		end

--	test_make_from_native_real_64
--			-- Test {STI_COMPLEX}.make_from_native_real_64.
--		note
--			testing: "covers/{STI_COMPLEX}.make_from_native_real_64"
--		local
--			l_converted: FUNCTION [REAL_64, like test_complex]
--		do
--			assert (
--				"make_from_native_real_64",
--				attached (
--					create {like test_complex}.make_from_native_real_64 (some_native_real_64)
--					)
--				)

--			l_converted := agent (v: REAL_64): like test_complex
--				do
--					Result := v
--				end
--			assert ("convert_from_native_real_64", attached (l_converted (some_native_real_64)))
--		end

--feature -- Test routines (Primitive)

--	test_real
--			-- Test {STI_COMPLEX}.real.
--		note
--			testing: "covers/{STI_COMPLEX}.real"
--		do
--			assert ("real", attached test_complex.real)
--		end

--	test_imaginary
--			-- Test {STI_COMPLEX}.imaginary.
--		note
--			testing: "covers/{STI_COMPLEX}.imaginary"
--		do
--			assert ("imaginary", attached test_complex.imaginary)
--		end

--feature -- Test routines (Output)

--	test_out
--			-- Test {STI_COMPLEX}.out.
--		note
--			testing: "covers/{STI_COMPLEX}.out"
--		do
--			assert ("out", attached test_complex.out)
--		end

--feature {NONE} -- Factory (test element)

--	test_complex: STI_COMPLEX
--			-- <Precursor>
--		do
--			create Result.make (some_strict_real, some_strict_real)
--		end

note
	copyright: "Copyright (c) 2012-2019, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"
end
