note
	description: "Test suite for {STI_REAL}"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date$"
	revision: "$Revision$"
	testing: "type/manual"

deferred class
	STT_STRICT_REAL_TESTS [
		X, B,
		EQ_X -> STS_EQUALITY [X]
			create
				default_create
			end,
		EQ_B -> STS_EQUALITY [B]
			create
				default_create
			end
		]

--inherit
--	STT_REAL_TESTS  [X, STS_REAL, B, EQ_X, STS_REAL_EQUALITY [STS_REAL], EQ_B]
--		rename
--				-- Factory (object)
--			some_object_a as some_real
--		end
--feature -- Test routines (Initialization)

--	test_default_create
--			-- Test {STI_REAL}.default_create.
--		note
--			testing: "covers/{STI_REAL}.default_create"
--		do
--			assert ("default_create", attached (create {like test_real}))
--		end

--	test_make
--			-- Test {STI_REAL}.make.
--		note
--			testing: "covers/{STI_REAL}.make"
--		local
--			l_converted: FUNCTION [REAL, like test_real]
--		do
--			assert ("make", attached (create {like test_real}.make (some_native_real)))

--			l_converted := agent (v: REAL): like test_real
--				do
--					Result := v
--				end
--			assert ("convert_make", attached (l_converted (some_native_real)))
--		end

--	test_make_from_native_real_64
--			-- Test {STI_REAL}.make_from_native_real_64.
--		note
--			testing: "covers/{STI_REAL}.make_from_native_real_64"
--		local
--			l_converted: FUNCTION [REAL_64, like test_real]
--		do
--			assert ("make_from_native_real_64", attached (create {like test_real}.make_from_native_real_64 (some_native_real_64)))

--			l_converted := agent (v: REAL_64): like test_real
--				do
--					Result := v
--				end
--			assert ("convert_from_native_real_64", attached (l_converted (some_native_real_64)))
--		end

--	test_make_from_native_integer
--			-- Test {STI_REAL}.make_from_native_integer.
--		note
--			testing: "covers/{STI_REAL}.make_from_native_integer"
--		local
--			l_converted: FUNCTION [INTEGER, like test_real]
--		do
--			assert ("make_from_native_integer", attached (create {like test_real}.make_from_native_integer (some_native_integer)))

--			l_converted := agent (v: INTEGER): like test_real
--				do
--					Result := v
--				end
--			assert ("convert_from_native_integer", attached (l_converted (some_native_integer)))
--		end

--	test_make_from_native_natural
--			-- Test {STI_REAL}.make_from_native_natural.
--		note
--			testing: "covers/{STI_REAL}.make_from_native_natural"
--		local
--			l_converted: FUNCTION [NATURAL, like test_real]
--		do
--			assert ("make_from_native_natural", attached (create {like test_real}.make_from_native_natural (some_native_natural)))

--			l_converted := agent (v: NATURAL): like test_real
--				do
--					Result := v
--				end
--			assert ("convert_from_native_natural", attached (l_converted (some_native_natural)))
--		end

--	test_make_abs
--			-- Test {STI_REAL}.make_abs.
--		note
--			testing: "covers/{STI_REAL}.make_abs"
--		do
--			assert ("make_abs", attached (create {like test_real}.make_abs (some_strict_real)))
--		end

--	test_make_opposite
--			-- Test {STI_REAL}.make_opposite.
--		note
--			testing: "covers/{STI_REAL}.make_opposite"
--		do
--			assert ("make_opposite", attached (create {like test_real}.make_opposite (some_strict_real)))
--		end

--feature -- Test routines (Primitive)

--	test_value
--			-- Test {STI_REAL}.value.
--		note
--			testing: "covers/{STI_REAL}.value"
--		local
--			l_converted: FUNCTION [like test_real, REAL]
--		do
--			l_converted := agent (x: like test_real): REAL
--				do
--					Result := x
--				end
--			assert ("convert_value", attached (l_converted (test_real)))
--		end

--feature -- Test routines (Access)

--	test_nan
--			-- Test {STI_REAL}.nan.
--		note
--			testing: "covers/{STI_REAL}.nan"
--		do
--			assert ("nan", attached {like test_real}.Nan)
--		end

--	test_negative_infinity
--			-- Test {STI_REAL}.negative_infinity.
--		note
--			testing: "covers/{STI_REAL}.negative_infinity"
--		do
--			assert ("negative_infinity", attached {like test_real}.Negative_infinity)
--		end

--	test_positive_infinity
--			-- Test {STI_REAL}.positive_infinity.
--		note
--			testing: "covers/{STI_REAL}.positive_infinity"
--		do
--			assert ("positive_infinity", attached {like test_real}.Positive_infinity)
--		end

--feature -- Test routines (Output)

--	test_out
--			-- Test {STI_REAL}.out.
--		note
--			testing: "covers/{STI_REAL}.out"
--		do
--			assert ("out", attached test_real.out)
--		end

--feature -- Test routines (Status report)

--	test_is_nan
--			-- Test {STI_REAL}.is_nan.
--		note
--			testing: "covers/{STI_REAL}.is_nan"
--		local
--			x: like test_real
--		do
--			x := {like test_real}.Zero * {like test_real}.Positive_infinity
--			assert ("x_is_nan", x.is_nan)

--			x := test_real
--			assert ("is_nan", x.is_nan implies True)
--		end

--	test_is_negative_infinity
--			-- Test {STI_REAL}.is_negative_infinity.
--		note
--			testing: "covers/{STI_REAL}.is_negative_infinity"
--		local
--			x: like test_real
--		do
--			x := {SINGLE_MATH}.log (0)
--			assert ("x_is_negative_infinity", x.is_negative_infinity)

--			x := test_real
--			assert ("is_negative_infinity", x.is_negative_infinity implies True)
--		end

--	test_is_positive_infinity
--			-- Test {STI_REAL}.is_positive_infinity.
--		note
--			testing: "covers/{STI_REAL}.is_positive_infinity"
--		local
--			x: like test_real
--		do
--			x := 1 / 0
--			assert ("is_positive_infinity", x.is_positive_infinity)

--			x := test_real
--			assert ("is_positive_infinity", x.is_positive_infinity implies True)
--		end

--feature -- Test routines (Conversion)

--	test_as_complex
--			-- Test {STI_REAL}.as_complex.
--		note
--			testing: "covers/{STI_REAL}.as_complex"
--		local
--			l_converted: FUNCTION [like test_real, STI_COMPLEX]
--		do
--			assert ("as_complex", attached test_real.as_complex)

--			l_converted := agent (x: like test_real): STI_COMPLEX
--				do
--					Result := x
--				end
--			assert ("convert_as_complex", attached (l_converted (test_real)))
--		end

--feature {NONE} -- Factory (test element)

--	test_real: STI_REAL
--			-- <Precursor>
--		do
--			Result := some_native_real
--		end

note
	copyright: "Copyright (c) 2012-2019, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"
end
