note
	description: "Test suite for {STT_STRICT_COMPLEX_TESTS [NATURAL, INTEGER, ...]}"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date$"
	revision: "$Revision$"
	testing: "type/manual"

class
	STT_COMPLEX_TESTS_N_STC_I

--inherit
--	STT_STRICT_COMPLEX_TESTS [
--		NATURAL, INTEGER,
--		STS_OBJECT_EQUALITY [NATURAL],
--		STS_OBJECT_EQUALITY [INTEGER]
--		]
--		rename
--				-- {NONE} -- Factory (object)
--			some_object_x as some_native_natural,
--			some_object_b as some_native_integer
--		redefine
--				-- Test routines (Initialization)
--			test_default_create,
--			test_make,
----			test_make_from_real,
--			test_make_from_native_real,
--			test_make_from_native_real_64,
--				-- Test routines (Primitive)
--			test_real,
--			test_imaginary,
--				-- Test routines (Membership)
--			test_element_is_in,
--			test_is_in,
--				-- Test routines (Access)
--			test_zero,
--			test_one,
--				-- Test routines (Status report)
--			test_is_invertible,
--			test_divisible,
--				-- Test routines (Output)
--			test_out,
--				-- Test routines (Comparison)
--			test_is_equal,
--			test_equals,
--				-- Test routines (Basic operations)
--			test_conjugate,
--			test_plus,
--			test_identity,
--			test_minus,
--			test_opposite,
--			test_product,
--			test_quotient,
--			test_reciprocal,
--			test_inverse
--	end

--feature -- Test routines (Initialization)

--	test_default_create
--			-- <Precursor>
--		note
--			testing: "covers/{STI_COMPLEX}.default_create"
--		do
--			Precursor {STT_STRICT_COMPLEX_TESTS}
--		end

--	test_make
--			-- <Precursor>
--		note
--			testing: "covers/{STI_COMPLEX}.make"
--		do
--			Precursor {STT_STRICT_COMPLEX_TESTS}
--		end

----	test_make_from_real
----			-- <Precursor>
----		note
----			testing: "covers/{STI_COMPLEX}.make_from_real"
----		do
----			Precursor {STT_STRICT_COMPLEX_TESTS}
----		end

--	test_make_from_native_real
--			-- <Precursor>
--		note
--			testing: "covers/{STI_COMPLEX}.make_from_native_real"
--		do
--			Precursor {STT_STRICT_COMPLEX_TESTS}
--		end

--	test_make_from_native_real_64
--			-- <Precursor>
--		note
--			testing: "covers/{STI_COMPLEX}.make_from_native_real_64"
--		do
--			Precursor {STT_STRICT_COMPLEX_TESTS}
--		end

--feature -- Test routines (Primitive)

--	test_real
--			-- Test {STI_COMPLEX}.real.
--		note
--			testing: "covers/{STI_COMPLEX}.real"
--		do
--			Precursor {STT_STRICT_COMPLEX_TESTS}
--		end

--	test_imaginary
--			-- Test {STI_COMPLEX}.imaginary.
--		note
--			testing: "covers/{STI_COMPLEX}.imaginary"
--		do
--			Precursor {STT_STRICT_COMPLEX_TESTS}
--		end

--feature -- Test routines (Membership)

--	test_element_is_in
--			-- Test {STI_COMPLEX}.element_is_in.
--		note
--			testing: "covers/{STI_COMPLEX}.element_is_in"
--		do
--			Precursor {STT_STRICT_COMPLEX_TESTS}
--		end

--	test_is_in
--			-- Test {STI_COMPLEX}.is_in.
--		note
--			testing: "covers/{STI_COMPLEX}.is_in"
--		do
--			Precursor {STT_STRICT_COMPLEX_TESTS}
--		end

--feature -- Test routines (Access)

--	test_zero
--			-- Test {STI_COMPLEX}.zero.
--		note
--			testing: "covers/{STI_COMPLEX}.zero"
--		do
--			Precursor {STT_STRICT_COMPLEX_TESTS}
--		end

--	test_one
--			-- Test {STI_COMPLEX}.one.
--		note
--			testing: "covers/{STI_COMPLEX}.one"
--		do
--			Precursor {STT_STRICT_COMPLEX_TESTS}
--		end

--feature -- Test routines (Status report)

--	test_is_invertible
--			-- Test {STI_COMPLEX}.is_invertible.
--		note
--			testing: "covers/{STI_COMPLEX}.is_invertible"
--		do
--			Precursor {STT_STRICT_COMPLEX_TESTS}
--		end

--	test_divisible
--			-- Test {STI_COMPLEX}.divisible.
--		note
--			testing: "covers/{STI_COMPLEX}.divisible"
--		do
--			Precursor {STT_STRICT_COMPLEX_TESTS}
--		end

--feature -- Test routines (Output)

--	test_out
--			-- Test {STI_COMPLEX}.out.
--		note
--			testing: "covers/{STI_COMPLEX}.out"
--		do
--			Precursor {STT_STRICT_COMPLEX_TESTS}
--		end

--feature -- Test routines (Comparison)

--	test_is_equal
--			-- Test {STI_COMPLEX}.is_equal.
--		note
--			testing: "covers/{STI_COMPLEX}.is_equal"
--		do
--			Precursor {STT_STRICT_COMPLEX_TESTS}
--		end

--	test_equals
--			-- Test {STI_COMPLEX}.equals.
--		note
--			testing: "covers/{STI_COMPLEX}.equals"
--		do
--			Precursor {STT_STRICT_COMPLEX_TESTS}
--		end

--feature -- Test routines (Basic operations)

--	test_conjugate
--			-- Test {STI_COMPLEX}.conjugate.
--		note
--			testing: "covers/{STI_COMPLEX}.conjugate"
--		do
--			Precursor {STT_STRICT_COMPLEX_TESTS}
--		end

--	test_plus
--			-- Test {STI_COMPLEX}.plus.
--		note
--			testing: "covers/{STI_COMPLEX}.plus"
--		do
--			Precursor {STT_STRICT_COMPLEX_TESTS}
--		end

--	test_identity
--			-- Test {STI_COMPLEX}.identity.
--		note
--			testing: "covers/{STI_COMPLEX}.identity"
--		do
--			Precursor {STT_STRICT_COMPLEX_TESTS}
--		end

--	test_minus
--			-- Test {STI_COMPLEX}.minus.
--		note
--			testing: "covers/{STI_COMPLEX}.minus"
--		do
--			Precursor {STT_STRICT_COMPLEX_TESTS}
--		end

--	test_opposite
--			-- Test {STI_COMPLEX}.opposite.
--		note
--			testing: "covers/{STI_COMPLEX}.opposite"
--		do
--			Precursor {STT_STRICT_COMPLEX_TESTS}
--		end

--	test_product
--			-- Test {STI_COMPLEX}.product.
--		note
--			testing: "covers/{STI_COMPLEX}.product"
--		do
--			Precursor {STT_STRICT_COMPLEX_TESTS}
--		end

--	test_quotient
--			-- Test {STI_COMPLEX}.quotient.
--		note
--			testing: "covers/{STI_COMPLEX}.quotient"
--		do
--			Precursor {STT_STRICT_COMPLEX_TESTS}
--		end

--	test_reciprocal
--			-- Test {STI_COMPLEX}.reciprocal.
--		note
--			testing: "covers/{STI_COMPLEX}.reciprocal"
--		do
--			Precursor {STT_STRICT_COMPLEX_TESTS}
--		end

--	test_inverse
--			-- Test {STI_COMPLEX}.inverse.
--		note
--			testing: "covers/{STI_COMPLEX}.inverse"
--		do
--			Precursor {STT_STRICT_COMPLEX_TESTS}
--		end

note
	copyright: "Copyright (c) 2012-2019, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"
end
