note
	description: "Test suite for {STT_STRICT_REAL_SET_TESTS [NATURAL, INTEGER, ...]}"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date$"
	revision: "$Revision$"
	testing: "type/manual"

class
	STT_REAL_SET_TESTS_N_STR_I

--inherit
--	STT_STRICT_REAL_SET_TESTS [
--		NATURAL, INTEGER,
--		STS_OBJECT_EQUALITY [NATURAL],
--		STS_OBJECT_EQUALITY [INTEGER]
--		]
--		rename
--				-- {NONE} -- Factory (object)
--			some_object_x as some_native_natural,
--			some_object_b as some_native_integer
--		redefine
--				-- Test routines (Initialization)
--			test_make_empty,
--			test_make_singleton,
--			test_make_extended,
--				-- Test routines (Primitive)
--			test_is_empty,
--			test_any,
--			test_others,
--				-- Test routines (Membership)
--			test_element_is_in,
--			test_is_in,
--			test_has,
--				-- Test routines (Access)
--			test_zero,
--				-- Test routines (Construction)
--			test_with,
--			test_without,
--			test_extended,
--			test_batch_extended,
--				-- Test routines (Output)
--			test_out,
--				-- Test routines (Quality)
--			test_is_singleton,
--				-- Test routines (Measurement)
--			test_cardinality,
--				-- Test routines (Comparison)
--			test_equals,
--			test_is_subset,
--			test_is_superset,
--			test_is_comparable,
--			test_is_not_comparable,
--			test_is_strict_subset,
--			test_is_strict_superset,
--			test_is_trivial_subset,
--			test_is_trivial_superset,
--			test_is_proper_subset,
--			test_is_proper_superset,
--			test_is_disjoint,
--			test_intersects,
--				-- Test routines (Relationship)
--			test_is_partitioned,
--				-- Test routines (Quantifier)
--			test_exists,
--			test_exists_unique,
--			test_exists_pair,
--			test_exists_distinct_pair,
--			test_for_all,
--			test_for_all_pairs,
--			test_for_all_distinct_pairs,
--				-- Test routines (Restriction)
--			test_without_zero,
--			test_non_positive,
--			test_non_negative,
--			test_negative,
--			test_positive,
--				-- Test routines (Interval)
--			test_closed_interval,
--			test_left_closed_right_open_interval,
--			test_left_open_right_closed_interval,
--			test_open_interval,
--			test_left_closed_right_unbounded_interval,
--			test_left_open_right_unbounded_interval,
--			test_left_unbounded_right_closed_interval,
--			test_left_unbounded_right_open_interval,
--			test_unbounded_interval,
--				-- Test routines (Operation)
--			test_subsets,
--			test_powerset,
--			test_trivial_subsets,
--			test_proper_subsets,
--			test_filtered,
--			test_complemented,
--			test_united,
--			test_intersected,
--			test_subtracted,
--			test_subtracted_symmetricaly,
--			test_crossed,
--			test_squared,
--			test_diagonal,
--			test_raised,
--			test_crossed_tuples,
--			test_singleton_crossed_tuples,
--				-- Test routines (Transformation)
--			test_mapped,
--			test_reduced,
--			test_proper_reduced,
--				-- Test routines (Conversion)
--			test_as_singleton,
--			test_n_times,
--			test_as_tuple,
--				-- Test routines (Factory)
--			test_o, test_empty_set,
--			test_singleton,
--			test_pair,
--			test_converted,
--			test_unit,
--				-- Test routines (Predicate)
--			test_negated,
--			test_anded,
--			test_ored,
--			test_xored,
--			test_implied,
--			test_iff,
--			test_predicate_holds_for_pair,
--			test_pair_negated,
--			test_pair_anded,
--			test_pair_implied,
--			test_equality_holds,
--			test_number_is_less,
--			test_number_is_less_equal,
--				-- Test routines (Mapping)
--			test_second_after_first,
--				-- Test routines (Reduction)
--			test_natural_successor,
--			test_disjunction,
--			test_conjunction,
--			test_sets_plus_same_sets_with_element
--		end

--feature -- Test routines (Initialization)

--	test_make_empty
--			-- Test {STI_REAL_SET}.make_empty.
--		note
--			testing: "covers/{STI_REAL_SET}.make_empty"
--		do
--			Precursor {STT_STRICT_REAL_SET_TESTS}
--		end

--	test_make_singleton
--			-- Test {STI_REAL_SET}.make_singleton.
--		note
--			testing: "covers/{STI_REAL_SET}.make_singleton"
--		do
--			Precursor {STT_STRICT_REAL_SET_TESTS}
--		end

--	test_make_extended
--			-- Test {STI_REAL_SET}.make_extended.
--		note
--			testing: "covers/{STI_REAL_SET}.make_extended"
--		do
--			Precursor {STT_STRICT_REAL_SET_TESTS}
--		end

--feature -- Test routines (Primitive)

--	test_is_empty
--			-- Test {STI_REAL_SET}.is_empty.
--		note
--			testing: "covers/{STI_REAL_SET}.is_empty"
--		do
--			Precursor {STT_STRICT_REAL_SET_TESTS}
--		end

--	test_any
--			-- Test {STI_REAL_SET}.any.
--		note
--			testing: "covers/{STI_REAL_SET}.any"
--		do
--			Precursor {STT_STRICT_REAL_SET_TESTS}
--		end

--	test_others
--			-- Test {STI_REAL_SET}.others.
--		note
--			testing: "covers/{STI_REAL_SET}.others"
--		do
--			Precursor {STT_STRICT_REAL_SET_TESTS}
--		end

--feature -- Test routines (Membership)

--	test_element_is_in
--			-- Test {STI_REAL_SET}.element_is_in.
--		note
--			testing: "covers/{STI_REAL_SET}.element_is_in"
--		do
--			Precursor {STT_STRICT_REAL_SET_TESTS}
--		end

--	test_is_in
--			-- Test {STI_REAL_SET}.is_in.
--		note
--			testing: "covers/{STI_REAL_SET}.is_in"
--		do
--			Precursor {STT_STRICT_REAL_SET_TESTS}
--		end

--	test_has
--			-- Test {STI_REAL_SET}.has.
--		note
--			testing: "covers/{STI_REAL_SET}.has"
--		do
--			Precursor {STT_STRICT_REAL_SET_TESTS}
--		end

--feature -- Test routines (Access)

--	test_zero
--			-- Test {STI_REAL_SET}.zero.
--		note
--			testing: "covers/{STI_REAL_SET}.zero"
--		do
--			Precursor {STT_STRICT_REAL_SET_TESTS}
--		end

--feature -- Test routines (Construction)

--	test_with
--			-- Test {STI_REAL_SET}.with.
--		note
--			testing: "covers/{STI_REAL_SET}.with"
--		do
--			Precursor {STT_STRICT_REAL_SET_TESTS}
--		end

--	test_without
--			-- Test {STI_REAL_SET}.without.
--		note
--			testing: "covers/{STI_REAL_SET}.without"
--		do
--			Precursor {STT_STRICT_REAL_SET_TESTS}
--		end

--	test_extended
--			-- Test {STI_REAL_SET}.extended.
--		note
--			testing: "covers/{STI_REAL_SET}.extended"
--		do
--			Precursor {STT_STRICT_REAL_SET_TESTS}
--		end

--	test_batch_extended
--			-- Test {STI_REAL_SET}.batch_extended.
--		note
--			testing: "covers/{STI_REAL_SET}.batch_extended"
--		do
--			Precursor {STT_STRICT_REAL_SET_TESTS}
--		end

--feature -- Test routines (Output)

--	test_out
--			-- Test {STI_REAL_SET}.out.
--		note
--			testing: "covers/{STI_REAL_SET}.out"
--		do
--			Precursor {STT_STRICT_REAL_SET_TESTS}
--		end

--feature -- Test routines (Quality)

--	test_is_singleton
--			-- Test {STI_REAL_SET}.is_singleton.
--		note
--			testing: "covers/{STI_REAL_SET}.is_singleton"
--		do
--			Precursor {STT_STRICT_REAL_SET_TESTS}
--		end

--feature -- Test routines (Measurement)

--	test_cardinality
--			-- Test {STI_REAL_SET}.cardinality.
--		note
--			testing: "covers/{STI_REAL_SET}.cardinality"
--		do
--			Precursor {STT_STRICT_REAL_SET_TESTS}
--		end

--feature -- Test routines (Comparison)

--	test_equals
--			-- Test {STI_REAL_SET}.equals.
--		note
--			testing: "covers/{STI_REAL_SET}.equals"
--		do
--			Precursor {STT_STRICT_REAL_SET_TESTS}
--		end

--	test_is_subset
--			-- Test {STI_REAL_SET}.is_subset.
--		note
--			testing: "covers/{STI_REAL_SET}.is_subset"
--		do
--			Precursor {STT_STRICT_REAL_SET_TESTS}
--		end

--	test_is_superset
--			-- Test {STI_REAL_SET}.is_superset.
--		note
--			testing: "covers/{STI_REAL_SET}.is_superset"
--		do
--			Precursor {STT_STRICT_REAL_SET_TESTS}
--		end

--	test_is_comparable
--			-- Test {STI_REAL_SET}.is_comparable.
--		note
--			testing: "covers/{STI_REAL_SET}.is_comparable"
--		do
--			Precursor {STT_STRICT_REAL_SET_TESTS}
--		end

--	test_is_not_comparable
--			-- Test {STI_REAL_SET}.is_not_comparable.
--		note
--			testing: "covers/{STI_REAL_SET}.is_not_comparable"
--		do
--			Precursor {STT_STRICT_REAL_SET_TESTS}
--		end

--	test_is_strict_subset
--			-- Test {STI_REAL_SET}.is_strict_subset.
--		note
--			testing: "covers/{STI_REAL_SET}.is_strict_subset"
--		do
--			Precursor {STT_STRICT_REAL_SET_TESTS}
--		end

--	test_is_strict_superset
--			-- Test {STI_REAL_SET}.is_strict_superset.
--		note
--			testing: "covers/{STI_REAL_SET}.is_strict_superset"
--		do
--			Precursor {STT_STRICT_REAL_SET_TESTS}
--		end

--	test_is_trivial_subset
--			-- Test {STI_REAL_SET}.is_trivial_subset.
--		note
--			testing: "covers/{STI_REAL_SET}.is_trivial_subset"
--		do
--			Precursor {STT_STRICT_REAL_SET_TESTS}
--		end

--	test_is_trivial_superset
--			-- Test {STI_REAL_SET}.is_trivial_superset.
--		note
--			testing: "covers/{STI_REAL_SET}.is_trivial_superset"
--		do
--			Precursor {STT_STRICT_REAL_SET_TESTS}
--		end

--	test_is_proper_subset
--			-- Test {STI_REAL_SET}.is_proper_subset.
--		note
--			testing: "covers/{STI_REAL_SET}.is_proper_subset"
--		do
--			Precursor {STT_STRICT_REAL_SET_TESTS}
--		end

--	test_is_proper_superset
--			-- Test {STI_REAL_SET}.is_proper_superset.
--		note
--			testing: "covers/{STI_REAL_SET}.is_proper_superset"
--		do
--			Precursor {STT_STRICT_REAL_SET_TESTS}
--		end

--	test_is_disjoint
--			-- Test {STI_REAL_SET}.is_disjoint.
--		note
--			testing: "covers/{STI_REAL_SET}.is_disjoint"
--		do
--			Precursor {STT_STRICT_REAL_SET_TESTS}
--		end

--	test_intersects
--			-- Test {STI_REAL_SET}.intersects.
--		note
--			testing: "covers/{STI_REAL_SET}.intersects"
--		do
--			Precursor {STT_STRICT_REAL_SET_TESTS}
--		end

--feature -- Test routines (Relationship)

--	test_is_partitioned
--			-- Test {STI_REAL_SET}.is_partitioned.
--		note
--			testing: "covers/{STI_REAL_SET}.is_partitioned"
--		do
--			Precursor {STT_STRICT_REAL_SET_TESTS}
--		end

--feature -- Test routines (Quantifier)

--	test_exists
--			-- Test {STI_REAL_SET}.exists.
--		note
--			testing: "covers/{STI_REAL_SET}.exists"
--		do
--			Precursor {STT_STRICT_REAL_SET_TESTS}
--		end

--	test_exists_unique
--			-- Test {STI_REAL_SET}.exists_unique.
--		note
--			testing: "covers/{STI_REAL_SET}.exists_unique"
--		do
--			Precursor {STT_STRICT_REAL_SET_TESTS}
--		end

--	test_exists_pair
--			-- Test {STI_REAL_SET}.exists_pair.
--		note
--			testing: "covers/{STI_REAL_SET}.exists_pair"
--		do
--			Precursor {STT_STRICT_REAL_SET_TESTS}
--		end

--	test_exists_distinct_pair
--			-- Test {STI_REAL_SET}.exists_distinct_pair.
--		note
--			testing: "covers/{STI_REAL_SET}.exists_distinct_pair"
--		do
--			Precursor {STT_STRICT_REAL_SET_TESTS}
--		end

--	test_for_all
--			-- Test {STI_REAL_SET}.for_all.
--		note
--			testing: "covers/{STI_REAL_SET}.for_all"
--		do
--			Precursor {STT_STRICT_REAL_SET_TESTS}
--		end

--	test_for_all_pairs
--			-- Test {STI_REAL_SET}.for_all_pairs.
--		note
--			testing: "covers/{STI_REAL_SET}.for_all_pairs"
--		do
--			Precursor {STT_STRICT_REAL_SET_TESTS}
--		end

--	test_for_all_distinct_pairs
--			-- Test {STI_REAL_SET}.for_all_distinct_pairs.
--		note
--			testing: "covers/{STI_REAL_SET}.for_all_distinct_pairs"
--		do
--			Precursor {STT_STRICT_REAL_SET_TESTS}
--		end

--feature -- Test routines (Restriction)

--	test_without_zero
--			-- Test {STI_REAL_SET}.without_zero.
--		note
--			testing: "covers/{STI_REAL_SET}.without_zero"
--		do
--			Precursor {STT_STRICT_REAL_SET_TESTS}
--		end

--	test_non_positive
--			-- Test {STI_REAL_SET}.non_positive.
--		note
--			testing: "covers/{STI_REAL_SET}.non_positive"
--		do
--			Precursor {STT_STRICT_REAL_SET_TESTS}
--		end

--	test_non_negative
--			-- Test {STI_REAL_SET}.non_negative.
--		note
--			testing: "covers/{STI_REAL_SET}.non_negative"
--		do
--			Precursor {STT_STRICT_REAL_SET_TESTS}
--		end

--	test_negative
--			-- Test {STI_REAL_SET}.negative.
--		note
--			testing: "covers/{STI_REAL_SET}.negative"
--		do
--			Precursor {STT_STRICT_REAL_SET_TESTS}
--		end

--	test_positive
--			-- Test {STI_REAL_SET}.positive.
--		note
--			testing: "covers/{STI_REAL_SET}.positive"
--		do
--			Precursor {STT_STRICT_REAL_SET_TESTS}
--		end

--feature -- Test routines (Interval)

--	test_closed_interval
--			-- Test {STI_REAL_SET}.closed_interval.
--		note
--			testing: "covers/{STI_REAL_SET}.closed_interval"
--		do
--			Precursor {STT_STRICT_REAL_SET_TESTS}
--		end

--	test_left_closed_right_open_interval
--			-- Test {STI_REAL_SET}.left_closed_right_open_interval.
--		note
--			testing: "covers/{STI_REAL_SET}.left_closed_right_open_interval"
--		do
--			Precursor {STT_STRICT_REAL_SET_TESTS}
--		end

--	test_left_open_right_closed_interval
--			-- Test {STI_REAL_SET}.left_open_right_closed_interval.
--		note
--			testing: "covers/{STI_REAL_SET}.left_open_right_closed_interval"
--		do
--			Precursor {STT_STRICT_REAL_SET_TESTS}
--		end

--	test_open_interval
--			-- Test {STI_REAL_SET}.open_interval.
--		note
--			testing: "covers/{STI_REAL_SET}.open_interval"
--		do
--			Precursor {STT_STRICT_REAL_SET_TESTS}
--		end

--	test_left_closed_right_unbounded_interval
--			-- Test {STI_REAL_SET}.left_closed_right_unbounded_interval.
--		note
--			testing: "covers/{STI_REAL_SET}.left_closed_right_unbounded_interval"
--		do
--			Precursor {STT_STRICT_REAL_SET_TESTS}
--		end

--	test_left_open_right_unbounded_interval
--			-- Test {STI_REAL_SET}.left_open_right_unbounded_interval.
--		note
--			testing: "covers/{STI_REAL_SET}.left_open_right_unbounded_interval"
--		do
--			Precursor {STT_STRICT_REAL_SET_TESTS}
--		end

--	test_left_unbounded_right_closed_interval
--			-- Test {STI_REAL_SET}.left_unbounded_right_closed_interval.
--		note
--			testing: "covers/{STI_REAL_SET}.left_unbounded_right_closed_interval"
--		do
--			Precursor {STT_STRICT_REAL_SET_TESTS}
--		end

--	test_left_unbounded_right_open_interval
--			-- Test {STI_REAL_SET}.left_unbounded_right_open_interval.
--		note
--			testing: "covers/{STI_REAL_SET}.left_unbounded_right_open_interval"
--		do
--			Precursor {STT_STRICT_REAL_SET_TESTS}
--		end

--	test_unbounded_interval
--			-- Test {STI_REAL_SET}.unbounded_interval.
--		note
--			testing: "covers/{STI_REAL_SET}.unbounded_interval"
--		do
--			Precursor {STT_STRICT_REAL_SET_TESTS}
--		end

--feature -- Test routines (Operation)

--	test_subsets
--			-- Test {STI_REAL_SET}.subsets.
--		note
--			testing: "covers/{STI_REAL_SET}.subsets"
--		do
--			Precursor {STT_STRICT_REAL_SET_TESTS}
--		end

--	test_powerset
--			-- Test {STI_REAL_SET}.powerset.
--		note
--			testing: "covers/{STI_REAL_SET}.powerset"
--		do
--			Precursor {STT_STRICT_REAL_SET_TESTS}
--		end

--	test_trivial_subsets
--			-- Test {STI_REAL_SET}.trivial_subsets.
--		note
--			testing: "covers/{STI_REAL_SET}.trivial_subsets"
--		do
--			Precursor {STT_STRICT_REAL_SET_TESTS}
--		end

--	test_proper_subsets
--			-- Test {STI_REAL_SET}.proper_subsets.
--		note
--			testing: "covers/{STI_REAL_SET}.proper_subsets"
--		do
--			Precursor {STT_STRICT_REAL_SET_TESTS}
--		end

--	test_filtered
--			-- Test {STI_REAL_SET}.filtered.
--		note
--			testing: "covers/{STI_REAL_SET}.filtered"
--		do
--			Precursor {STT_STRICT_REAL_SET_TESTS}
--		end

--	test_complemented
--			-- Test {STI_REAL_SET}.complemented.
--		note
--			testing: "covers/{STI_REAL_SET}.complemented"
--		do
--			Precursor {STT_STRICT_REAL_SET_TESTS}
--		end

--	test_united
--			-- Test {STI_REAL_SET}.united.
--		note
--			testing: "covers/{STI_REAL_SET}.united"
--		do
--			Precursor {STT_STRICT_REAL_SET_TESTS}
--		end

--	test_intersected
--			-- Test {STI_REAL_SET}.intersected.
--		note
--			testing: "covers/{STI_REAL_SET}.intersected"
--		do
--			Precursor {STT_STRICT_REAL_SET_TESTS}
--		end

--	test_subtracted
--			-- Test {STI_REAL_SET}.subtracted.
--		note
--			testing: "covers/{STI_REAL_SET}.subtracted"
--		do
--			Precursor {STT_STRICT_REAL_SET_TESTS}
--		end

--	test_subtracted_symmetricaly
--			-- Test {STI_REAL_SET}.subtracted_symmetricaly.
--		note
--			testing: "covers/{STI_REAL_SET}.subtracted_symmetricaly"
--		do
--			Precursor {STT_STRICT_REAL_SET_TESTS}
--		end

--	test_crossed
--			-- Test {STI_REAL_SET}.crossed.
--		note
--			testing: "covers/{STI_REAL_SET}.crossed"
--		do
--			Precursor {STT_STRICT_REAL_SET_TESTS}
--		end

--	test_squared
--			-- Test {STI_REAL_SET}.squared.
--		note
--			testing: "covers/{STI_REAL_SET}.squared"
--		do
--			Precursor {STT_STRICT_REAL_SET_TESTS}
--		end

--	test_diagonal
--			-- Test {STI_REAL_SET}.diagonal.
--		note
--			testing: "covers/{STI_REAL_SET}.diagonal"
--		do
--			Precursor {STT_STRICT_REAL_SET_TESTS}
--		end

--	test_raised
--			-- Test {STI_REAL_SET}.raised.
--		note
--			testing: "covers/{STI_REAL_SET}.raised"
--		do
--			Precursor {STT_STRICT_REAL_SET_TESTS}
--		end

--	test_crossed_tuples
--			-- Test {STI_REAL_SET}.crossed_tuples.
--		note
--			testing: "covers/{STI_REAL_SET}.crossed_tuples"
--		do
--			Precursor {STT_STRICT_REAL_SET_TESTS}
--		end

--	test_singleton_crossed_tuples
--			-- Test {STI_REAL_SET}.singleton_crossed_tuples.
--		note
--			testing: "covers/{STI_REAL_SET}.singleton_crossed_tuples"
--		do
--			Precursor {STT_STRICT_REAL_SET_TESTS}
--		end

--feature -- Test routines (Transformation)

--	test_mapped
--			-- Test {STI_REAL_SET}.mapped.
--		note
--			testing: "covers/{STI_REAL_SET}.mapped"
--		do
--			Precursor {STT_STRICT_REAL_SET_TESTS}
--		end

--	test_reduced
--			-- Test {STI_REAL_SET}.reduced.
--		note
--			testing: "covers/{STI_REAL_SET}.reduced"
--		do
--			Precursor {STT_STRICT_REAL_SET_TESTS}
--		end

--	test_proper_reduced
--			-- Test {STI_REAL_SET}.proper_reduced.
--		note
--			testing: "covers/{STI_REAL_SET}.proper_reduced"
--		do
--			Precursor {STT_STRICT_REAL_SET_TESTS}
--		end

--feature -- Test routines (Conversion)

--	test_as_singleton
--			-- Test {STI_REAL_SET}.as_singleton.
--		note
--			testing: "covers/{STI_REAL_SET}.as_singleton"
--		do
--			Precursor {STT_STRICT_REAL_SET_TESTS}
--		end

--	test_n_times
--			-- Test {STI_REAL_SET}.n_times.
--		note
--			testing: "covers/{STI_REAL_SET}.n_times"
--		do
--			Precursor {STT_STRICT_REAL_SET_TESTS}
--		end

--	test_as_tuple
--			-- Test {STI_REAL_SET}.as_tuple.
--		note
--			testing: "covers/{STI_REAL_SET}.as_tuple"
--		do
--			Precursor {STT_STRICT_REAL_SET_TESTS}
--		end

--feature -- Test routines (Factory)

--	test_o
--			-- Test {STI_REAL_SET}.o.
--		note
--			testing: "covers/{STI_REAL_SET}.o"
--		do
--			Precursor {STT_STRICT_REAL_SET_TESTS}
--		end

--	test_empty_set
--			-- Test {STI_REAL_SET}.empty_set.
--		note
--			testing: "covers/{STI_REAL_SET}.empty_set"
--		do
--			Precursor {STT_STRICT_REAL_SET_TESTS}
--		end

--	test_singleton
--			-- Test {STI_REAL_SET}.singleton.
--		note
--			testing: "covers/{STI_REAL_SET}.singleton"
--		do
--			Precursor {STT_STRICT_REAL_SET_TESTS}
--		end

--	test_pair
--			-- Test {STI_REAL_SET}.pair.
--		note
--			testing: "covers/{STI_REAL_SET}.pair"
--		do
--			Precursor {STT_STRICT_REAL_SET_TESTS}
--		end

--	test_converted
--			-- Test {STI_REAL_SET}.converted.
--		note
--			testing: "covers/{STI_REAL_SET}.converted"
--		do
--			Precursor {STT_STRICT_REAL_SET_TESTS}
--		end

--	test_unit
--			-- Test {STI_REAL_SET}.unit.
--		note
--			testing: "covers/{STI_REAL_SET}.unit"
--		do
--			Precursor {STT_STRICT_REAL_SET_TESTS}
--		end

--feature -- Test routines (Predicate)

--	test_negated
--			-- Test {STI_REAL_SET}.negated.
--		note
--			testing: "covers/{STI_REAL_SET}.negated"
--		do
--			Precursor {STT_STRICT_REAL_SET_TESTS}
--		end

--	test_anded
--			-- Test {STI_REAL_SET}.anded.
--		note
--			testing: "covers/{STI_REAL_SET}.anded"
--		do
--			Precursor {STT_STRICT_REAL_SET_TESTS}
--		end

--	test_ored
--			-- Test {STI_REAL_SET}.ored.
--		note
--			testing: "covers/{STI_REAL_SET}.ored"
--		do
--			Precursor {STT_STRICT_REAL_SET_TESTS}
--		end

--	test_xored
--			-- Test {STI_REAL_SET}.xored.
--		note
--			testing: "covers/{STI_REAL_SET}.xored"
--		do
--			Precursor {STT_STRICT_REAL_SET_TESTS}
--		end

--	test_implied
--			-- Test {STI_REAL_SET}.implied.
--		note
--			testing: "covers/{STI_REAL_SET}.implied"
--		do
--			Precursor {STT_STRICT_REAL_SET_TESTS}
--		end

--	test_iff
--			-- Test {STI_REAL_SET}.iff.
--		note
--			testing: "covers/{STI_REAL_SET}.iff"
--		do
--			Precursor {STT_STRICT_REAL_SET_TESTS}
--		end

--	test_predicate_holds_for_pair
--			-- Test {STI_REAL_SET}.predicate_holds_for_pair.
--		note
--			testing: "covers/{STI_REAL_SET}.predicate_holds_for_pair"
--		do
--			Precursor {STT_STRICT_REAL_SET_TESTS}
--		end

--	test_pair_negated
--			-- Test {STI_REAL_SET}.pair_negated.
--		note
--			testing: "covers/{STI_REAL_SET}.pair_negated"
--		do
--			Precursor {STT_STRICT_REAL_SET_TESTS}
--		end

--	test_pair_anded
--			-- Test {STI_REAL_SET}.pair_anded.
--		note
--			testing: "covers/{STI_REAL_SET}.pair_anded"
--		do
--			Precursor {STT_STRICT_REAL_SET_TESTS}
--		end

--	test_pair_implied
--			-- Test {STI_REAL_SET}.pair_implied.
--		note
--			testing: "covers/{STI_REAL_SET}.pair_implied"
--		do
--			Precursor {STT_STRICT_REAL_SET_TESTS}
--		end

--	test_equality_holds
--			-- Test {STI_REAL_SET}.equality_holds.
--		note
--			testing: "covers/{STI_REAL_SET}.equality_holds"
--		do
--			Precursor {STT_STRICT_REAL_SET_TESTS}
--		end

--	test_number_is_less
--			-- Test {STI_REAL_SET}.number_is_less.
--		note
--			testing: "covers/{STI_REAL_SET}.number_is_less"
--		do
--			Precursor {STT_STRICT_REAL_SET_TESTS}
--		end

--	test_number_is_less_equal
--			-- Test {STI_REAL_SET}.number_is_less_equal.
--		note
--			testing: "covers/{STI_REAL_SET}.number_is_less_equal"
--		do
--			Precursor {STT_STRICT_REAL_SET_TESTS}
--		end

--feature -- Test routines (Mapping)

--	test_second_after_first
--			-- Test {STI_REAL_SET}.second_after_first.
--		note
--			testing: "covers/{STI_REAL_SET}.second_after_first"
--		do
--			Precursor {STT_STRICT_REAL_SET_TESTS}
--		end

--feature -- Test routines (Reduction)

--	test_natural_successor
--			-- Test {STI_REAL_SET}.natural_successor.
--		note
--			testing: "covers/{STI_REAL_SET}.natural_successor"
--		do
--			Precursor {STT_STRICT_REAL_SET_TESTS}
--		end

--	test_disjunction
--			-- Test {STI_REAL_SET}.disjunction.
--		note
--			testing: "covers/{STI_REAL_SET}.disjunction"
--		do
--			Precursor {STT_STRICT_REAL_SET_TESTS}
--		end

--	test_conjunction
--			-- Test {STI_REAL_SET}.conjunction.
--		note
--			testing: "covers/{STI_REAL_SET}.conjunction"
--		do
--			Precursor {STT_STRICT_REAL_SET_TESTS}
--		end

--	test_sets_plus_same_sets_with_element
--			-- Test {STI_REAL_SET}.sets_plus_same_sets_with_element.
--		note
--			testing: "covers/{STI_REAL_SET}.sets_plus_same_sets_with_element"
--		do
--			Precursor {STT_STRICT_REAL_SET_TESTS}
--		end

--feature {NONE} -- Predicate

--	p_x (x: STI_REAL): BOOLEAN
--			-- <Precursor>
--		do
--			Result := x.value.truncated_to_integer \\ 2 = 0
--		end

--	p_x1_x2 (x1, x2: STI_REAL): BOOLEAN
--			-- <Precursor>
--		do
--			Result := x1.value.truncated_to_integer \\ 2 /= (x1.value.truncated_to_integer + x2.value.truncated_to_integer) \\ 2
--		end

--feature {NONE} -- Mapping

--	f_x (x: STI_REAL): STI_REAL
--			-- <Precursor>
--		do
--			Result := x + (create {STI_REAL }.make_from_native_integer (2))
--		end

--feature {NONE} -- Reduction

--	f_acc_x (acc, x: STI_REAL): STI_REAL
--			-- <Precursor>
--		do
--			Result := acc - x
--		end

--	f_acc_i_x (acc: STI_REAL; i: NATURAL; x: STI_REAL): STI_REAL
--			-- <Precursor>
--		do
--			Result := (acc - x) * (create {STI_REAL}.make_from_native_natural (i))
--		end

note
	copyright: "Copyright (c) 2012-2019, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"
end
