note
	description: "Test suite for {STT_STRICT_REAL_TESTS [NATURAL, INTEGER, ...]}"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date$"
	revision: "$Revision$"
	testing: "type/manual"

class
	STT_REAL_TESTS_N_STR_I

--inherit
--	STT_STRICT_REAL_TESTS [
--		NATURAL, INTEGER,
--		STS_OBJECT_EQUALITY [NATURAL],
--		STS_OBJECT_EQUALITY [INTEGER]
--		]
--		rename
--				-- {NONE} -- Factory (object)
--			some_object_x as some_native_natural,
--			some_object_b as some_native_integer
--		redefine
--				-- Test routines (Initialization)
--			test_default_create,
--			test_make,
--			test_make_from_native_real_64,
--			test_make_from_native_integer,
--			test_make_from_native_natural,
--			test_make_abs,
--			test_make_opposite,
--				-- Test routines (Primitive)
--			test_value,
--				-- Test routines (Membership)
--			test_element_is_in,
--			test_is_in,
--				-- Test routines (Access)
--			test_sign,
--			test_zero,
--			test_one,
--			test_nan,
--			test_negative_infinity,
--			test_positive_infinity,
--				-- Test routines (Status report)
--			test_is_invertible,
--			test_complex_divisible,
--			test_divisible,
--			test_exponentiable,
--			test_is_nan,
--			test_is_negative_infinity,
--			test_is_positive_infinity,
--				-- Test routines (Output)
--			test_out,
--				-- Test routines (Comparison)
--			test_is_equal,
--			test_complex_equals,
--			test_equals,
--			test_same_value,
--			test_is_less,
--			test_is_less_equal,
--			test_is_greater,
--			test_is_greater_equal,
--			test_min,
--			test_max,
--			test_three_way_comparison,
--				-- Test routines (Basic operations)
--			test_conjugate,
--			test_abs,
--			test_complex_plus,
--			test_plus,
--			test_identity,
--			test_complex_minus,
--			test_minus,
--			test_opposite,
--			test_complex_product,
--			test_product,
--			test_complex_quotient,
--			test_quotient,
--			test_reciprocal,
--			test_inverse,
--			test_power,
--				-- Test routines (Conversion)
--			test_as_complex,
--				-- Test routines (Factory)
--			test_normalized_value
--	end

--feature -- Test routines (Initialization)

--	test_default_create
--			-- <Precursor>
--		note
--			testing: "covers/{STI_REAL}.default_create"
--		do
--			Precursor {STT_STRICT_REAL_TESTS}
--		end

--	test_make
--			-- <Precursor>
--		note
--			testing: "covers/{STI_REAL}.make"
--		do
--			Precursor {STT_STRICT_REAL_TESTS}
--		end

--	test_make_from_native_real_64
--			-- <Precursor>
--		note
--			testing: "covers/{STI_REAL}.make_from_native_real_64"
--		do
--			Precursor {STT_STRICT_REAL_TESTS}
--		end

--	test_make_from_native_integer
--			-- <Precursor>
--		note
--			testing: "covers/{STI_REAL}.make_from_native_integer"
--		do
--			Precursor {STT_STRICT_REAL_TESTS}
--		end

--	test_make_from_native_natural
--			-- <Precursor>
--		note
--			testing: "covers/{STI_REAL}.make_from_native_natural"
--		do
--			Precursor {STT_STRICT_REAL_TESTS}
--		end

--	test_make_abs
--			-- <Precursor>
--		note
--			testing: "covers/{STI_REAL}.make_abs"
--		do
--			Precursor {STT_STRICT_REAL_TESTS}
--		end

--	test_make_opposite
--			-- <Precursor>
--		note
--			testing: "covers/{STI_REAL}.make_opposite"
--		do
--			Precursor {STT_STRICT_REAL_TESTS}
--		end

--feature -- Test routines (Primitive)

--	test_value
--			-- <Precursor>
--		note
--			testing: "covers/{STI_REAL}.value"
--		do
--			Precursor {STT_STRICT_REAL_TESTS}
--		end

--feature -- Test routines (Membership)

--	test_element_is_in
--			-- Test {STI_REAL}.element_is_in.
--		note
--			testing: "covers/{STI_REAL}.element_is_in"
--		do
--			Precursor {STT_STRICT_REAL_TESTS}
--		end

--	test_is_in
--			-- Test {STI_REAL}.is_in.
--		note
--			testing: "covers/{STI_REAL}.is_in"
--		do
--			Precursor {STT_STRICT_REAL_TESTS}
--		end

--feature -- Test routines (Access)

--	test_sign
--			-- Test {STI_REAL}.sign.
--		note
--			testing: "covers/{STI_REAL}.sign"
--		do
--			Precursor {STT_STRICT_REAL_TESTS}
--		end

--	test_zero
--			-- Test {STI_REAL}.zero.
--		note
--			testing: "covers/{STI_REAL}.zero"
--		do
--			Precursor {STT_STRICT_REAL_TESTS}
--		end

--	test_one
--			-- Test {STI_REAL}.one.
--		note
--			testing: "covers/{STI_REAL}.one"
--		do
--			Precursor {STT_STRICT_REAL_TESTS}
--		end

--	test_nan
--			-- <Precursor>
--		note
--			testing: "covers/{STI_REAL}.nan"
--		do
--			Precursor {STT_STRICT_REAL_TESTS}
--		end

--	test_negative_infinity
--			-- <Precursor>
--		note
--			testing: "covers/{STI_REAL}.negative_infinity"
--		do
--			Precursor {STT_STRICT_REAL_TESTS}
--		end

--	test_positive_infinity
--			-- <Precursor>
--		note
--			testing: "covers/{STI_REAL}.positive_infinity"
--		do
--			Precursor {STT_STRICT_REAL_TESTS}
--		end

--feature -- Test routines (Status report)

--	test_is_invertible
--			-- Test {STI_REAL}.is_invertible.
--		note
--			testing: "covers/{STI_REAL}.is_invertible"
--		do
--			Precursor {STT_STRICT_REAL_TESTS}
--		end

--	test_complex_divisible
--			-- Test {STI_REAL}.complex_divisible.
--		note
--			testing: "covers/{STI_REAL}.complex_divisible"
--		do
--			Precursor {STT_STRICT_REAL_TESTS}
--		end

--	test_divisible
--			-- Test {STI_REAL}.divisible.
--		note
--			testing: "covers/{STI_REAL}.divisible"
--		do
--			Precursor {STT_STRICT_REAL_TESTS}
--		end

--	test_exponentiable
--			-- Test {STI_REAL}.exponentiable.
--		note
--			testing: "covers/{STI_REAL}.exponentiable"
--		do
--			Precursor {STT_STRICT_REAL_TESTS}
--		end

--	test_is_nan
--			-- <Precursor>
--		note
--			testing: "covers/{STI_REAL}.is_nan"
--		do
--			Precursor {STT_STRICT_REAL_TESTS}
--		end

--	test_is_negative_infinity
--			-- <Precursor>
--		note
--			testing: "covers/{STI_REAL}.is_negative_infinity"
--		do
--			Precursor {STT_STRICT_REAL_TESTS}
--		end

--	test_is_positive_infinity
--			-- <Precursor>
--		note
--			testing: "covers/{STI_REAL}.is_positive_infinity"
--		do
--			Precursor {STT_STRICT_REAL_TESTS}
--		end

--feature -- Test routines (Output)

--	test_out
--			-- Test {STI_REAL}.out.
--		note
--			testing: "covers/{STI_REAL}.out"
--		do
--			Precursor {STT_STRICT_REAL_TESTS}
--		end

--feature -- Test routines (Comparison)

--	test_is_equal
--			-- Test {STI_REAL}.is_equal.
--		note
--			testing: "covers/{STI_REAL}.is_equal"
--		do
--			Precursor {STT_STRICT_REAL_TESTS}
--		end

--	test_complex_equals
--			-- Test {STI_REAL}.complex_equals.
--		note
--			testing: "covers/{STI_REAL}.complex_equals"
--		do
--			Precursor {STT_STRICT_REAL_TESTS}
--		end

--	test_equals
--			-- Test {STI_REAL}.equals.
--		note
--			testing: "covers/{STI_REAL}.equals"
--		do
--			Precursor {STT_STRICT_REAL_TESTS}
--		end

--	test_same_value
--			-- Test {STI_REAL}.same_value.
--		note
--			testing: "covers/{STI_REAL}.same_value"
--		do
--			Precursor {STT_STRICT_REAL_TESTS}
--		end

--	test_is_less
--			-- Test {STI_REAL}.is_less.
--		note
--			testing: "covers/{STI_REAL}.is_less"
--		do
--			Precursor {STT_STRICT_REAL_TESTS}
--		end

--	test_is_less_equal
--			-- Test {STI_REAL}.is_less_equal.
--		note
--			testing: "covers/{STI_REAL}.is_less_equal"
--		do
--			Precursor {STT_STRICT_REAL_TESTS}
--		end

--	test_is_greater
--			-- Test {STI_REAL}.is_greater.
--		note
--			testing: "covers/{STI_REAL}.is_greater"
--		do
--			Precursor {STT_STRICT_REAL_TESTS}
--		end

--	test_is_greater_equal
--			-- Test {STI_REAL}.is_greater_equal.
--		note
--			testing: "covers/{STI_REAL}.is_greater_equal"
--		do
--			Precursor {STT_STRICT_REAL_TESTS}
--		end

--	test_min
--			-- Test {STI_REAL}.min.
--		note
--			testing: "covers/{STI_REAL}.min"
--		do
--			Precursor {STT_STRICT_REAL_TESTS}
--		end

--	test_max
--			-- Test {STI_REAL}.max.
--		note
--			testing: "covers/{STI_REAL}.max"
--		do
--			Precursor {STT_STRICT_REAL_TESTS}
--		end

--	test_three_way_comparison
--			-- Test {STI_REAL}.three_way_comparison.
--		note
--			testing: "covers/{STI_REAL}.three_way_comparison"
--		do
--			Precursor {STT_STRICT_REAL_TESTS}
--		end

--feature -- Test routines (Basic operations)

--	test_conjugate
--			-- Test {STI_REAL}.identity.
--		note
--			testing: "covers/{STI_REAL}.identity"
--		do
--			Precursor {STT_STRICT_REAL_TESTS}
--		end

--	test_abs
--			-- Test {STI_REAL}.abs.
--		note
--			testing: "covers/{STI_REAL}.abs"
--		do
--			Precursor {STT_STRICT_REAL_TESTS}
--		end

--	test_complex_plus
--			-- Test {STI_REAL}.complex_plus.
--		note
--			testing: "covers/{STI_REAL}.complex_plus"
--		do
--			Precursor {STT_STRICT_REAL_TESTS}
--		end

--	test_plus
--			-- Test {STI_REAL}.plus.
--		note
--			testing: "covers/{STI_REAL}.plus"
--		do
--			Precursor {STT_STRICT_REAL_TESTS}
--		end

--	test_identity
--			-- Test {STI_REAL}.identity.
--		note
--			testing: "covers/{STI_REAL}.identity"
--		do
--			Precursor {STT_STRICT_REAL_TESTS}
--		end

--	test_complex_minus
--			-- Test {STI_REAL}.complex_minus.
--		note
--			testing: "covers/{STI_REAL}.complex_minus"
--		do
--			Precursor {STT_STRICT_REAL_TESTS}
--		end

--	test_minus
--			-- Test {STI_REAL}.minus.
--		note
--			testing: "covers/{STI_REAL}.minus"
--		do
--			Precursor {STT_STRICT_REAL_TESTS}
--		end

--	test_opposite
--			-- Test {STI_REAL}.opposite.
--		note
--			testing: "covers/{STI_REAL}.opposite"
--		do
--			Precursor {STT_STRICT_REAL_TESTS}
--		end

--	test_complex_product
--			-- Test {STI_REAL}.complex_product.
--		note
--			testing: "covers/{STI_REAL}.complex_product"
--		do
--			Precursor {STT_STRICT_REAL_TESTS}
--		end

--	test_product
--			-- Test {STI_REAL}.product.
--		note
--			testing: "covers/{STI_REAL}.product"
--		do
--			Precursor {STT_STRICT_REAL_TESTS}
--		end

--	test_complex_quotient
--			-- Test {STI_REAL}.complex_quotient.
--		note
--			testing: "covers/{STI_REAL}.complex_quotient"
--		do
--			Precursor {STT_STRICT_REAL_TESTS}
--		end

--	test_quotient
--			-- Test {STI_REAL}.quotient.
--		note
--			testing: "covers/{STI_REAL}.quotient"
--		do
--			Precursor {STT_STRICT_REAL_TESTS}
--		end

--	test_reciprocal
--			-- Test {STI_REAL}.reciprocal.
--		note
--			testing: "covers/{STI_REAL}.reciprocal"
--		do
--			Precursor {STT_STRICT_REAL_TESTS}
--		end

--	test_inverse
--			-- Test {STI_REAL}.inverse.
--		note
--			testing: "covers/{STI_REAL}.inverse"
--		do
--			Precursor {STT_STRICT_REAL_TESTS}
--		end

--	test_power
--			-- Test {STI_REAL}.power.
--		note
--			testing: "covers/{STI_REAL}.power"
--		do
--			Precursor {STT_STRICT_REAL_TESTS}
--		end

--feature -- Test routines (Conversion)

--	test_as_complex
--			-- <Precursor>
--		note
--			testing: "covers/{STI_REAL}.as_complex"
--		do
--			Precursor {STT_STRICT_REAL_TESTS}
--		end

--feature -- Test routines (Factory)

--	test_normalized_value
--			-- Test {STI_REAL}.normalized_value.
--		note
--			testing: "covers/{STI_REAL}.normalized_value"
--		do
--			Precursor {STT_STRICT_REAL_TESTS}
--		end

note
	copyright: "Copyright (c) 2012-2019, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"
end
