note
	description: "(Partial) implementation of {STS_ORDERED_NUMERIC_SET}"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date$"
	revision: "$Revision$"

deferred class
	ORDERED_NUMERIC_SET [A -> STS_REAL_NUMBER, EQ -> STS_NUMERIC_EQUALITY [A] create default_create end]

inherit
	STS_ORDERED_NUMERIC_SET [A, EQ]
		undefine
			has,
			with,
			without,
			cardinality,
			out,
			equals,
			is_subset,
			is_superset,
			is_comparable,
			is_strict_subset,
			is_strict_superset,
			is_trivial_subset,
			is_trivial_superset,
			is_proper_subset,
			is_proper_superset,
			is_disjoint,
			exists,
			exists_unique,
			exists_pair,
			exists_distinct_pair,
			for_all,
			for_all_pairs,
			for_all_distinct_pairs,
			trivial_subsets,
			complemented,
			intersected,
			subtracted,
			subtracted_symmetricaly,
			diagonal,
			crossed_tuples,
			equality_holds
		end

	NUMERIC_SET [A, EQ]

feature -- Access

	u,
	universe: UNIVERSE [A, EQ]
			-- <Precursor>
		deferred
		end

feature -- Anchor

	set_anchor,
	subset_anchor,
	superset_anchor: ORDERED_NUMERIC_SET [A, EQ]
			-- <Precursor>
		deferred
		end

note
	copyright: "Copyright (c) 2012-2021, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"
end
