note
	description: "Implementation of {STS_ORDERED_PAIR_COMPOSER}"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date: Sat 2018-11-10 18:52:01 -0300 $"
	revision: "$Revision$"

class
	ORDERED_PAIR_COMPOSER [
		W, A, B,
		EQ_W -> STS_EQUALITY [W] create default_create end,
		EQ_A -> STS_EQUALITY [A] create default_create end,
		EQ_B -> STS_EQUALITY [B] create default_create end
		]

inherit
	STS_ORDERED_PAIR_COMPOSER [W, A, B, EQ_W, EQ_A, EQ_B]

feature -- Operation

	composite_pair alias "()" (xy: STS_ORDERED_PAIR [A, B, EQ_A, EQ_B]; wx: STS_ORDERED_PAIR [W, A, EQ_W, EQ_A]): COMPOSABLE_ORDERED_PAIR [A, W, B, EQ_A, EQ_W, EQ_B]
			-- <Precursor>
		do
			create Result.make (wx.a, xy.b)
		ensure then
			class
		end

note
	copyright: "Copyright (c) 2012-2020, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"

end
