﻿note
	description: "Implementation of {STS_COMPOSABLE_GRAPH}"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date$"
	revision: "$Revision$"

class
	STI_COMPOSABLE_GRAPH [
		W, A, B,
		EQ_W -> STS_EQUALITY [W]
			create default_create end,
		EQ_A -> STS_EQUALITY [A]
			create default_create end,
		EQ_B -> STS_EQUALITY [B]
			create default_create end
		]

--inherit

--	STS_COMPOSABLE_GRAPH [W, A, B, EQ_W, EQ_A, EQ_B]
--		undefine
--			out,
--			with,
--			without,
--			cardinality,
--			equals,
--			is_strict_subset,
--			is_trivial_subset,
--			is_proper_subset,
--			is_disjoint,
--			exists,
--			exists_unique,
--			exists_pair,
--			exists_distinct_pair,
--			for_all,
--			for_all_pairs,
--			for_all_distinct_pairs,
--			trivial_subsets,
--			subtracted_symmetricaly,
--			diagonal,
--			crossed_tuples,
--			equality_holds,
--			equality_does_not_hold,
--			product_anchor,
--			square_anchor,
--			diagonal_anchor,
--			tuple_anchor,
--			first_anchor,
--			second_anchor
--		redefine
--			graph_anchor,
--			subgraph_anchor,
--			supergraph_anchor,
--			inverse_anchor,
--			pair_anchor
--		end

--	STI_GRAPH [A, B, EQ_A, EQ_B]
--		redefine
--			graph_anchor,
--			subgraph_anchor,
--			supergraph_anchor,
--			inverse_anchor,
--			pair_anchor,
--			any_anchor
--		end

--create
--	make_empty, make_singleton, make_extended, make_from_set

--convert
--	make_from_set ({
--		STS_SET [
--			STS_ORDERED_PAIR [A, B, EQ_A, EQ_B],
--			STS_PAIR_EQUALITY [A, B, EQ_A, EQ_B]
--			],
--		STI_SET [
--			STS_ORDERED_PAIR [A, B, EQ_A, EQ_B],
--			STS_PAIR_EQUALITY [A, B, EQ_A, EQ_B]
--			],

--		STS_TRANSFORMABLE_SET [
--			STS_ORDERED_PAIR [A, B, EQ_A, EQ_B],
--			A,
--			STS_PAIR_EQUALITY [A, B, EQ_A, EQ_B],
--			EQ_A
--			],
--		STI_TRANSFORMABLE_SET [
--			STS_ORDERED_PAIR [A, B, EQ_A, EQ_B],
--			A,
--			STS_PAIR_EQUALITY [A, B, EQ_A, EQ_B],
--			EQ_A
--			],

--		STS_TRANSFORMABLE_SET [
--			STS_ORDERED_PAIR [A, B, EQ_A, EQ_B],
--			B,
--			STS_PAIR_EQUALITY [A, B, EQ_A, EQ_B],
--			EQ_B
--			],
--		STI_TRANSFORMABLE_SET [
--			STS_ORDERED_PAIR [A, B, EQ_A, EQ_B],
--			B,
--			STS_PAIR_EQUALITY [A, B, EQ_A, EQ_B],
--			EQ_B
--			],

--		STS_TRANSFORMABLE_SET [
--			STS_ORDERED_PAIR [A, B, EQ_A, EQ_B],
--			STS_ORDERED_PAIR [A, B, EQ_A, EQ_B],
--			STS_PAIR_EQUALITY [A, B, EQ_A, EQ_B],
--			STS_PAIR_EQUALITY [A, B, EQ_A, EQ_B]
--			],
--		STI_TRANSFORMABLE_SET [
--			STS_ORDERED_PAIR [A, B, EQ_A, EQ_B],
--			STS_ORDERED_PAIR [A, B, EQ_A, EQ_B],
--			STS_PAIR_EQUALITY [A, B, EQ_A, EQ_B],
--			STS_PAIR_EQUALITY [A, B, EQ_A, EQ_B]
--			],

--		STS_TRANSFORMABLE_SET [
--			STS_ORDERED_PAIR [A, B, EQ_A, EQ_B],
--			STS_ORDERED_PAIR [B, A, EQ_B, EQ_A],
--			STS_PAIR_EQUALITY [A, B, EQ_A, EQ_B],
--			STS_PAIR_EQUALITY [B, A, EQ_B, EQ_A]
--			],
--		STI_TRANSFORMABLE_SET [
--			STS_ORDERED_PAIR [A, B, EQ_A, EQ_B],
--			STS_ORDERED_PAIR [B, A, EQ_B, EQ_A],
--			STS_PAIR_EQUALITY [A, B, EQ_A, EQ_B],
--			STS_PAIR_EQUALITY [B, A, EQ_B, EQ_A]
--			],

--		STS_SET_OF_PAIRS [A, B, EQ_A, EQ_B],
--		STI_SET_OF_PAIRS [A, B, EQ_A, EQ_B],

--		STS_RELATION_AWARE_SET [
--			STS_ORDERED_PAIR [A, B, EQ_A, EQ_B],
--			STS_PAIR_EQUALITY [A, B, EQ_A, EQ_B]
--			],
--		STI_RELATION_AWARE_SET [
--			STS_ORDERED_PAIR [A, B, EQ_A, EQ_B],
--			STS_PAIR_EQUALITY [A, B, EQ_A, EQ_B]
--			],

--		STS_RELATABLE_SET [
--			STS_ORDERED_PAIR [A, B, EQ_A, EQ_B],
--			A,
--			STS_PAIR_EQUALITY [A, B, EQ_A, EQ_B],
--			EQ_A
--			],
--		STI_RELATABLE_SET [
--			STS_ORDERED_PAIR [A, B, EQ_A, EQ_B],
--			A,
--			STS_PAIR_EQUALITY [A, B, EQ_A, EQ_B],
--			EQ_A
--			],

--		STS_RELATABLE_SET [
--			STS_ORDERED_PAIR [A, B, EQ_A, EQ_B],
--			B,
--			STS_PAIR_EQUALITY [A, B, EQ_A, EQ_B],
--			EQ_B
--			],
--		STI_RELATABLE_SET [
--			STS_ORDERED_PAIR [A, B, EQ_A, EQ_B],
--			B,
--			STS_PAIR_EQUALITY [A, B, EQ_A, EQ_B],
--			EQ_B
--			],

--		STS_RELATABLE_SET [
--			STS_ORDERED_PAIR [A, B, EQ_A, EQ_B],
--			STS_ORDERED_PAIR [A, B, EQ_A, EQ_B],
--			STS_PAIR_EQUALITY [A, B, EQ_A, EQ_B],
--			STS_PAIR_EQUALITY [A, B, EQ_A, EQ_B]
--			],
--		STI_RELATABLE_SET [
--			STS_ORDERED_PAIR [A, B, EQ_A, EQ_B],
--			STS_ORDERED_PAIR [A, B, EQ_A, EQ_B],
--			STS_PAIR_EQUALITY [A, B, EQ_A, EQ_B],
--			STS_PAIR_EQUALITY [A, B, EQ_A, EQ_B]
--			],

--		STS_RELATABLE_SET [
--			STS_ORDERED_PAIR [A, B, EQ_A, EQ_B],
--			STS_ORDERED_PAIR [B, A, EQ_B, EQ_A],
--			STS_PAIR_EQUALITY [A, B, EQ_A, EQ_B],
--			STS_PAIR_EQUALITY [B, A, EQ_B, EQ_A]
--			],
--		STI_RELATABLE_SET [
--			STS_ORDERED_PAIR [A, B, EQ_A, EQ_B],
--			STS_ORDERED_PAIR [B, A, EQ_B, EQ_A],
--			STS_PAIR_EQUALITY [A, B, EQ_A, EQ_B],
--			STS_PAIR_EQUALITY [B, A, EQ_B, EQ_A]
--			],

--		STS_GRAPH  [A, B, EQ_A, EQ_B],
--		STI_GRAPH  [A, B, EQ_A, EQ_B],

--		STS_COMPOSABLE_GRAPH [A, A, B, EQ_A, EQ_A, EQ_B],
--		STI_COMPOSABLE_GRAPH [A, A, B, EQ_A, EQ_A, EQ_B],

--		STS_COMPOSABLE_GRAPH [B, A, B, EQ_B, EQ_A, EQ_B],
--		STI_COMPOSABLE_GRAPH [B, A, B, EQ_B, EQ_A, EQ_B]
--		})

--feature -- Transformer

--	composer: STI_RELATION_COMPOSER [W, A, B, EQ_W, EQ_A, EQ_B]
--			-- <Precursor>
--		do
--			create Result
--		end

--feature -- Anchor

--	graph_anchor,
--	subgraph_anchor,
--	supergraph_anchor: STI_COMPOSABLE_GRAPH [W, A, B, EQ_W, EQ_A, EQ_B]
--			-- <Precursor>
--		do
--			Result := Current
--		end

--	inverse_anchor: STI_COMPOSABLE_GRAPH [W, B, A, EQ_W, EQ_B, EQ_A]
--			-- <Precursor>
--		do
--			Result := ⁻¹ Current
--		end

--	pair_anchor (a: A; b: B): STI_COMPOSABLE_PAIR [W, A, B, EQ_W, EQ_A, EQ_B]
--			-- <Precursor>
--		do
--			Result := pair (a, b)
--		end

--	any_anchor: STI_COMPOSABLE_PAIR [W, A, B, EQ_W, EQ_A, EQ_B]
--			-- <Precursor>
--		do
--			Result := any
--		end

note
	copyright: "Copyright (c) 2012-2019, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"
end
