﻿note
	description: "Implementation of {STS_ENDORELATION}"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date$"
	revision: "$Revision$"

class
	STI_ENDORELATION [A, EQ -> STS_EQUALITY [A] create default_create end]

--inherit

--	STS_ENDORELATION [A, EQ]
--		undefine
--			out
--		redefine
--			underlying_set_anchor,
--			relation_anchor,
--			superrelation_anchor,
--			inverse_anchor,
--			graph_anchor
--		end

--	STI_BINARY_RELATION [A, A, EQ, EQ]
--		rename
--			make as binary_relation_make,
--			departure as underlying_set,
--			b as a,
--			arrival as underlying_set,
--			departure_anchor as underlying_set_anchor,
--			arrival_anchor as underlying_set_anchor,
--			united as binary_relation_united,
--			intersected as binary_relation_intersected
--		redefine
--			ab,
--			a, underlying_set,
--			underlying_set_anchor,
--			relation_anchor,
--			superrelation_anchor,
--			inverse_anchor,
--			graph_anchor
--		select
--			pair_out
--		end

--create
--	make

--feature {NONE} -- Initialization

--	make (a_underlying_set: STS_SET [A, EQ]; a_graph: STS_SET [STS_ORDERED_PAIR [A, A, EQ, EQ], STS_PAIR_EQUALITY [A, A, EQ, EQ]])
--			-- Create the endorelation (`a_underlying_set`, `a_underlying_set`, `a_graph`)
--		require
--			within_square: a_graph ⊆ ²a_underlying_set
--		do
--			create ab.make (a_underlying_set, a_underlying_set)
--			create g.make_empty
--			g := g.converted (a_graph)
--		ensure
--			underlying_set: a ≍ a_underlying_set
--			graph: g ≍ a_graph
--		end

--feature -- Primitive

--	ab: STI_HOMOGENEOUS_PAIR [STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ]]
--			-- <Precursor>

--feature -- Access

--	a,
--	underlying_set: like underlying_set_anchor
--			-- <Precursor>
--		do
--			if attached {like underlying_set_anchor} ab.a as l_underlying_set then
--				Result := l_underlying_set
--			else
--				create Result.make_empty
--				Result := Result.converted (ab.a)
--			end
--		end

--feature -- Operation

--	united alias "∪" (r: STS_ENDORELATION [A, EQ]): like relation_anchor
--			-- <Precursor>
--		do
--				check
--					within_square: g ∪ r.g ⊆ ²(a ∪ r.a) -- g ⊆ ²a and r.g ⊆ ²r.a
--				end
--			create Result.make (a ∪ r.a, g ∪ r.g)
--		end

--	intersected alias "∩" (r: STS_ENDORELATION [A, EQ]): like relation_anchor
--			-- <Precursor>
--		do
--				check
--					within_square: g ∩ r.g ⊆ ²(a ∪ r.a) -- g ⊆ ²a and r.g ⊆ ²r.a
--				end
--			create Result.make (a ∪ r.a, g ∩ r.g)
--		end

--	composed alias "∘" (r: STS_BINARY_RELATION [A, A, EQ, EQ]): like relation_anchor
--			-- <Precursor>
--		do
--				check
--					within_square: g ∘ r.g ⊆ ²(a ∪ r.a) -- `∘' definition
--				end
--			create Result.make (a ∪ r.a, g ∘ r.g)
--		end

--feature -- Anchor

--	underlying_set_anchor: STI_RELATABLE_SET [A, A, EQ, EQ]
--			-- <Precursor>
--		do
--			Result := a
--		end

--	relation_anchor,
--	inverse_anchor: STI_ENDORELATION [A, EQ]
--			-- <Precursor>
--		do
--			Result := Current
--		end

--	superrelation_anchor: STI_BINARY_RELATION [A, A, EQ, EQ]
--			-- <Precursor>
--		do
--			Result := Current
--		end

--	graph_anchor: STI_HOMOGENEOUS_GRAPH [A, EQ]
--			-- <Precursor>
--		do
--			Result := g
--		end

note
	copyright: "Copyright (c) 2012-2019, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"
end
