﻿note
	description: "Implementation of {STS_GRAPH}"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date$"
	revision: "$Revision$"

class
	STI_GRAPH [
		A, B,
		EQ_A -> STS_EQUALITY [A]
			create default_create end,
		EQ_B -> STS_EQUALITY [B]
			create default_create end
		]

--inherit

--	STS_GRAPH [A, B, EQ_A, EQ_B]
--		undefine
--				-- Construction
--			with,
--			without,
--				-- Measurement
--			cardinality,
--				-- Output
--			out,
--				-- Comparison
--			equals,
--			is_strict_subset,
--			is_trivial_subset,
--			is_proper_subset,
--			is_disjoint,
--				-- Quantifier
--			exists,
--			exists_unique,
--			exists_pair,
--			exists_distinct_pair,
--			for_all,
--			for_all_pairs,
--			for_all_distinct_pairs,
--				-- Operation
--			trivial_subsets,
--			subtracted_symmetricaly,
--			diagonal,
--			crossed_tuples,
--				-- Predicate
--			equality_holds,
--			equality_does_not_hold,
--				-- Anchor
--			product_anchor,
--			square_anchor,
--			diagonal_anchor,
--			tuple_anchor
--		redefine
--				-- Anchor
--			graph_anchor,
--			subgraph_anchor,
--			supergraph_anchor,
--			first_anchor,
--			second_anchor,
--			inverse_anchor,
--			pair_anchor
--		end

--	STI_SET_OF_PAIRS [A, B, EQ_A, EQ_B]
--		rename
--			pair as pair_of_pairs,
--				-- Anchor
--			set_anchor as graph_anchor,
--			subset_anchor as subgraph_anchor,
--			superset_anchor as supergraph_anchor
--		undefine
--			pair_to_pair,
--			pair_to_natural,
--			pair_to_boolean,
--			pair_to_tuple,
--			pair_to_sets,
--			tuple_extensor,
--			product_anchor,
--			square_anchor,
--			diagonal_anchor
--		redefine
--				-- Anchor
--			graph_anchor,
--			subgraph_anchor,
--			supergraph_anchor
--		end

--	STI_RELATION_AWARE_SET [STS_ORDERED_PAIR [A, B, EQ_A, EQ_B], STS_PAIR_EQUALITY [A, B, EQ_A, EQ_B]]
--		rename
--			pair as pair_of_pairs,
--			converted_element as converted_pair,
--				-- Transformer
--			element_to_element as pair_to_pair,
--			element_to_natural as pair_to_natural,
--			element_to_boolean as pair_to_boolean,
--			element_to_tuple as pair_to_tuple,
--			element_to_sets as pair_to_sets,
--				-- Anchor
--			set_anchor as graph_anchor,
--			subset_anchor as subgraph_anchor,
--			superset_anchor as supergraph_anchor
--		undefine
--			converted_pair,
--			any_anchor
--		redefine
--				-- Anchor
--			graph_anchor,
--			subgraph_anchor,
--			supergraph_anchor
--		end

--create
--	make_empty, make_singleton, make_extended, make_from_set

--convert
--	make_from_set ({
--		STS_SET [
--			STS_ORDERED_PAIR [A, B, EQ_A, EQ_B],
--			STS_PAIR_EQUALITY [A, B, EQ_A, EQ_B]
--			],
--		STI_SET [
--			STS_ORDERED_PAIR [A, B, EQ_A, EQ_B],
--			STS_PAIR_EQUALITY [A, B, EQ_A, EQ_B]
--			],

--		STS_TRANSFORMABLE_SET [
--			STS_ORDERED_PAIR [A, B, EQ_A, EQ_B],
--			A,
--			STS_PAIR_EQUALITY [A, B, EQ_A, EQ_B],
--			EQ_A
--			],
--		STI_TRANSFORMABLE_SET [
--			STS_ORDERED_PAIR [A, B, EQ_A, EQ_B],
--			A,
--			STS_PAIR_EQUALITY [A, B, EQ_A, EQ_B],
--			EQ_A
--			],

--		STS_TRANSFORMABLE_SET [
--			STS_ORDERED_PAIR [A, B, EQ_A, EQ_B],
--			B,
--			STS_PAIR_EQUALITY [A, B, EQ_A, EQ_B],
--			EQ_B
--			],
--		STI_TRANSFORMABLE_SET [
--			STS_ORDERED_PAIR [A, B, EQ_A, EQ_B],
--			B,
--			STS_PAIR_EQUALITY [A, B, EQ_A, EQ_B],
--			EQ_B
--			],

--		STS_TRANSFORMABLE_SET [
--			STS_ORDERED_PAIR [A, B, EQ_A, EQ_B],
--			STS_ORDERED_PAIR [A, B, EQ_A, EQ_B],
--			STS_PAIR_EQUALITY [A, B, EQ_A, EQ_B],
--			STS_PAIR_EQUALITY [A, B, EQ_A, EQ_B]
--			],
--		STI_TRANSFORMABLE_SET [
--			STS_ORDERED_PAIR [A, B, EQ_A, EQ_B],
--			STS_ORDERED_PAIR [A, B, EQ_A, EQ_B],
--			STS_PAIR_EQUALITY [A, B, EQ_A, EQ_B],
--			STS_PAIR_EQUALITY [A, B, EQ_A, EQ_B]
--			],

--		STS_TRANSFORMABLE_SET [
--			STS_ORDERED_PAIR [A, B, EQ_A, EQ_B],
--			STS_ORDERED_PAIR [B, A, EQ_B, EQ_A],
--			STS_PAIR_EQUALITY [A, B, EQ_A, EQ_B],
--			STS_PAIR_EQUALITY [B, A, EQ_B, EQ_A]
--			],
--		STI_TRANSFORMABLE_SET [
--			STS_ORDERED_PAIR [A, B, EQ_A, EQ_B],
--			STS_ORDERED_PAIR [B, A, EQ_B, EQ_A],
--			STS_PAIR_EQUALITY [A, B, EQ_A, EQ_B],
--			STS_PAIR_EQUALITY [B, A, EQ_B, EQ_A]
--			],

--		STS_SET_OF_PAIRS [A, B, EQ_A, EQ_B],
--		STI_SET_OF_PAIRS [A, B, EQ_A, EQ_B],

--		STS_RELATION_AWARE_SET [
--			STS_ORDERED_PAIR [A, B, EQ_A, EQ_B],
--			STS_PAIR_EQUALITY [A, B, EQ_A, EQ_B]
--			],
--		STI_RELATION_AWARE_SET [
--			STS_ORDERED_PAIR [A, B, EQ_A, EQ_B],
--			STS_PAIR_EQUALITY [A, B, EQ_A, EQ_B]
--			],

--		STS_RELATABLE_SET [
--			STS_ORDERED_PAIR [A, B, EQ_A, EQ_B],
--			A,
--			STS_PAIR_EQUALITY [A, B, EQ_A, EQ_B],
--			EQ_A
--			],
--		STI_RELATABLE_SET [
--			STS_ORDERED_PAIR [A, B, EQ_A, EQ_B],
--			A,
--			STS_PAIR_EQUALITY [A, B, EQ_A, EQ_B],
--			EQ_A
--			],

--		STS_RELATABLE_SET [
--			STS_ORDERED_PAIR [A, B, EQ_A, EQ_B],
--			B,
--			STS_PAIR_EQUALITY [A, B, EQ_A, EQ_B],
--			EQ_B
--			],
--		STI_RELATABLE_SET [
--			STS_ORDERED_PAIR [A, B, EQ_A, EQ_B],
--			B,
--			STS_PAIR_EQUALITY [A, B, EQ_A, EQ_B],
--			EQ_B
--			],

--		STS_RELATABLE_SET [
--			STS_ORDERED_PAIR [A, B, EQ_A, EQ_B],
--			STS_ORDERED_PAIR [A, B, EQ_A, EQ_B],
--			STS_PAIR_EQUALITY [A, B, EQ_A, EQ_B],
--			STS_PAIR_EQUALITY [A, B, EQ_A, EQ_B]
--			],
--		STI_RELATABLE_SET [
--			STS_ORDERED_PAIR [A, B, EQ_A, EQ_B],
--			STS_ORDERED_PAIR [A, B, EQ_A, EQ_B],
--			STS_PAIR_EQUALITY [A, B, EQ_A, EQ_B],
--			STS_PAIR_EQUALITY [A, B, EQ_A, EQ_B]
--			],

--		STS_RELATABLE_SET [
--			STS_ORDERED_PAIR [A, B, EQ_A, EQ_B],
--			STS_ORDERED_PAIR [B, A, EQ_B, EQ_A],
--			STS_PAIR_EQUALITY [A, B, EQ_A, EQ_B],
--			STS_PAIR_EQUALITY [B, A, EQ_B, EQ_A]
--			],
--		STI_RELATABLE_SET [
--			STS_ORDERED_PAIR [A, B, EQ_A, EQ_B],
--			STS_ORDERED_PAIR [B, A, EQ_B, EQ_A],
--			STS_PAIR_EQUALITY [A, B, EQ_A, EQ_B],
--			STS_PAIR_EQUALITY [B, A, EQ_B, EQ_A]
--			],

--		STS_GRAPH  [A, B, EQ_A, EQ_B],
--		STS_COMPOSABLE_GRAPH [A, A, B, EQ_A, EQ_A, EQ_B],
--		STS_COMPOSABLE_GRAPH [B, A, B, EQ_B, EQ_A, EQ_B]
--		})

--feature -- Primitive

--	eq_a: EQ_A
--			-- <Precursor>
--		do
--			create Result
--		ensure then
--			class
--		end

--	eq_b: EQ_B
--			-- <Precursor>
--		do
--			create Result
--		ensure then
--			class
--		end

--feature -- Transformation

--	mapped_to_first_projection_like alias "↦₁"
--		(f: FUNCTION [STS_ORDERED_PAIR [A, B, EQ_A, EQ_B], A]): like first_anchor
--			-- <Precursor>
--		local
--			g: like subgraph_anchor
--		do
--			from
--				create Result.make_empty
--				g := Current
--			invariant
--				building_up: Result ≍ pair_to_first.set_map (Current ∖ g, f)
--			until
--				g.is_empty
--			loop
--				Result := Result & f (g.any)
--				g := g.others
--			variant
--				cartinality: (# g).as_integer_64
--			end
--		end

--	mapped_to_second_projection_like alias "↦₂"
--		(f: FUNCTION [STS_ORDERED_PAIR [A, B, EQ_A, EQ_B], B]): like second_anchor
--			-- <Precursor>
--		local
--			g: like subgraph_anchor
--		do
--			from
--				create Result.make_empty
--				g := Current
--			invariant
--				building_up: Result ≍ pair_to_second.set_map (Current ∖ g, f)
--			until
--				g.is_empty
--			loop
--				Result := Result & f (g.any)
--				g := g.others
--			variant
--				cartinality: (# g).as_integer_64
--			end
--		end

--	mapped_to_inverse_like alias "↦₂ｘ₁" (
--		f: FUNCTION [STS_ORDERED_PAIR [A, B, EQ_A, EQ_B], STS_ORDERED_PAIR [B, A, EQ_B, EQ_A]]
--		): like inverse_anchor
--			-- <Precursor>
--		local
--			g: like subgraph_anchor
--		do
--			from
--				create Result.make_empty
--				g := Current
--			invariant
--				building_up: Result ≍ pair_to_inverse.set_map (Current ∖ g, f)
--			until
--				g.is_empty
--			loop
--				Result := Result & f (g.any)
--				g := g.others
--			variant
--				cartinality: (# g).as_integer_64
--			end
--		end

--feature -- Factory

--	pair (a: A; b: B): like pair_anchor
--			-- <Precursor>
--		do
--			create Result.make (a, b)
--		end

--feature -- Transformer

--	pair_to_first: STI_RELATION_PRODUCER [STS_ORDERED_PAIR [A, B, EQ_A, EQ_B], A, STS_PAIR_EQUALITY [A, B, EQ_A, EQ_B], EQ_A]
--			-- <Precursor>
--		do
--			create Result
--		end

--	pair_to_second: STI_RELATION_PRODUCER [STS_ORDERED_PAIR [A, B, EQ_A, EQ_B], B, STS_PAIR_EQUALITY [A, B, EQ_A, EQ_B], EQ_B]
--			-- <Precursor>
--		do
--			create Result
--		end

--	pair_to_inverse: STI_RELATION_PRODUCER [
--		STS_ORDERED_PAIR [A, B, EQ_A, EQ_B], STS_ORDERED_PAIR [B, A, EQ_B, EQ_A],
--		STS_PAIR_EQUALITY [A, B, EQ_A, EQ_B], STS_PAIR_EQUALITY [B, A, EQ_B, EQ_A]
--		]
--			-- <Precursor>
--		do
--			create Result
--		end

--	composer_with_homogeneous: STI_RELATION_COMPOSER [A, A, B, EQ_A, EQ_A, EQ_B]
--			-- <Precursor>
--		do
--			create Result
--		end

--	composer_with_inverse_like: STI_RELATION_COMPOSER [B, A, B, EQ_B, EQ_A, EQ_B]
--			-- <Precursor>
--		do
--			create Result
--		end

--feature -- Anchor

--	graph_anchor,
--	subgraph_anchor,
--	supergraph_anchor: STI_GRAPH [A, B, EQ_A, EQ_B]
--			-- <Precursor>
--		do
--			Result := Current
--		end

--	first_anchor: STI_RELATABLE_SET [A, B, EQ_A, EQ_B]
--			-- <Precursor>
--		do
--			Result := π₁ Current
--		end

--	second_anchor: STI_RELATABLE_SET [B, A, EQ_B, EQ_A]
--			-- <Precursor>
--		do
--			Result := π₂ Current
--		end

--	inverse_anchor: STI_GRAPH [B, A, EQ_B, EQ_A]
--			-- <Precursor>
--		do
--			Result := ⁻¹ Current
--		end

--	pair_anchor (a: A; b: B): STI_ORDERED_PAIR [A, B, EQ_A, EQ_B]
--			-- <Precursor>
--		do
--			Result := pair (a, b)
--		end

note
	copyright: "Copyright (c) 2012-2019, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"
end
