﻿note
	description: "Implementation of {STS_RELATABLE_SET}"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date$"
	revision: "$Revision$"

class
	STI_RELATABLE_SET [
		A, B,
		EQ_A -> STS_EQUALITY [A]
			create default_create end,
		EQ_B -> STS_EQUALITY [B]
			create default_create end
		]

--inherit

--	STS_RELATABLE_SET [A, B, EQ_A, EQ_B]
--		undefine
--				-- Construction
--			with,
--			without,
--				-- Measurement
--			cardinality,
--				-- Output
--			out,
--				-- Comparison
--			equals,
--			is_strict_subset,
--			is_trivial_subset,
--			is_proper_subset,
--			is_disjoint,
--				-- Quantifier
--			exists,
--			exists_unique,
--			exists_pair,
--			exists_distinct_pair,
--			for_all,
--			for_all_pairs,
--			for_all_distinct_pairs,
--				-- Operation
--			trivial_subsets,
--			subtracted_symmetricaly,
--			diagonal,
--			crossed_tuples,
--				-- Predicate
--			equality_holds,
--			equality_does_not_hold,
--			tuple_anchor,
--			product_anchor,
--			square_anchor,
--				-- Anchor
--			diagonal_anchor
--		redefine
--				-- Anchor
--			set_anchor,
--			subset_anchor,
--			superset_anchor
--		end

--	STI_RELATION_AWARE_SET [A, EQ_A]
--		rename
--				-- Primitive
--			eq as eq_a,
--				-- Operation
--			crossed as crossed_with_same_kind alias "×₁",
--			relations as homogeneous_relations alias "₁↔₁",
--				-- Transformation
--			mapped as mapped_to_same_kind alias "↦₁",
--			reduced as reduced_to_element_like
--		undefine
--			tuple_anchor
--		redefine
--			set_anchor,
--			subset_anchor,
--			superset_anchor
--		end

--	STI_TRANSFORMABLE_SET [A, B, EQ_A, EQ_B]
--		rename
--				-- Factory
--			transformer as relation_producer
--		undefine
--			element_to_element,
--			element_to_natural,
--			element_to_boolean,
--			element_to_tuple,
--			element_to_sets,
--			tuple_extensor,
--			product_anchor,
--			square_anchor,
--			diagonal_anchor
--		redefine
--			relation_producer,
--			set_anchor,
--			subset_anchor,
--			superset_anchor
--		end

--create
--	make_empty, make_singleton, make_extended, make_from_set

--convert
--	make_from_set ({
--		STS_SET [A, EQ_A],
--		STI_SET [A, EQ_A],

--		STS_TRANSFORMABLE_SET [A, A, EQ_A, EQ_A],
--		STI_TRANSFORMABLE_SET [A, A, EQ_A, EQ_A],

--		STS_TRANSFORMABLE_SET [A, B, EQ_A, EQ_B],
--		STI_TRANSFORMABLE_SET [A, B, EQ_A, EQ_B],

--		STS_RELATION_AWARE_SET [A, EQ_A],
--		STI_RELATION_AWARE_SET [A, EQ_A],

--		STS_RELATABLE_SET [A, A, EQ_A, EQ_A],
--		STI_RELATABLE_SET [A, A, EQ_A, EQ_A],

--		STS_RELATABLE_SET [A, B, EQ_A, EQ_B]
--		})

--feature -- Transformer

--	relation_producer: STI_RELATION_PRODUCER [A, B, EQ_A, EQ_B]
--			-- <Precursor>
--		do
--			create Result
--		end

--feature -- Anchor

--	set_anchor,
--	subset_anchor,
--	superset_anchor: STI_RELATABLE_SET [A, B, EQ_A, EQ_B]
--			-- <Precursor>
--		do
--			Result := Current
--		end

note
	copyright: "Copyright (c) 2012-2019, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"
end
