﻿note
	description: "Implementation of {STS_RELATION_COMPOSER}"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date$"
	revision: "$Revision$"

class
	STI_RELATION_COMPOSER [
		W, A, B,
		EQ_W -> STS_EQUALITY [W]
			create default_create end,
		EQ_A -> STS_EQUALITY [A]
			create default_create end,
		EQ_B -> STS_EQUALITY [B]
			create default_create end
		]

--inherit

--	STS_RELATION_COMPOSER [W, A, B, EQ_W, EQ_A, EQ_B]

--	STI_PAIR_COMPOSER [W, A, B, EQ_W, EQ_A, EQ_B]
--		rename
--				-- Operation
--			composite_pair as composite_pair
--		end

--feature -- Operation

--	composite_graph (
--		h: STS_GRAPH [A, B, EQ_A, EQ_B]; g: STS_GRAPH [W, A, EQ_W, EQ_A]
--		): STI_COMPOSABLE_GRAPH [A, W, B, EQ_A, EQ_W, EQ_B]
--			-- <Precursor>
--		local
--			ws: STS_SET [W, EQ_W]
--			xs: STS_SET [A, EQ_A]
--			ys, ysi: STS_SET [B, EQ_B]
--			wy: STI_COMPOSABLE_PAIR [A, W, B, EQ_A, EQ_W, EQ_B]
--		do
--			from
--				create Result.make_empty
--				ws := π₁ g
--				xs := π₂ g ∩ π₁ h
--				ys :=  π₂ h
--			invariant
--				building_up: Result ≍ (w_x_b.cartesian_product (π₁ g ∖ ws, ys) ｜ˣʸ agent pair_is_composite (?, ?, g, h))
--			until
--				ws.is_empty
--			loop
--				from
--					ysi := ys
--				invariant
--					preceding: attached (w_x_b.cartesian_product (π₁ g ∖ ws, ys) ｜ˣʸ agent pair_is_composite (?, ?, g, h)) as preceding
--					succeeding: Result ≍ (preceding ∪ (w_x_b.cartesian_product (ws.singleton (ws.any), ys ∖ ysi) ｜ˣʸ agent pair_is_composite (?, ?, g, h)))
--				until
--					ysi.is_empty
--				loop
--					if xs ∃ agent x_is_common (ws.any, ?, ysi.any, g, h) then
--						create wy.make (ws.any,  ysi.any)
--							check
--								does_not_have: Result ∌ wy -- loop invariant
--							end
--						Result := Result.extended (wy)
--					end
--					ysi := ysi.others
--				variant
--					ysi_cartinality: (# ysi).as_integer_64
--				end
--				ws := ws.others
--			variant
--				ws_cartinality: (# ws).as_integer_64
--			end
--		end

--	composite_relation (
--		r2: STS_BINARY_RELATION [A, B, EQ_A, EQ_B]; r1: STS_BINARY_RELATION [W, A, EQ_W, EQ_A]
--		): STI_COMPOSABLE_RELATION [A, W, B, EQ_A, EQ_W, EQ_B]
--			-- <Precursor>
--		do
--				check
--					within_product: composite_graph (r2.g, r1.g) ⊆ {STI_RELATION_PRODUCER [W, B, EQ_W, EQ_B]}.cartesian_product (r1.a, r2.b) -- `composite_graph' definition
--				end
--			create Result.make (r1.a, r2.b, composite_graph (r2.g, r1.g))
--		end

--feature -- Transformer

--	w_x_b: STI_RELATION_PRODUCER [W, B, EQ_W, EQ_B]
--			-- <Precursor>
--		do
--			create Result
--		end

note
	copyright: "Copyright (c) 2012-2019, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"
end
