﻿note
	description: "[
		Object that checks whether an implementation of {STS_COMPOSABLE_RELATION} bears the properties
		determined by set theory
	]"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date$"
	revision: "$Revision$"

deferred class
	STP_COMPOSABLE_RELATIOIN_PROPERTIES
		[W, A, B, EQ_W -> STS_EQUALITY [W], EQ_A -> STS_EQUALITY [A], EQ_B -> STS_EQUALITY [B]]

--inherit

--	STP_BINARY_RELATION_PROPERTIES [A, B, EQ_A, EQ_B]

--feature -- Properties (Operation)

--	composed_ok (
--		r2: STS_COMPOSABLE_RELATION [W, A, B, EQ_W, EQ_A, EQ_B]
--		r1: STS_COMPOSABLE_RELATION [B, W, A, EQ_B, EQ_W, EQ_A]
--		r0: STS_BINARY_RELATION [B, W, EQ_B, EQ_W]
--		): BOOLEAN
--			-- Do the properties verified within set theory hold for
--			-- {STS_COMPOSABLE_RELATION}.composed?
--		do
--			u_a := u_a & r2.ab
--			u_b := u_b & r2.g
--			check
--				inverse: ⁻¹(r2 ∘ r1) ≍ (⁻¹r1 ∘ ⁻¹r2)
--				associative: ((r2 ∘ r1) ₂∘₁ r0) ≍ (r2 ₂∘₁ (r1 ∘ r0))
--			then
--				Result := True
--			end
--		ensure
--			u_a: u_a ⊇ old (u_a & r2.ab)
--			u_b: u_b ⊇ old (u_b & r2.g)
--		end

note
	copyright: "Copyright (c) 2012-2020, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"
end
