﻿note
	description: "[
		Object that checks whether an implementation of {STS_HOMOGENEOUS_GRAPH} bears the properties
		determined by set theory
	]"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date$"
	revision: "$Revision$"

deferred class
	STP_HOMOGENEOUS_GRAPH_PROPERTIES [A, EQ -> STS_EQUALITY [A]]

inherit

	STP_GRAPH_PROPERTIES [A, A, EQ, EQ]

--feature -- Properties (Operation)

--	composed_ok (s1, s2, s3: STS_RELATION_AWARE_SET [A, EQ]): BOOLEAN
--			-- Do the properties verified within set theory hold for {STS_HOMOGENEOUS_GRAPH}.composed?
--		do
--			u_ab := u_ab ∪ ²s1 ∪ ²s2 ∪ ²s3 -- todo: rename/redefine u_ab etc?
--			check
--				idempotent_product: s1 ∩ s1 ≭ o_a implies (s1 × s2) ∘ (s1 × s2) ≍ (s1 × s2)
--				empty: s1 ∩ s1 ≍ o_a implies (s1 × s2) ∘ (s1 × s2) ≍ o_ab
--				induced_product: s2 ≭ o_a implies (s2 × s3) ∘ (s1 × s2) ≍ (s1 × s3)
--			then
--				Result := True
--			end
--		ensure
--			u_ab: u_ab ⊇ old (u_ab ∪ ²s1 ∪ ²s2 ∪ ²s3)
--		end

note
	copyright: "Copyright (c) 2012-2020, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"
end
