﻿note
	description: "[
		Object that checks whether an implementation of {STS_IDENTITY_RELATION} bears the properties
		determined by set theory
	]"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date$"
	revision: "$Revision$"

deferred class
	STP_IDENTITY_RELATION_PROPERTIES [A, EQ -> STS_EQUALITY [A]]

--inherit

--	STP_ENDORELATION_PROPERTIES [A, EQ]
--		rename
--			inverse_ok as ep_inverse_ok
--		end

--feature -- Properties (Operation)

--	inverse_ok (i: STS_IDENTITY_RELATION [A, EQ]): BOOLEAN
--			-- Do the properties verified within set theory hold for {STS_IDENTITY_RELATION}.inverse?
--		do
--			u_a := u_a & i.ab
--			u_b := u_b & i.g
--			check
--				identical: ⁻¹i ≍ i
--			then
--				Result := True
--			end
--		ensure
--			u_a: u_a ⊇ old (u_a & i.ab)
--			u_b: u_b ⊇ old (u_b & i.g)
--		end

--	composed_ok (r: STS_BINARY_RELATION [A, A, EQ, EQ]): BOOLEAN
--			-- Do the properties verified within set theory hold for {STS_IDENTITY_RELATION}.composed?
--		do
--			u_a := u_a & r.ab
--			u_b := u_b & r.g
--			check
--				identity: 𝐼 r.b ∘ r ≍ r
--			then
--				Result := True
--			end
--		ensure
--			u_a: u_a ⊇ old (u_a & r.ab)
--			u_b: u_b ⊇ old (u_b & r.g)
--		end

note
	copyright: "Copyright (c) 2012-2020, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"
end
