﻿note
	description: "[
		Object that checks whether an implementation of {STS_RELATABLE_SET} bears the properties
		determined by set theory
	]"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date$"
	revision: "$Revision$"

deferred class
	STP_RELATABLE_SET_PROPERTIES [A, B, EQ_A -> STS_EQUALITY [A], EQ_B -> STS_EQUALITY [B]]

--inherit

--	STP_TRANSFORMABLE_SET_PROPERTIES [A, B, EQ_A, EQ_B]

--feature -- Properties (Operation)

--	relations_ok (xs: STS_RELATABLE_SET [A, B, EQ_A, EQ_B]; ys: STS_SET [B, EQ_B]): BOOLEAN
--			-- Do the properties verified within set theory hold for {STS_RELATABLE_SET}.relations?
--		do
--			set_universe_a (u_a ∪ xs)
--			u_b := u_b ∪ ys
--			check
--				how_many: # (xs ↔ ys) = 2 ^ (# xs * # ys)
--			then
--				Result := True
--			end
--		ensure
--			u_a: u_a ⊇ old (u_a ∪ xs)
--			u_b: u_b ⊇ old (u_b ∪ ys)
--		end

note
	copyright: "Copyright (c) 2012-2020, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"
end
