﻿note
	description: "[
		Object that checks whether an implementation of {STS_RELATION_AWARE_SET} bears the properties
		determined by set theory
	]"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date$"
	revision: "$Revision$"

deferred class
	STP_RELATION_AWARE_SET_PROPERTIES [A, EQ -> STS_EQUALITY [A]]

--inherit

--	STP_SET_PROPERTIES [A, EQ]

--feature -- Properties (Operation)

--	identity_relation_ok (s: STS_RELATION_AWARE_SET [A, EQ]): BOOLEAN
--			-- Do the properties verified within set theory hold for {STS_RELATION_AWARE_SET}.identity_relation?
--		do
--			set_universe (u ∪ s)
--			check
--				full_domain: 𝐝𝐨𝐦 𝐼 s ≍ s
--				full_range: 𝐫𝐚𝐧 𝐼 s ≍ s
--			then
--				Result := True
--			end
--		ensure
--			u: u ⊇ old (u ∪ s)
--		end

--	endorelations_ok (s: STS_RELATION_AWARE_SET [A, EQ]): BOOLEAN
--			-- Do the properties verified within set theory hold for {STS_RELATION_AWARE_SET}.endorelations?
--		do
--			set_universe (u ∪ s)
--			check
--				how_many: # ↔ s = 2 ^ ((# s) ^ 2)
--				how_many_reflexive: # s >= 1 implies # (↔ s | agent {STS_ENDORELATION [A, EQ]}.is_reflexive) = 2 ^ (# s * (# s - 1))
--				how_many_reflexive_symmetric: # s >= 1 implies # (↔ s | agent {STS_ENDORELATION [A, EQ]}.is_reflexive | agent {STS_ENDORELATION [A, EQ]}.is_symmetric) = 2 ^ (# s * (# s - 1) / 2)
--			then
--				Result := True
--			end
--		ensure
--			u: u ⊇ old (u ∪ s)
--		end

note
	copyright: "Copyright (c) 2012-2020, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"
end
