﻿note
	description: "Equality that compares numbers according to {COMPLEX_NUMBER}.equals, i.e. the complex number ≍ operator."
	author: "Rosivaldo Fernandes Alves"
	date: "$Date$"
	revision: "$Revision$"

class
	NUMERIC_EQUALITY [A -> COMPLEX_NUMBER]

inherit
	INSTANCE_FREE_EQUALITY [A]

feature -- Relationship

	holds alias "()" (x, y: A): BOOLEAN
			-- Does current equality hold for `x` and `y`?
		do
			Result := x ≍ y
		ensure then
			definition: Result = (x ≍ y)
		end

note
	copyright: "Copyright (c) 2012-2022, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"

end
