﻿note
	description: "[
		Equality that compares sets according to {SET}.equals, i.e. the set ≍ operator.
		]"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date: Wed 2018-11-21 07:53:55 -0300 $"
	revision: "$Revision$"

class
	SET_EQUALITY [A, EQ -> EQUALITY [A]]

inherit
	INSTANCE_FREE_EQUALITY [SET [A, EQ]]

feature -- Relationship

	holds alias "()" (a, b: SET [A, EQ]): BOOLEAN
			-- <Precursor>
		do
			Result := a ≍ b
		ensure then
			definition: Result = (a ≍ b)
		end

note
	copyright: "Copyright (c) 2012-2020, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"

end
