﻿note
	description: "[
		Equality that compares binary relations according to {STS_ENDORELATION}.equals, i.e. the endorelation ≍ operator.
	]"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date$"
	revision: "$Revision$"

class
	STS_ENDORELATION_EQUALITY [A, EQ -> STS_EQUALITY [A]]

--inherit

--	STS_INSTANCE_FREE_EQUALITY [STS_ENDORELATION [A, EQ]]

--feature -- Relationship

--	holds alias "()" (r1, r2: STS_ENDORELATION [A, EQ]): BOOLEAN
--			-- Does this equality hold for `r1` and `r2`?
--		do
--			Result := r1 ≍ r2
--		ensure then
--			definition: Result = (r1 ≍ r2)
--		end

note
	copyright: "Copyright (c) 2012-2020, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"
end
