﻿note
	description: "Reflexive, symmetric and transitive endorelation"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date$"
	revision: "$Revision$"

deferred class
	STS_EQUIVALENCE [A, EQ -> STS_EQUALITY [A]]

--inherit

--	STS_ENDORELATION [A, EQ]
--		rename
--			image as image
--		redefine
--			inverse_anchor
--		end

--feature -- Relationship

--	is_represented (s: STS_SET [A, EQ]): BOOLEAN
--			-- Is this equivalence represented by `s', i.e. does `s' have exactly one element from every class defined by this equivalence?
--		do
--			Result := # s = # quotient and element_to_set.set_map (s, agent equivalence_class) ≍ quotient
--		ensure
--			definition: Result = (# s = # quotient and element_to_set.set_map (s, agent equivalence_class) ≍ quotient)
--		end

--feature -- Operation

--	equivalence_class alias "[]" (x: A): like image
--			-- Set of elements in `underlying_set_anchor' regarded equivalent to `x` by this relation
--		do
--			Result := image (a.singleton (x))
--		ensure
--			definition: Result ≍ image (a.singleton (x))
--		end

--	quotient: STS_SET_QUOTIENT [A, EQ]
--			-- Set of all classes defined by this equivalence
--		deferred
--		ensure
--			definition: Result ≍ element_to_set.set_map (a, agent equivalence_class)
--		end

--feature -- Transformer

--	element_to_set: STS_RELATION_PRODUCER [A, STS_SET [A, EQ], EQ, STS_SET_EQUALITY [A, EQ]]
--			-- Producer of relations between types derived from {A} and {STS_SET [A, EQ]}
--		deferred
--		end

--feature -- Anchor

--	inverse_anchor: STS_EQUIVALENCE [A, EQ]
--			-- <Precursor>
--		do
--			Result := Current
--		end

--invariant
--	is_reflexive: is_reflexive
--	is_symmetric: is_symmetric
--	is_transitive: is_transitive

note
	copyright: "Copyright (c) 2012-2020, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"
end
