﻿note
	description: "Set partition defined by an equivalence relation"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date$"
	revision: "$Revision$"

deferred class
	STS_SET_QUOTIENT [A, EQ -> STS_EQUALITY [A]]

--inherit

--	STS_SET_PARTITION [A, EQ]

--feature -- Access

--	equivalence: STS_EQUIVALENCE [A, EQ]
--			-- Equivalence relation defined by this set quotient
--		deferred
--		ensure
--			definition: Result.g ≍ (²(⋃ Current) ｜ˣʸ agent x_and_y_are_in_the_same_set)
--		end

--feature -- Predicate

--	x_and_y_are_in_the_same_set (x, y: A): BOOLEAN
--			-- Are `x' and `y' in the same set of this quotient?
--		do
--			Result := Current | agent {STS_SET [A, EQ]}.has (x) ≍ (Current | agent {STS_SET [A, EQ]}.has (y))
--		ensure
--		    definition: Result = (Current | agent {STS_SET [A, EQ]}.has (x) ≍ (Current | agent {STS_SET [A, EQ]}.has (y)))
--		end

note
	copyright: "Copyright (c) 2012-2020, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"
end
