﻿note
	description: "Set able to produce binary relations"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date$"
	revision: "$Revision$"

deferred class
	STS_RELATABLE_SET [A, B, EQ_A -> STS_EQUALITY [A], EQ_B -> STS_EQUALITY [B]]

--inherit

--	STS_RELATION_AWARE_SET [A, EQ_A]
--		rename
--				-- Primitive
--			eq as eq_a,
--				-- Operation
--			crossed as crossed_with_same_kind alias "×₁",
--			relations as homogeneous_relations alias "₁↔₁",
--				-- Transformation
--			mapped as mapped_to_same_kind alias "↦₁",
--			reduced as reduced_to_element_like
--		undefine
--			tuple_anchor
--		redefine
--				-- Anchor
--			set_anchor,
--			subset_anchor,
--			superset_anchor
--		end

--	STS_TRANSFORMABLE_SET [A, B, EQ_A, EQ_B]
--		rename
--				-- Factory
--			transformer as relation_producer
--		undefine
--			product_anchor,
--			square_anchor,
--			diagonal_anchor
--		redefine
--				-- Factory
--			relation_producer,
--				-- Anchor
--			set_anchor,
--			subset_anchor,
--			superset_anchor
--		end

--feature -- Operation

--	relations alias "↔" (s: STS_SET [B, EQ_B]): like relation_producer.binary_relations
--			-- Set of all binary relations between this set and `s'
--		do
--			Result := relation_producer.binary_relations (Current, s)
--		ensure
--			definition: Result ≍ relation_producer.binary_relations (Current, s)
--		end

--feature -- Transformer

--	element_to_element: STS_ENDORELATION_PRODUCER [A, EQ_A]
--			-- <Precursor>
--		deferred
--		end

--	relation_producer: STS_RELATION_PRODUCER [A, B, EQ_A, EQ_B]
--			-- Producer of relations between types derived from {A} and {B}
--		deferred
--		end

--	element_to_natural: STS_RELATION_PRODUCER [A, NATURAL, EQ_A, STS_OBJECT_EQUALITY [NATURAL]]
--			-- <Precursor>
--		deferred
--		end

--	element_to_boolean: STS_RELATION_PRODUCER [A, BOOLEAN, EQ_A, STS_OBJECT_EQUALITY [BOOLEAN]]
--			-- <Precursor>
--		deferred
--		end

--	element_to_tuple: STS_RELATION_PRODUCER [A, STS_N_TUPLE [A, EQ_A], EQ_A, STS_N_TUPLE_EQUALITY [A, EQ_A]]
--			-- <Precursor>
--		deferred
--		end

--	element_to_sets: STS_RELATION_PRODUCER [A, STS_SET [STS_SET [A, EQ_A], STS_SET_EQUALITY [A, EQ_A]], EQ_A, STS_SET_EQUALITY [STS_SET [A, EQ_A], STS_SET_EQUALITY [A, EQ_A]]]
--			-- <Precursor>
--		deferred
--		end

--	tuple_extensor: STS_RELATION_PRODUCER [STS_ORDERED_PAIR [A, STS_N_TUPLE [A, EQ_A], EQ_A, STS_N_TUPLE_EQUALITY [A, EQ_A]], STS_N_TUPLE [A, EQ_A], STS_PAIR_EQUALITY [A, STS_N_TUPLE [A, EQ_A], EQ_A, STS_N_TUPLE_EQUALITY [A, EQ_A]], STS_N_TUPLE_EQUALITY [A, EQ_A]]
--			-- <Precursor>
--		deferred
--		end

--feature -- Anchor

--	set_anchor,
--	subset_anchor,
--	superset_anchor: STS_RELATABLE_SET [A, B, EQ_A, EQ_B]
--			-- <Precursor>
--		do
--			Result := Current
--		end

note
	copyright: "Copyright (c) 2012-2020, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"
end
