﻿note
	description: "[
		Object able to relate objects derived from a generic parameter to objects derived from
		another generic parameter.
	]"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date: Sat 2018-12-01 19:25:58 -0300 $"
	revision: "$Revision$"

deferred class
	STS_RELATION_PRODUCER [A, B, EQ_A -> STS_EQUALITY [A], EQ_B -> STS_EQUALITY [B]]

--inherit

--	STS_TRANSFORMER [A, B, EQ_A, EQ_B]
--		redefine
--				-- Anchor
--			product_anchor
--		end

--feature -- Operation

--	binary_relations (xs: STS_SET [A, EQ_A]; ys: STS_SET [B, EQ_B]): STS_SET [STS_BINARY_RELATION [A, B, EQ_A, EQ_B], STS_RELATION_EQUALITY [A, B, EQ_A, EQ_B]]
--			-- Set of all binary relations between `xs' and `ys'
--		deferred
--		ensure
--			departure: Result ∀ agent departs_from_left (xs, ?)
--			arrival: Result ∀ agent arrives_upon_right (?, ys)
--			graphs: relation_to_graph.set_map (Result, agent {STS_BINARY_RELATION [A, B, EQ_A, EQ_B]}.g) ≍ 𝒫 cartesian_product (xs, ys)
--		end

--feature -- Predicate

--	departs_from_left (xs: STS_SET [A, EQ_A]; r: STS_BINARY_RELATION [A, B, EQ_A, EQ_B]): BOOLEAN
--			-- Is `xs' the departure of `r'?
--		do
--			Result := r.a ≍ xs
--		ensure
--			class
--			definition: Result = r.a ≍ xs
--		end

--	arrives_upon_right (r: STS_BINARY_RELATION [A, B, EQ_A, EQ_B]; ys: STS_SET [B, EQ_B]): BOOLEAN
--			-- Is `ys' the arrival of `r'?
--		do
--			Result := r.b ≍ ys
--		ensure
--			class
--			definition: Result = r.b ≍ ys
--		end

--feature -- Transformer

--	relation_to_graph: STS_RELATION_PRODUCER [
--		STS_BINARY_RELATION [A, B, EQ_A, EQ_B], STS_SET [STS_ORDERED_PAIR [A, B, EQ_A, EQ_B], STS_PAIR_EQUALITY [A, B, EQ_A, EQ_B]],
--		STS_RELATION_EQUALITY [A, B, EQ_A, EQ_B], STS_SET_EQUALITY [STS_ORDERED_PAIR [A, B, EQ_A, EQ_B], STS_PAIR_EQUALITY [A, B, EQ_A, EQ_B]]
--		]
--			-- Producer of relations between binary relations and sets like their graphs
--		deferred
--		end

--feature -- Anchor

--	product_anchor: STS_GRAPH [A, B, EQ_A, EQ_B]
--			-- <Precursor>
--		deferred
--		end

note
	copyright: "Copyright (c) 2012-2020, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"
end
