﻿note
	description: "[
		{EQUALITY_PROPERTIES} derived for {STS_COMPLEX_NUMBER} and
		{STS_COMPLEX_EQUALITY}
		]"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date$"
	revision: "$Revision$"

class
	COMPLEX_EQUALITY_PROPERTIES

inherit
	EQUALITY_PROPERTIES [STS_COMPLEX_NUMBER, STS_COMPLEX_EQUALITY]
		rename
			current_universe as C
		redefine
			C
		end

feature -- Access

	c: STI_COMPLEX_UNIVERSE
			-- The "Universe" of complex numbers, i.e. ℂ, or the set with
			-- every representable complex number.
		once
			Result := {STI_COMPLEX_SET}.C
		end

note
	copyright: "Copyright (c) 2012-2021, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"
end
