﻿note
	description: "(Partial) implementation of {STP_NUMERIC_SET_PROPERTIES}"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date$"
	revision: "$Revision$"

deferred class
	NUMERIC_SET_PROPERTIES [A -> STS_COMPLEX_NUMBER, EQ -> STS_NUMERIC_EQUALITY [A] create default_create end]

inherit
	STP_NUMERIC_SET_PROPERTIES [A, EQ]
		undefine
			default_create,
			has_ok,
			with_ok,
			without_ok,
			subsets_ok,
			powerset_ok,
			sp_united_ok,
			sp_intersected_ok,
			sp_subtracted_ok,
			sp_subtracted_symmetricaly_ok,
			mapped_ok,
			singleton_ok
		end

	SET_PROPERTIES [A, EQ]
		rename
			equals_ok as sp_equals_ok,
			is_subset_ok as sp_is_subset_ok,
			is_superset_ok as sp_is_superset_ok,
			is_not_superset_ok as sp_is_not_superset_ok,
			is_comparable_ok as sp_is_comparable_ok,
			is_not_comparable_ok as sp_is_not_comparable_ok,
			is_strict_subset_ok as sp_is_strict_subset_ok,
			is_strict_superset_ok as sp_is_strict_superset_ok,
			is_proper_subset_ok as sp_is_proper_subset_ok,
			is_proper_superset_ok as sp_is_proper_superset_ok,
			is_disjoint_ok as sp_is_disjoint_ok,
			complemented_ok as sp_complemented_ok,
			united_ok as sp_united_ok,
			intersected_ok as sp_intersected_ok,
			subtracted_ok as sp_subtracted_ok,
			subtracted_symmetricaly_ok as sp_subtracted_symmetricaly_ok
		undefine
			default_create,
			make_empty_ok,
			make_singleton_ok,
			make_extended_ok,
			set_anchor,
			universe_anchor
		end

feature -- Anchor

	set_anchor,
	universe_anchor: STI_NUMERIC_SET [A, EQ]
			-- <Precursor>
		deferred
		end

note
	copyright: "Copyright (c) 2012-2021, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"
end
