﻿note
	description: "[
		{SETS_TESTS_RESOURCES_BINARY} whose first and second generic parameters are, respectively, a set of sets and a set.
		]"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date$"
	revision: "$Revision$"

deferred class
	SETS_TESTS_RESOURCES_BINARY_SSA_SA [A, EQ -> STS_EQUALITY [A] create default_create end]

inherit
	SETS_TESTS_RESOURCES_BINARY [
		STS_SET [STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ]], STS_SET [A, EQ],
		STS_SET_EQUALITY [STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ]], STS_SET_EQUALITY [A, EQ]
		]
		rename
			resources_b as resources_sa,
			eq_a as eq_ssa,
			eq_b as eq_sa,
			some_object_a as some_set_sa,
			same_object_a as same_set_sa,
			object_twin_a as set_twin_sa,
			new_eq_a as new_eq_ssa,
			new_reference_equality_a as new_reference_equality_ssa,
			new_object_equality_a as new_object_equality_ssa,
			new_reference_equality_aa as new_reference_equality_ssa_ssa,
			new_object_equality_aa as new_object_equality_ssa_ssa,
			new_pair_equality_aa as new_pair_equality_ssa_ssa,
			new_reference_equality_ab as new_reference_equality_ssa_sa,
			new_object_equality_ab as new_object_equality_ssa_sa,
			new_pair_equality_ab as new_pair_equality_ssa_sa,
			new_reference_equality_ba as new_reference_equality_sa_ssa,
			new_object_equality_ba as new_object_equality_sa_ssa,
			new_pair_equality_ba as new_pair_equality_sa_ssa,
			new_reference_equality_sa as new_reference_equality_sssa,
			new_object_equality_sa as new_object_equality_sssa,
			new_set_equality_a as new_set_equality_ssa,
			new_reference_equality_ta as new_reference_equality_tssa,
			new_object_equality_ta as new_object_equality_tssa,
			new_n_tuple_equality_a as new_n_tuple_equality_ssa,
			some_preceding_pair_dsa_a as some_preceding_pair_dsa_ssa,
			some_pair_aa as some_pair_ssa_ssa,
			new_pair_aa as new_pair_ssa_ssa,
			some_preceding_pair_aa as some_preceding_pair_ssa_ssa,
			new_composable_pair_aaa as new_composable_pair_ssa_ssa_ssa,
			new_homogeneous_pair_a as new_homogeneous_pair_ssa,
			new_pair_a_ta as new_pair_ssa_tssa,
			some_pair_ab as some_pair_ssa_sa,
			new_pair_ab as new_pair_ssa_sa,
			same_pair_ab as same_pair_ssa_sa,
			some_pair_ba as some_pair_sa_ssa,
			new_pair_ba as new_pair_sa_ssa,
			some_preceding_pair_ba as some_preceding_pair_sa_ssa,
			some_pair_bb as some_pair_sa_sa,
			some_preceding_pair_bb as some_preceding_pair_sa_sa,
			new_composable_pair_aab as new_composable_pair_ssa_ssa_sa,
			new_composable_pair_aba as new_composable_pair_ssa_sa_ssa,
			new_composable_pair_abb as new_composable_pair_ssa_sa_sa,
			new_composable_pair_baa as new_composable_pair_sa_ssa_ssa,
			new_composable_pair_bab as new_composable_pair_sa_ssa_sa,
			new_composable_pair_bba as new_composable_pair_sa_sa_ssa,
			new_references_a as new_references_ssa,
			new_objects_a as new_objects_ssa,
			some_set_a as some_set_ssa,
			new_set_a as new_set_ssa,
			new_transformable_set_aa as new_transformable_set_ssa_ssa,
			same_set_a as same_set_ssa,
			some_transformable_set_ab as some_transformable_set_ssa_sa,
			same_transformable_set_ab as same_transformable_set_ssa_sa,
			some_direct_transformable_set_ab as some_direct_transformable_set_ssa_sa,
			new_transformable_set_ab as new_transformable_set_ssa_sa,
			some_transformable_set_ba as some_transformable_set_sa_ssa,
			new_references_aa as new_references_ssa_ssa,
			new_objects_aa as new_objects_ssa_ssa,
			new_math_set_aa as new_math_set_ssa_ssa,
			new_transformable_set_aa_a as new_transformable_set_ssa_ssa_ssa,
			new_set_of_pairs_aa as new_set_of_pairs_ssa_ssa,
			some_set_ab as some_set_ssa_sa,
			some_references_ab as some_references_ssa_sa,
			new_references_ab as new_references_ssa_sa,
			some_objects_ab as some_objects_ssa_sa,
			new_objects_ab as new_objects_ssa_sa,
			some_math_set_ab as some_math_set_ssa_sa,
			new_math_set_ab as new_math_set_ssa_sa,
			some_set_of_pairs_ab as some_set_of_pairs_ssa_sa,
			some_direct_set_of_pairs_ab as some_direct_set_of_pairs_ssa_sa,
			new_set_of_pairs_ab as new_set_of_pairs_ssa_sa,
			new_transformable_set_ab_a as new_transformable_set_ssa_sa_ssa,
			new_transformable_set_ab_b as new_transformable_set_ssa_sa_sa,
			new_references_ba as new_references_sa_ssa,
			new_objects_ba as new_objects_sa_ssa,
			new_math_set_ba as new_math_set_sa_ssa,
			new_set_of_pairs_ba as new_set_of_pairs_sa_ssa,
			new_transformable_set_ba_a as new_transformable_set_sa_ssa_ssa,
			new_transformable_set_ba_b as new_transformable_set_sa_ssa_sa,
			new_references_bb as new_references_sa_sa,
			new_objects_bb as new_objects_sa_sa,
			new_math_set_bb as new_math_set_sa_sa,
			new_set_of_pairs_bb as new_set_of_pairs_sa_sa,
			new_transformable_set_bb_b as new_transformable_set_sa_sa_sa,
			new_references_sb as new_references_ssa,
			new_objects_sb as new_objects_ssa,
			new_math_set_sb as new_math_set_ssa,
			new_transformable_set_sb_tb as new_transformable_set_ssa_tsa,
			new_references_tb as new_references_tsa,
			new_objects_tb as new_objects_tsa,
			new_math_set_tb as new_math_set_tsa,
			new_transformable_set_tb_sb as new_transformable_set_tsa_ssa,
			some_set_sa as some_set_sssa,
			some_references_sa as some_references_sssa,
			new_references_sa as new_references_sssa,
			some_objects_sa as some_objects_sssa,
			new_objects_sa as new_objects_sssa,
			some_math_set_sa as some_math_set_sssa,
			new_math_set_sa as new_math_set_sssa,
			new_transformable_set_sa_ta as new_transformable_set_sssa_tssa,
			some_set_of_sets_a as some_set_of_sets_ssa,
			some_set_family_a as some_set_family_ssa,
			some_direct_set_family_a as some_direct_set_family_ssa,
			new_set_family_a as new_set_family_ssa,
			some_set_partition_a as some_set_partition_ssa,
			some_direct_set_partition_a as some_direct_set_partition_ssa,
			new_set_partition_a as new_set_partition_ssa,
			partitioned_set_a as partitioned_set_ssa,
			some_subset_family_a as some_subset_family_ssa,
			some_direct_subset_family_a as some_direct_subset_family_ssa,
			new_subset_family_a as new_subset_family_ssa,
			same_subset_family_a as same_subset_family_ssa,
			some_subset_family_structure_a as some_subset_family_structure_ssa,
			some_direct_subset_family_structure_a as some_direct_subset_family_structure_ssa,
			new_subset_family_structure_a as new_subset_family_structure_ssa,
			some_set_b as some_set_sa,
			new_set_family_b as new_set_family_sa,
			new_set_partition_b as new_set_partition_sa,
			new_subset_family_b as new_subset_family_sa,
			new_transformable_set_ba as new_transformable_set_sa_ssa,
			some_set_ta as some_set_tssa,
			some_references_ta as some_references_tssa,
			new_references_ta as new_references_tssa,
			some_objects_ta as some_objects_tssa,
			new_objects_ta as new_objects_tssa,
			some_math_set_ta as some_math_set_tssa,
			new_math_set_ta as new_math_set_tssa,
			new_transformable_set_ta_sa as new_transformable_set_tssa_sssa,
			new_pair_composer_aaa as new_pair_composer_ssa_ssa_ssa,
			new_pair_composer_aab as new_pair_composer_ssa_ssa_sa,
			new_pair_composer_aba as new_pair_composer_ssa_sa_ssa,
			new_pair_composer_abb as new_pair_composer_ssa_sa_sa,
			new_pair_composer_baa as new_pair_composer_sa_ssa_ssa,
			new_pair_composer_bab as new_pair_composer_sa_ssa_sa,
			new_pair_composer_bba as new_pair_composer_sa_sa_ssa,
			new_transformer_aa as new_transformer_ssa_ssa,
			new_transformer_ab as new_transformer_ssa_sa,
			new_transformer_ba as new_transformer_sa_ssa,
			some_n_tuple_a as some_n_tuple_ssa,
			new_n_tuple_a as new_n_tuple_ssa,
			new_transformable_tuple_aa as new_transformable_tuple_ssa_ssa,
			same_n_tuple_a as same_n_tuple_ssa,
			new_n_tuple_sa as new_n_tuple_sssa,
			new_n_tuple_sb as new_n_tuple_ssa,
			new_transformable_tuple_sa_ta as new_transformable_tuple_sssa_tssa,
			new_set_tuple_a as new_set_tuple_ssa,
			some_n_tuple_b as some_n_tuple_sa,
			new_set_tuple_b as new_set_tuple_sa,
			new_transformable_tuple_ab as new_transformable_tuple_ssa_sa,
			new_transformable_tuple_ba as new_transformable_tuple_sa_ssa,
			new_transformable_tuple_sb_tb as new_transformable_tuple_ssa_tsa,
			some_direct_transformable_tuple_ab as some_direct_transformable_tuple_ssa_sa,
			some_direct_transformable_tuple_ba as some_direct_transformable_tuple_sa_ssa
		undefine
			same_set_sa
		redefine
			new_references_ssa,
			new_objects_ssa,
			new_n_tuple_ssa
		end

	SETS_TESTS_RESOURCES_UNARY_SSA [A, EQ]
		rename
			f_x as f_x_to_same_kind,
			f_acc_x as f_acc_x_to_same_kind,
			f_x_acc as f_x_acc_to_same_kind,
			f_acc_i_x as f_acc_i_x_to_same_kind,
			f_i_x_acc as f_i_x_acc_to_same_kind
		undefine
			some_equality,
			some_pair,
			some_pair_ssa_ssa,
			some_pair_composer,
			some_transformer,
			some_set,
			some_set_sa,
			some_set_ssa,
			same_set_ssa,
			some_n_tuple,
			some_n_tuple_ssa,
			same_n_tuple_ssa
		redefine
			new_references_ssa,
			new_objects_ssa,
			new_n_tuple_ssa
		end

feature -- Access

	resources_sa: SETS_TESTS_RESOURCES_UNARY_SA [A, EQ]
			-- Pool of features for sets of elements like {A}
		deferred
		end

feature -- Factory (set)

	new_references_ssa: STI_SET [STS_SET [STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ]], STS_REFERENCE_EQUALITY [STS_SET [STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ]]]]
			-- Randomly created monomorphic set of sets of sets of elements like {A}, which are (the member sets of sets) compared by their object references.
		do
			across
				1 |..| some_count.as_integer_32 as i
			from
				create Result.make_empty
			loop
				Result := Result & some_set_sa
			end
		end

	new_objects_ssa: STI_SET [STS_SET [STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ]], STS_OBJECT_EQUALITY [STS_SET [STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ]]]]
			-- Randomly created monomorphic set of sets of sets of elements like {A}, which are (the member sets of sets) compared by their object values.
		do
			across
				1 |..| some_count.as_integer_32 as i
			from
				create Result.make_empty
			loop
				Result := Result & some_set_sa
			end
		end

feature -- Factory (n-tuple)

	new_n_tuple_ssa: like some_n_tuple_ssa
			-- Randomly created monomorphic n-tuple of sets of sets of elements like {A}
		do
			across
				1 |..| some_count.as_integer_32 as i
			from
				create Result.make_unit
			loop
				Result := Result.after (some_set_sa)
			end
		end

feature -- Mapping
	-- todo: explain.

	f_x (x: STS_SET [STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ]]): STS_SET [A, EQ]
			-- Function that maps `x` to a set of elements like {A}
		do
			Result := x.reduced (resources_sa.some_set_a.o, agent resources_sa.f_acc_x) -- todo: define an `o' feature?
		end

feature -- Reduction
	-- todo: explain.

	f_acc_x (acc: STS_SET [A, EQ]; x: STS_SET [STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ]]): STS_SET [A, EQ]
			-- Function that reduces (`acc`, `x`) to a set of elements like {A}
		do
			Result := x.reduced (acc, agent resources_sa.f_acc_x)
		end

	f_acc_i_x (acc: STS_SET [A, EQ]; i: NATURAL_32; x: STS_SET [STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ]]): STS_SET [A, EQ]
			-- Function that reduces (`acc`, `i`, `x`) to a set of elements like {A}
		do
			Result := x.reduced (acc, agent resources_sa.f_acc_i_x (?, i, ?))
		end

note
	copyright: "Copyright (c) 2012-2021, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"
end
