note
	description: "[
		{SETS_TESTS_RESOURCES_BINARY_SSA_SA}, derived for {detachable INTEGER_REF} generic parameter, compared by object value.
		]"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date$"
	revision: "$Revision$"

class
	SETS_TESTS_RESOURCES_BINARY_SSI_SI

inherit
	SETS_TESTS_RESOURCES_BINARY_SSA_SA [detachable INTEGER_REF, STS_OBJECT_EQUALITY [detachable INTEGER_REF]]
		redefine
			on_prepare
		end

	SETS_TESTS_RESOURCES_UNARY_SSI
		rename
			f_x as f_x_to_same_kind,
			f_acc_x as f_acc_x_to_same_kind,
			f_x_acc as f_x_acc_to_same_kind,
			f_acc_i_x as f_acc_i_x_to_same_kind,
			f_i_x_acc as f_i_x_acc_to_same_kind
		undefine
			some_equality,
			some_pair,
			some_pair_ssa_ssa,
			some_pair_composer,
			some_transformer,
			some_set,
			new_references_ssa,
			new_objects_ssa,
			some_set_sa,
			some_set_ssa,
			same_set_ssa,
			some_n_tuple,
			some_n_tuple_ssa,
			new_n_tuple_ssa,
			same_n_tuple_ssa
		redefine
			on_prepare
		end

feature {NONE} -- Events

	on_prepare
			-- <Precursor>
		do
			Precursor {SETS_TESTS_RESOURCES_UNARY_SSI}
			create eq_sa
		end

note
	copyright: "Copyright (c) 2012-2021, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"
end
