note
	description: "[
		{SETS_TESTS_RESOURCES_TERNARY}, derived for {detachable INTEGER_REF}, {detachable INTEGER_REF} and {detachable INTEGER_REF} generic parameters,
		all of them compared by object value.
		]"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date: Sat 2018-11-10 18:52:01 -0300 $"
	revision: "$Revision$"
	testing: "type/manual"

class
	SETS_TESTS_RESOURCES_TERNARY_III

inherit
	SETS_TESTS_RESOURCES_TERNARY [
		detachable INTEGER_REF, detachable INTEGER_REF, detachable INTEGER_REF,
		STS_OBJECT_EQUALITY [detachable INTEGER_REF], STS_OBJECT_EQUALITY [detachable INTEGER_REF], STS_OBJECT_EQUALITY [detachable INTEGER_REF]
		]
		rename
			some_object_a as some_integer_ref
		redefine
			on_prepare
		end

	SETS_TESTS_RESOURCES_BINARY_II
		undefine
			some_equality,
			some_pair,
			some_preceding_pair_dsa_a,
			some_pair_aa,
			some_preceding_pair_aa,
			some_pair_ab,
			same_pair_ab,
			some_pair_ba,
			some_preceding_pair_ba,
			some_pair_bb,
			some_preceding_pair_bb,
			some_set,
			some_set_a,
			same_set_a,
			some_set_b,
			some_pair_composer,
			some_transformer,
			some_n_tuple,
			some_n_tuple_a,
			same_n_tuple_a,
			some_n_tuple_b
		redefine
			on_prepare
		end

feature -- Access

	resources_wa: SETS_TESTS_RESOURCES_BINARY_II
			-- Pool of features for ordered pairs of integer references

	resources_wb: SETS_TESTS_RESOURCES_BINARY_II
			-- Pool of features for ordered pairs of integer references

feature {NONE} -- Events

	on_prepare
			-- <Precursor>
		do
			Precursor {SETS_TESTS_RESOURCES_BINARY_II}
			create resources_wa
			create resources_wb
			create eq_w
		end

note
	copyright: "Copyright (c) 2012-2021, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"

end
