note
	description: "[
		{SETS_TESTS_RESOURCES_UNARY_SA}, derived for {detachable INTEGER_REF} generic parameter, compared by object value.
		]"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date: Sat 2018-11-10 18:52:01 -0300 $"
	revision: "$Revision$"
	testing: "type/manual"

class
	SETS_TESTS_RESOURCES_UNARY_SI

inherit
	SETS_TESTS_RESOURCES_UNARY_SA [detachable INTEGER_REF, STS_OBJECT_EQUALITY [detachable INTEGER_REF]]
		redefine
			on_prepare
		end

feature {NONE} -- Events

	on_prepare
			-- <Precursor>
		do
			create resources_a
			create eq_sa
		end

feature -- Access

	resources_a: SETS_TESTS_RESOURCES_TERNARY_NIC
			-- Pool of features for integer references

feature {SET_PROPERTIES} -- Implementation

	max_asserted_elements: NATURAL = 209_715 -- 2 ^ 20 // Max_count
			-- <Precursor>

note
	copyright: "Copyright (c) 2012-2021, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"

end
