﻿note
	description: "Test suite for features that {STI_SUBSET_FAMILY_STRUCTURE} inherit from {STI_ORDERED_PAIR}"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date$"
	revision: "$Revision$"

deferred class
	SUBSET_FAMILY_STRUCTURE_TESTS_FOR_ORDERED_PAIR [A, EQ -> STS_EQUALITY [A] create default_create end]

inherit
	ORDERED_PAIR_TESTS [
		STS_SET [STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ]], STS_SET [A, EQ],
		STS_SET_EQUALITY [STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ]], STS_SET_EQUALITY [A, EQ]
		]
		rename
			test_make as test_make_pair,
			test_a as test_sf,
			test_first as test_subset_family,
			test_b as test_s,
			test_second as test_superset,
			test_eq_a as test_eq_ss,
			test_eq_b as test_eq_s,
			pair_to_be_tested as subset_family_structure_to_be_tested,
			resources_b as resources_sa,
			eq_a as eq_ssa,
			eq_b as eq_sa,
			some_object_a as some_set_sa,
			same_object_a as same_set_sa,
			object_twin_a as set_twin_sa,
			new_eq_a as new_eq_ssa,
			new_reference_equality_a as new_reference_equality_ssa,
			new_object_equality_a as new_object_equality_ssa,
			new_reference_equality_aa as new_reference_equality_ssa_ssa,
			new_object_equality_aa as new_object_equality_ssa_ssa,
			new_pair_equality_aa as new_pair_equality_ssa_ssa,
			new_reference_equality_ab as new_reference_equality_ssa_sa,
			new_object_equality_ab as new_object_equality_ssa_sa,
			new_pair_equality_ab as new_pair_equality_ssa_sa,
			new_reference_equality_ba as new_reference_equality_sa_ssa,
			new_object_equality_ba as new_object_equality_sa_ssa,
			new_pair_equality_ba as new_pair_equality_sa_ssa,
			new_reference_equality_sa as new_reference_equality_sssa,
			new_object_equality_sa as new_object_equality_sssa,
			new_set_equality_a as new_set_equality_ssa,
			new_reference_equality_ta as new_reference_equality_tssa,
			new_object_equality_ta as new_object_equality_tssa,
			new_n_tuple_equality_a as new_n_tuple_equality_ssa,
			some_preceding_pair_dsa_a as some_preceding_pair_dsa_ssa,
			some_pair_aa as some_pair_ssa_ssa,
			new_pair_aa as new_pair_ssa_ssa,
			some_preceding_pair_aa as some_preceding_pair_ssa_ssa,
			new_composable_pair_aaa as new_composable_pair_ssa_ssa_ssa,
			new_homogeneous_pair_a as new_homogeneous_pair_ssa,
			new_pair_a_ta as new_pair_ssa_tssa,
			some_pair_ab as some_pair_ssa_sa,
			new_pair_ab as new_pair_ssa_sa,
			same_pair_ab as same_pair_ssa_sa,
			some_pair_ba as some_pair_sa_ssa,
			new_pair_ba as new_pair_sa_ssa,
			some_preceding_pair_ba as some_preceding_pair_sa_ssa,
			some_pair_bb as some_pair_sa_sa,
			some_preceding_pair_bb as some_preceding_pair_sa_sa,
			new_composable_pair_aab as new_composable_pair_ssa_ssa_sa,
			new_composable_pair_aba as new_composable_pair_ssa_sa_ssa,
			new_composable_pair_abb as new_composable_pair_ssa_sa_sa,
			new_composable_pair_baa as new_composable_pair_sa_ssa_ssa,
			new_composable_pair_bab as new_composable_pair_sa_ssa_sa,
			new_composable_pair_bba as new_composable_pair_sa_sa_ssa,
			new_references_a as new_references_ssa,
			new_objects_a as new_objects_ssa,
			some_set_a as some_set_ssa,
			new_set_a as new_set_ssa,
			new_transformable_set_aa as new_transformable_set_ssa_ssa,
			same_set_a as same_set_ssa,
			some_transformable_set_ab as some_transformable_set_ssa_sa,
			same_transformable_set_ab as same_transformable_set_ssa_sa,
			some_direct_transformable_set_ab as some_direct_transformable_set_ssa_sa,
			new_transformable_set_ab as new_transformable_set_ssa_sa,
			some_transformable_set_ba as some_transformable_set_sa_ssa,
			new_references_aa as new_references_ssa_ssa,
			new_objects_aa as new_objects_ssa_ssa,
			new_math_set_aa as new_math_set_ssa_ssa,
			new_transformable_set_aa_a as new_transformable_set_ssa_ssa_ssa,
			new_set_of_pairs_aa as new_set_of_pairs_ssa_ssa,
			some_set_ab as some_set_ssa_sa,
			some_references_ab as some_references_ssa_sa,
			new_references_ab as new_references_ssa_sa,
			some_objects_ab as some_objects_ssa_sa,
			new_objects_ab as new_objects_ssa_sa,
			some_math_set_ab as some_math_set_ssa_sa,
			new_math_set_ab as new_math_set_ssa_sa,
			some_set_of_pairs_ab as some_set_of_pairs_ssa_sa,
			some_direct_set_of_pairs_ab as some_direct_set_of_pairs_ssa_sa,
			new_set_of_pairs_ab as new_set_of_pairs_ssa_sa,
			new_transformable_set_ab_a as new_transformable_set_ssa_sa_ssa,
			new_transformable_set_ab_b as new_transformable_set_ssa_sa_sa,
			new_references_ba as new_references_sa_ssa,
			new_objects_ba as new_objects_sa_ssa,
			new_math_set_ba as new_math_set_sa_ssa,
			new_set_of_pairs_ba as new_set_of_pairs_sa_ssa,
			new_transformable_set_ba_a as new_transformable_set_sa_ssa_ssa,
			new_transformable_set_ba_b as new_transformable_set_sa_ssa_sa,
			new_references_bb as new_references_sa_sa,
			new_objects_bb as new_objects_sa_sa,
			new_math_set_bb as new_math_set_sa_sa,
			new_set_of_pairs_bb as new_set_of_pairs_sa_sa,
			new_transformable_set_bb_b as new_transformable_set_sa_sa_sa,
			new_references_sb as new_references_ssa,
			new_objects_sb as new_objects_ssa,
			new_math_set_sb as new_math_set_ssa,
			new_transformable_set_sb_tb as new_transformable_set_ssa_tsa,
			new_references_tb as new_references_tsa,
			new_objects_tb as new_objects_tsa,
			new_math_set_tb as new_math_set_tsa,
			new_transformable_set_tb_sb as new_transformable_set_tsa_ssa,
			some_set_sa as some_set_sssa,
			some_references_sa as some_references_sssa,
			new_references_sa as new_references_sssa,
			some_objects_sa as some_objects_sssa,
			new_objects_sa as new_objects_sssa,
			some_math_set_sa as some_math_set_sssa,
			new_math_set_sa as new_math_set_sssa,
			new_transformable_set_sa_ta as new_transformable_set_sssa_tssa,
			some_set_of_sets_a as some_set_of_sets_ssa,
			some_set_family_a as some_set_family_ssa,
			some_direct_set_family_a as some_direct_set_family_ssa,
			new_set_family_a as new_set_family_ssa,
			some_set_partition_a as some_set_partition_ssa,
			some_direct_set_partition_a as some_direct_set_partition_ssa,
			new_set_partition_a as new_set_partition_ssa,
			partitioned_set_a as partitioned_set_ssa,
			some_subset_family_a as some_subset_family_ssa,
			some_direct_subset_family_a as some_direct_subset_family_ssa,
			new_subset_family_a as new_subset_family_ssa,
			same_subset_family_a as same_subset_family_ssa,
			some_subset_family_structure_a as some_subset_family_structure_ssa,
			some_direct_subset_family_structure_a as some_direct_subset_family_structure_ssa,
			new_subset_family_structure_a as new_subset_family_structure_ssa,
			some_set_b as some_set_sa,
			new_set_family_b as new_set_family_sa,
			new_set_partition_b as new_set_partition_sa,
			new_subset_family_b as new_subset_family_sa,
			new_transformable_set_ba as new_transformable_set_sa_ssa,
			some_set_ta as some_set_tssa,
			some_references_ta as some_references_tssa,
			new_references_ta as new_references_tssa,
			some_objects_ta as some_objects_tssa,
			new_objects_ta as new_objects_tssa,
			some_math_set_ta as some_math_set_tssa,
			new_math_set_ta as new_math_set_tssa,
			new_transformable_set_ta_sa as new_transformable_set_tssa_sssa,
			new_pair_composer_aaa as new_pair_composer_ssa_ssa_ssa,
			new_pair_composer_aab as new_pair_composer_ssa_ssa_sa,
			new_pair_composer_aba as new_pair_composer_ssa_sa_ssa,
			new_pair_composer_abb as new_pair_composer_ssa_sa_sa,
			new_pair_composer_baa as new_pair_composer_sa_ssa_ssa,
			new_pair_composer_bab as new_pair_composer_sa_ssa_sa,
			new_pair_composer_bba as new_pair_composer_sa_sa_ssa,
			new_transformer_aa as new_transformer_ssa_ssa,
			new_transformer_ab as new_transformer_ssa_sa,
			new_transformer_ba as new_transformer_sa_ssa,
			some_n_tuple_a as some_n_tuple_ssa,
			new_n_tuple_a as new_n_tuple_ssa,
			new_transformable_tuple_aa as new_transformable_tuple_ssa_ssa,
			same_n_tuple_a as same_n_tuple_ssa,
			new_n_tuple_sa as new_n_tuple_sssa,
			new_n_tuple_sb as new_n_tuple_ssa,
			new_transformable_tuple_sa_ta as new_transformable_tuple_sssa_tssa,
			new_set_tuple_a as new_set_tuple_ssa,
			some_n_tuple_b as some_n_tuple_sa,
			new_set_tuple_b as new_set_tuple_sa,
			new_transformable_tuple_ab as new_transformable_tuple_ssa_sa,
			new_transformable_tuple_ba as new_transformable_tuple_sa_ssa,
			new_transformable_tuple_sb_tb as new_transformable_tuple_ssa_tsa,
			some_direct_transformable_tuple_ab as some_direct_transformable_tuple_ssa_sa,
			some_direct_transformable_tuple_ba as some_direct_transformable_tuple_sa_ssa,
			pair_from_ab as pair_from_ssa_sa,
			pair_from_aab as pair_from_ssa_ssa_sa,
			pair_from_bab as pair_from_sa_ssaa_sa
		undefine
			same_set_sa,
			new_references_ssa,
			new_objects_ssa,
			new_n_tuple_ssa
		redefine
			test_make_pair,
			test_make_from_pair,
			test_equals,
			subset_family_structure_to_be_tested,
			pair_from_ssa_sa,
			pair_from_ssa_ssa_sa,
			pair_from_sa_ssaa_sa
		end

	SETS_TESTS_RESOURCES_BINARY_SSA_SA [A, EQ]

feature -- Access

	resources_sa: SETS_TESTS_RESOURCES_UNARY_SA [A, EQ]
			-- Pool of features for sets of elements like {A}
		deferred
		end

	properties: SUBSET_FAMILY_STRUCTURE_PROPERTIES [A, EQ]
			-- Object that checks the set-theory properties of {STI_SUBSET_FAMILY_STRUCTURE}
		deferred
		end

feature -- Test routines (Initialization)

	test_make_pair
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.make_pair.
		note
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.make_pair"
		local
			make_pair_got_rescued: PREDICATE [like subset_family_structure_to_be_tested, like some_set_sa, like some_set_sa, like some_set_a, like some_set_a]
			sf: like subset_family_structure_to_be_tested
			ss0, ss: like some_set_sa
			s0, s: like some_set_a
			chk_ops: BOOLEAN
		do
			make_pair_got_rescued := agent
				(ia_sf: like subset_family_structure_to_be_tested; ia_ss0, ia_ss: like some_set_sa; ia_s0, ia_s: like some_set_a): BOOLEAN
				require
					keep_non_emptiness: ia_ss.is_empty implies ia_sf.is_empty
					consistent_superset: ia_sf.converted (ia_ss).superset ⊆ ia_s
				local
					ss0_s0_have_failed, ss0_s_have_failed, ss_s0_have_failed: BOOLEAN
				do
					if not ss0_s0_have_failed then
						ia_sf.make_pair (ia_ss0, ia_s0)
					elseif not ss0_s_have_failed then
						ia_sf.make_pair (ia_ss0, ia_s)
					elseif not ss_s0_have_failed then
						ia_sf.make_pair (ia_ss, ia_s0)
					else
						ia_sf.make_pair (ia_ss, ia_s)
					end
					Result := True
				ensure
					ss0_s0: (ia_ss0.is_empty implies old ia_sf.is_empty) and
						ia_sf.converted (ia_ss0).superset ⊆ ia_s0 implies
						ia_sf.set_equals (ia_ss0) and ia_sf.s ≍ ia_s0
					ss0_s: (ia_ss0.is_empty implies old ia_sf.is_empty) and
						ia_sf.converted (ia_ss0).superset ⊈ ia_s0 and
						ia_sf.converted (ia_ss0).superset ⊆ ia_s implies
						ia_sf.set_equals (ia_ss0) and ia_sf.s ≍ ia_s
					ss_s0: (
						ia_ss0.is_empty and not old ia_sf.is_empty or
						ia_sf.converted (ia_ss0).superset ⊈ ia_s0 and ia_sf.converted (ia_ss0).superset ⊈ ia_s
						) and
						ia_sf.converted (ia_ss).superset ⊆ ia_s0 implies
						ia_sf.set_equals (ia_ss) and ia_sf.s ≍ ia_s0
					ss_s: (
						ia_ss0.is_empty and not old ia_sf.is_empty or
						ia_sf.converted (ia_ss0).superset ⊈ ia_s0 and ia_sf.converted (ia_ss0).superset ⊈ ia_s
						) and
						ia_sf.converted (ia_ss).superset ⊈ ia_s0 implies
						ia_sf.set_equals (ia_ss) and ia_sf.s ≍ ia_s
				rescue
					print (ia_sf) print (", ")
					print (ia_ss0) print (", ")
					print (ia_ss) print (", ")
					print (ia_s0) print (", ")
					print (ia_s) print ('%N')
					if not ss0_s0_have_failed then
						ss0_s0_have_failed := True
						retry
					end
					if not ss0_s_have_failed then
						ss0_s_have_failed := True
						retry
					end
					if not ss_s0_have_failed then
						ss_s0_have_failed := True
						retry
					end
				end

			from
				sf := subset_family_structure_to_be_tested
			until
				not sf.is_empty
			loop
				sf := subset_family_structure_to_be_tested
			end
			ss0 := some_set_sa.o
			s0 := some_set_a
			from
				ss := some_set_sa
			until
				ss.is_empty implies sf.is_empty
			loop
				ss := some_set_sa
			end

			chk_ops := {ISE_RUNTIME}.check_assert (False)
				s := some_set_a ∪ sf.converted (ss).superset
			chk_ops := {ISE_RUNTIME}.check_assert (chk_ops)

			assert ("consistent_superset", sf.converted (ss).superset ⊆ s) -- s := some_set_a ∪ sf.converted (ss).superset
			assert ("ss0_violates_keep_non_emptiness", make_pair_got_rescued (sf, ss0, ss, s0, s))

			from
				sf := subset_family_structure_to_be_tested
			until
				not sf.is_empty
			loop
				sf := subset_family_structure_to_be_tested
			end

			chk_ops := {ISE_RUNTIME}.check_assert (False)
				from
					ss0 := some_set_sa
				until
					not (ss0 |∀ agent {STS_SET [A, EQ]}.is_empty)
				loop
					ss0 := some_set_sa
				end
				from
					s0 := some_set_a
				until
					sf.converted (ss0).superset ⊈ s0
				loop
					s0 := some_set_a
				end
			chk_ops := {ISE_RUNTIME}.check_assert (chk_ops)

			from
				ss := some_set_sa
			until
				ss.is_empty implies sf.is_empty
			loop
				ss := some_set_sa
			end

			chk_ops := {ISE_RUNTIME}.check_assert (False)
				s := some_set_a ∪ sf.converted (ss).superset
			chk_ops := {ISE_RUNTIME}.check_assert (chk_ops)

			assert ("consistent_superset", sf.converted (ss).superset ⊆ s) -- s := some_set_a ∪ sf.converted (ss).superset
			assert ("ss0_s0_violates_consistent_superset", make_pair_got_rescued (sf, ss0, ss, s0, s))

			from
				sf := subset_family_structure_to_be_tested
			until
				not sf.is_empty
			loop
				sf := subset_family_structure_to_be_tested
			end

			chk_ops := {ISE_RUNTIME}.check_assert (False)
				from
					from
						ss := some_set_sa
					until
						ss.is_empty implies sf.is_empty
					loop
						ss := some_set_sa
					end
					s := some_set_a ∪ sf.converted (ss).superset
					ss0 := some_set_sa
				until
					not ss0.is_empty and sf.converted (ss0).superset ⊈ s
				loop
					from
						ss := some_set_sa
					until
						ss.is_empty implies sf.is_empty
					loop
						ss := some_set_sa
					end
					s := some_set_a ∪ sf.converted (ss).superset
					ss0 := some_set_sa
				end
				from
					s0 := some_set_a
				until
					sf.converted (ss0).superset ⊈ s0
				loop
					s0 := some_set_a
				end
			chk_ops := {ISE_RUNTIME}.check_assert (chk_ops)

			assert ("consistent_superset", sf.converted (ss).superset ⊆ s) -- s := s ∪ sf.converted (ss).superset
			assert ("ss0_s_violates_consistent_superset", make_pair_got_rescued (sf, ss0, ss, s0, s))

			from
				sf := subset_family_structure_to_be_tested
			until
				not sf.is_empty
			loop
				sf := subset_family_structure_to_be_tested
			end

			chk_ops := {ISE_RUNTIME}.check_assert (False)
				from
					ss := some_set_sa
				until
					not (ss |∀ agent {STS_SET [A, EQ]}.is_empty)
				loop
					ss := some_set_sa
				end
				s := some_set_a ∪ sf.converted (ss).superset
				from
					ss0 := some_set_sa
				until
					not (ss0 |∀ agent {STS_SET [A, EQ]}.is_empty)
				loop
					ss0 := some_set_sa
				end
				from
					s0 := some_set_a
				until
					sf.converted (ss0).superset ⊈ s0 and sf.converted (ss).superset ⊈ s0
				loop
					s0 := some_set_a
				end
			chk_ops := {ISE_RUNTIME}.check_assert (chk_ops)

			assert ("keep_non_emptiness", ss.is_empty implies sf.is_empty) -- not ss.is_empty
			assert ("consistent_superset", sf.converted (ss).superset ⊆ s) -- s := some_set_a ∪ sf.converted (ss).superset
			assert ("ss_s0_violates_consistent_superset", make_pair_got_rescued (sf, ss0, ss, s0, s))

			sf := subset_family_structure_to_be_tested
			s0 := some_set_a
			ss0 := some_set_sa
			if sf.is_empty then
				ss0 := ss0.o
			end
			from
				ss := some_set_sa
			until
				ss.is_empty implies sf.is_empty
			loop
				ss := some_set_sa
			end

			chk_ops := {ISE_RUNTIME}.check_assert (False)
				s := some_set_a ∪ sf.converted (ss).superset
			chk_ops := {ISE_RUNTIME}.check_assert (chk_ops)

			assert ("consistent_superset", sf.converted (ss).superset ⊆ s) -- s := some_set_a ∪ sf.converted (ss).superset
			assert ("make_pair", make_pair_got_rescued (sf, ss0, ss, s0, s))
		end

	test_make_from_pair
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.make_from_pair.
		note
			testing: "covers/{STI_SUBSET_FAMILY_STRUCTURE}.make_from_pair"
		local
			sf: like subset_family_structure_to_be_tested
			ss0, ss: like some_set_sa
			s0, s: like some_set_a
			chk_ops: BOOLEAN
		do
--			create sf.make_empty (
--				create {like subset_family_structure_to_be_tested.superset -- TODO: subset_family_structure_to_be_tested.superset is deferred}.make_singleton ((-2).to_reference) & Void & 0 & 2 & 1 & -2
--				)

			from
				sf := subset_family_structure_to_be_tested
			until
				not sf.is_empty
			loop
				sf := subset_family_structure_to_be_tested
			end
			ss0 := some_set_sa.o
			s0 := some_set_a
			from
				ss := some_set_sa
			until
				ss.is_empty implies sf.is_empty
			loop
				ss := some_set_sa
			end

			chk_ops := {ISE_RUNTIME}.check_assert (False)
				s := some_set_a ∪ sf.converted (ss).superset
			chk_ops := {ISE_RUNTIME}.check_assert (chk_ops)

			assert ("consistent_superset", sf.converted (ss).superset ⊆ s) -- s := some_set_a ∪ sf.converted (ss).superset
			assert ("ss0_violates_keep_non_emptiness", make_from_pair_got_rescued (sf, ss0, ss, s0, s))

			from
				sf := subset_family_structure_to_be_tested
			until
				not sf.is_empty
			loop
				sf := subset_family_structure_to_be_tested
			end

			chk_ops := {ISE_RUNTIME}.check_assert (False)
				from
					ss0 := some_set_sa
				until
					not sf.converted (ss0).superset.is_empty
				loop
					ss0 := some_set_sa
				end
				from
					s0 := some_set_a
				until
					sf.converted (ss0).superset ⊈ s0
				loop
					s0 := some_set_a
				end
			chk_ops := {ISE_RUNTIME}.check_assert (chk_ops)

			from
				ss := some_set_sa
			until
				ss.is_empty implies sf.is_empty
			loop
				ss := some_set_sa
			end

			chk_ops := {ISE_RUNTIME}.check_assert (False)
				s := some_set_a ∪ sf.converted (ss).superset
			chk_ops := {ISE_RUNTIME}.check_assert (chk_ops)

			assert ("consistent_superset", sf.converted (ss).superset ⊆ s) -- s := some_set_a ∪ sf.converted (ss).superset
			assert ("ss0_s0_violates_consistent_superset", make_from_pair_got_rescued (sf, ss0, ss, s0, s))

			from
				sf := subset_family_structure_to_be_tested
			until
				not sf.is_empty
			loop
				sf := subset_family_structure_to_be_tested
			end
			from
				ss := some_set_sa
			until
				ss.is_empty implies sf.is_empty
			loop
				ss := some_set_sa
			end

			chk_ops := {ISE_RUNTIME}.check_assert (False)
				s := s ∪ sf.converted (ss).superset
				from
					ss0 := some_set_sa
				until
					not ss0.is_empty and sf.converted (ss0).superset ⊈ s
				loop
					ss0 := some_set_sa
				end
				from
					s0 := some_set_a
				until
					sf.converted (ss0).superset ⊈ s0
				loop
					s0 := some_set_a
				end
			chk_ops := {ISE_RUNTIME}.check_assert (chk_ops)

			assert ("consistent_superset", sf.converted (ss).superset ⊆ s) -- s := s ∪ sf.converted (ss).superset
			assert ("ss0_s_violates_consistent_superset", make_from_pair_got_rescued (sf, ss0, ss, s0, s))

			from
				sf := subset_family_structure_to_be_tested
			until
				not sf.is_empty
			loop
				sf := subset_family_structure_to_be_tested
			end

			chk_ops := {ISE_RUNTIME}.check_assert (False)
				from
					ss := some_set_sa
				until
					not sf.converted (ss).superset.is_empty
				loop
					ss := some_set_sa
				end
				s := some_set_a ∪ sf.converted (ss).superset
				from
					ss0 := some_set_sa
				until
					not sf.converted (ss0).superset.is_empty
				loop
					ss0 := some_set_sa
				end
				from
					s0 := some_set_a
				until
					sf.converted (ss0).superset ⊈ s0 and sf.converted (ss).superset ⊈ s0
				loop
					s0 := some_set_a
				end
			chk_ops := {ISE_RUNTIME}.check_assert (chk_ops)

			assert ("keep_non_emptiness", ss.is_empty implies sf.is_empty) -- not ss.is_empty
			assert ("consistent_superset", sf.converted (ss).superset ⊆ s) -- s := some_set_a ∪ sf.converted (ss).superset
			assert ("ss_s0_violates_consistent_superset", make_from_pair_got_rescued (sf, ss0, ss, s0, s))

			sf := subset_family_structure_to_be_tested
			s0 := some_set_a
			ss0 := some_set_sa
			if sf.is_empty then
				ss0 := ss0.o
			end
			from
				ss := some_set_sa
			until
				ss.is_empty implies sf.is_empty
			loop
				ss := some_set_sa
			end

			chk_ops := {ISE_RUNTIME}.check_assert (False)
				s := some_set_a ∪ sf.converted (ss).superset
			chk_ops := {ISE_RUNTIME}.check_assert (chk_ops)

			assert ("consistent_superset", sf.converted (ss).superset ⊆ s) -- s := some_set_a ∪ sf.converted (ss).superset
			assert ("make_pair", make_from_pair_got_rescued (sf, ss0, ss, s0, s))
		end

feature -- Test routines (Comparison)

	test_equals
			-- <Precursor>
			-- Test {STS_SUBSET_FAMILY_STRUCTURE}.equals.
			-- Test {STI_SUBSET_FAMILY_STRUCTURE}.equals.
		local
			sf1: like subset_family_structure_to_be_tested
			sf2: like resources_sa.resources_a.some_subset_family_structure_a
		do
			Precursor {ORDERED_PAIR_TESTS}

			sf1 := subset_family_structure_to_be_tested
			sf2 := resources_sa.resources_a.same_subset_family_structure_a (sf1)
			assert ("sf1 ≍ sf1", sf1 ≍ sf1)
			assert ("sf1 ≍ sf1 ok", properties.equals_ok (sf1, sf1))

			sf1 := subset_family_structure_to_be_tested
			sf2 := resources_sa.resources_a.some_subset_family_structure_a
			assert ("equals", sf1 ≍ sf1 implies True)
			assert ("equals_ok", properties.equals_ok (sf1, sf1))
		end

feature {NONE} -- Factory (element to be tested)

	subset_family_structure_to_be_tested: like resources_sa.resources_a.some_direct_subset_family_structure_a
			-- Subset-family structure meant to be under tests
		do
			Result := resources_sa.resources_a.some_direct_subset_family_structure_a
		end

feature {NONE} -- Conversion

	pair_from_ssa_sa (
		ab: STS_ORDERED_PAIR [
			STS_SET [STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ]], STS_SET [A, EQ], STS_SET_EQUALITY [STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ]], STS_SET_EQUALITY [A, EQ]
			]
		): like new_pair_ssa_sa
			-- `ab` converted into a pair like `new_pair_ssa_sa`
		do
			Result := ab
		end

	pair_from_ssa_ssa_sa (
		aab: STS_COMPOSABLE_ORDERED_PAIR [
			STS_SET [STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ]], STS_SET [STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ]], STS_SET [A, EQ],
			STS_SET_EQUALITY [STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ]], STS_SET_EQUALITY [STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ]], STS_SET_EQUALITY [A, EQ]
			]
		): like new_pair_ssa_sa
			-- `aab` converted into a pair like `new_pair_ssa_sa`
		do
			Result := aab
		end

	pair_from_sa_ssaa_sa (bab: STS_COMPOSABLE_ORDERED_PAIR [
		STS_SET [A, EQ], STS_SET [STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ]], STS_SET [A, EQ],
		STS_SET_EQUALITY [A, EQ], STS_SET_EQUALITY [STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ]], STS_SET_EQUALITY [A, EQ]
		]): like new_pair_ssa_sa
			-- `bab` converted into a pair like `new_pair_ssa_sa`
		do
			Result := bab
		end

feature {NONE} -- Predicate

	make_from_pair_got_rescued
		(sf: EXPOSED_SUBSET_FAMILY_STRUCTURE [A, EQ]; ss0, ss: STI_SET [STS_SET [A, EQ], STS_SET_EQUALITY [A, EQ]]; s0, s: STS_SET [A, EQ]): BOOLEAN
			-- Does `sf'.`make_from_pair' get successfully rescued when called, successively, with the arguments (`ss0', `s0'), (`ss0', `s'), (`ss', `s0') and
			-- (`ss', `s')?
		require
			keep_non_emptiness: ss.is_empty implies sf.is_empty
			consistent_superset: sf.converted (ss).superset ⊆ s
		local
			ss0_s0_have_failed, ss0_s_have_failed, ss_s0_have_failed: BOOLEAN
			il_collecting: BOOLEAN
		do
			if not ss0_s0_have_failed then
				sf.make_from_pair (create {like new_pair_ssa_sa}.make (ss0, s0))
			elseif not ss0_s_have_failed then
				sf.make_from_pair (create {like new_pair_ssa_sa}.make (ss0, s))
			elseif not ss_s0_have_failed then
				sf.make_from_pair (create {like new_pair_ssa_sa}.make (ss, s0))
			else
				sf.make_from_pair (create {like new_pair_ssa_sa}.make (ss, s))
			end
			Result := True
			print ('%N')
		ensure
			ss0_s0: (ss0.is_empty implies sf.is_empty) and sf.converted (ss0).superset ⊆ s0 implies
				sf.set_equals (ss0) and sf.s ≍ s0
			ss0_s: (ss0.is_empty implies sf.is_empty) and sf.converted (ss0).superset ⊈ s0 and
				sf.converted (ss0).superset ⊆ s implies
				sf.set_equals (ss0) and sf.s ≍ s
			ss_s0: (
				ss0.is_empty and not sf.is_empty or
				sf.converted (ss0).superset ⊈ s0 and
				sf.converted (ss0).superset ⊈ s
				) and
				sf.converted (ss).superset ⊆ s0 implies
				sf.set_equals (ss) and sf.s ≍ s0
			ss_s: (
				ss0.is_empty and not sf.is_empty or
				sf.converted (ss0).superset ⊈ s0 and
				sf.converted (ss0).superset ⊈ s
				) and
				sf.converted (ss).superset ⊈ s0 implies
				sf.set_equals (ss) and sf.s ≍ s
		rescue
			print (sf) print (", ")
			print (ss0) if attached {STS_SUBSET_FAMILY [A, EQ]} ss0 as ss0_as_sf then
				print ("<-") print (ss0_as_sf)
			end print (", ")
			print (ss) if attached {STS_SUBSET_FAMILY [A, EQ]} ss as ss_as_sf then
				print ("<-") print (ss_as_sf)
			end print (", ")
			print (s0) print (", ")
			print (s) print ('%N')

				il_collecting := {MEMORY}.collecting
				{MEMORY}.collection_off -- Otherwise $x may get different values for the same reference at different instants.
			print (
				{
					STI_TRANSFORMER [
						STS_SET [A, EQ], STS_SET [STRING, STS_OBJECT_EQUALITY [STRING]],
						STS_SET_EQUALITY [A, EQ], STS_SET_EQUALITY [STRING, STS_OBJECT_EQUALITY [STRING]]
						]
					}.set_map (
						sf,
						agent (ia_s: STS_SET [A, EQ]): STS_SET [STRING, STS_OBJECT_EQUALITY [STRING]]
							do
								Result := {
									STI_TRANSFORMER [A, STRING, EQ, STS_OBJECT_EQUALITY [STRING]]
									}.set_map (
										ia_s, agent (x: A): STRING
											do
												if attached x then
													if x.generating_type.is_expanded then
														create Result.make_from_separate (x.out)
													else
														Result := ($x).out
													end
												else
													Result := "Void"
												end
											end
										)
							end
						)
				) print ("<-") print (
					{
						STI_TRANSFORMER [A, STRING, EQ, STS_OBJECT_EQUALITY [STRING]]
						}.set_map (
							sf.superset, agent (x: A): STRING
								do
									if attached x then
										if x.generating_type.is_expanded then
											create Result.make_from_separate (x.out)
										else
											Result := ($x).out
										end
									else
										Result := "Void"
									end
								end
							)
					) print (", ")
			print (
				{
					STI_TRANSFORMER [
						STS_SET [A, EQ], STS_SET [STRING, STS_OBJECT_EQUALITY [STRING]],
						STS_SET_EQUALITY [A, EQ], STS_SET_EQUALITY [STRING, STS_OBJECT_EQUALITY [STRING]]
						]
					}.set_map (
						ss0,
						agent (ia_s: STS_SET [A, EQ]): STS_SET [STRING, STS_OBJECT_EQUALITY [STRING]]
							do
								Result := {
									STI_TRANSFORMER [A, STRING, EQ, STS_OBJECT_EQUALITY [STRING]]
									}.set_map (
										ia_s, agent (x: A): STRING
											do
												if attached x then
													if x.generating_type.is_expanded then
														create Result.make_from_separate (x.out)
													else
														Result := ($x).out
													end
												else
													Result := "Void"
												end
											end
										)
							end
						)
				) if attached {STS_SUBSET_FAMILY [A, EQ]} ss0 as ss0_as_sf then
				print ("<-") print (
					{
						STI_TRANSFORMER [A, STRING, EQ, STS_OBJECT_EQUALITY [STRING]]
						}.set_map (
							ss0_as_sf.superset, agent (x: A): STRING
								do
									if attached x then
										if x.generating_type.is_expanded then
											create Result.make_from_separate (x.out)
										else
											Result := ($x).out
										end
									else
										Result := "Void"
									end
								end
							)
					)
			end print (", ")
			print (
				{
					STI_TRANSFORMER [
						STS_SET [A, EQ], STS_SET [STRING, STS_OBJECT_EQUALITY [STRING]],
						STS_SET_EQUALITY [A, EQ], STS_SET_EQUALITY [STRING, STS_OBJECT_EQUALITY [STRING]]
						]
					}.set_map (
						ss,
						agent (ia_s: STS_SET [A, EQ]): STS_SET [STRING, STS_OBJECT_EQUALITY [STRING]]
							do
								Result := {
									STI_TRANSFORMER [A, STRING, EQ, STS_OBJECT_EQUALITY [STRING]]
									}.set_map (
										ia_s, agent (x: A): STRING
											do
												if attached x then
													if x.generating_type.is_expanded then
														create Result.make_from_separate (x.out)
													else
														Result := ($x).out
													end
												else
													Result := "Void"
												end
											end
										)
							end
						)
				) if attached {STS_SUBSET_FAMILY [A, EQ]} ss as ss_as_sf then
				print ("<-") print (
					{
						STI_TRANSFORMER [A, STRING, EQ, STS_OBJECT_EQUALITY [STRING]]
						}.set_map (
							ss_as_sf.superset, agent (x: A): STRING
								do
									if attached x then
										if x.generating_type.is_expanded then
											create Result.make_from_separate (x.out)
										else
											Result := ($x).out
										end
									else
										Result := "Void"
									end
								end
							)
					)
			end print (", ")
			print (
				{
					STI_TRANSFORMER [A, STRING, EQ, STS_OBJECT_EQUALITY [STRING]]
					}.set_map (
						s0, agent (x: A): STRING
							do
								if attached x then
									if x.generating_type.is_expanded then
										create Result.make_from_separate (x.out)
									else
										Result := ($x).out
									end
								else
									Result := "Void"
								end
							end
						)
				) print (", ")
			print (
				{
					STI_TRANSFORMER [A, STRING, EQ, STS_OBJECT_EQUALITY [STRING]]
					}.set_map (
						s, agent (x: A): STRING
							do
								if attached x then
									if x.generating_type.is_expanded then
										create Result.make_from_separate (x.out)
									else
										Result := ($x).out
									end
								else
									Result := "Void"
								end
							end
						)
				) print ('%N')
				if il_collecting then
					{MEMORY}.collection_on
				end

			if not ss0_s0_have_failed then
				ss0_s0_have_failed := True
				retry
			end
			if not ss0_s_have_failed then
				ss0_s_have_failed := True
				retry
			end
			if not ss_s0_have_failed then
				ss_s0_have_failed := True
				retry
			end
		end

feature {NONE} -- Specific data

	specific_sf_ss0_ss_s0_s: TUPLE [sf: like subset_family_structure_to_be_tested; ss0, ss: like some_set_sa; s0, s: like some_set_a]
			-- Tuple of sets (of sets) whose (set) elements are predetermined via source code
		deferred
		ensure
			keep_non_emptiness: Result.ss.is_empty implies Result.sf.is_empty
			consistent_superset: Result.sf.converted (Result.ss).superset ⊆ Result.s
		end

note
	copyright: "Copyright (c) 2012-2021, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"
end
