﻿note
	description: "[
		Equality that compares rational numbers according to {STS_INTEGER}.equals, i.e. the integer ≍ operator.
		]"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date$"
	revision: "$Revision$"

class
	STS_INTEGER_EQUALITY [Z -> STS_INTEGER]

inherit

	STS_INSTANCE_FREE_EQUALITY [Z]

feature -- Relationship

	holds alias "()" (i1, i2: Z): BOOLEAN
			-- <Precursor>
		do
			Result := i1 ≍ i2
		ensure then
			definition: Result = (i1 ≍ i2)
		end

note
	copyright: "Copyright (c) 2012-2019, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"
end
