﻿note
	description: "[
		Equality that compares rational numbers according to {STS_NATURAL}.equals, i.e. the natural ≍ operator.
		]"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date$"
	revision: "$Revision$"

class
	STS_NATURAL_EQUALITY [N -> STS_NATURAL]

inherit

	STS_INSTANCE_FREE_EQUALITY [N]

feature -- Relationship

	holds alias "()" (n1, n2: N): BOOLEAN
			-- <Precursor>
		do
			Result := n1 ≍ n2
		ensure then
			definition: Result = (n1 ≍ n2)
		end

note
	copyright: "Copyright (c) 2012-2019, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"
end
