﻿note
	description: "Universe of integer numbers, i.e. a subset of ℤ."
	author: "Rosivaldo Fernandes Alves"
	date: "$Date$"
	revision: "$Revision$"

deferred class
	STS_INTEGER_SET [Z -> STS_INTEGER, EQ -> STS_INTEGER_EQUALITY [Z]]

inherit

	STS_SIGNED_NUMERIC_SET [Z, EQ]
		redefine
				-- Anchor
			set_anchor,
			subset_anchor,
			superset_anchor
		end

feature -- Anchor

	set_anchor,
	subset_anchor,
	superset_anchor: STS_INTEGER_SET [Z, EQ]
			-- <Precursor>
		do
			Result := Current
		end

note
	copyright: "Copyright (c) 2012-2019, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"
end
