﻿note
	description: "Universe of integer numbers, i.e. ℤ."
	author: "Rosivaldo Fernandes Alves"
	date: "$Date$"
	revision: "$Revision$"

deferred class
	STS_INTEGER_UNIVERSE [Z -> STS_INTEGER, EQ -> STS_INTEGER_EQUALITY [Z]]

inherit

	STS_INTEGER_SET [Z, EQ]
		rename
				-- Anchor
			superset_anchor as itself
		undefine
				-- Membership
			has,
				-- Anchor
			itself
		end

	STS_UNIVERSE [Z, EQ]
		undefine
				-- Anchor
			set_anchor,
			subset_anchor
		end

note
	copyright: "Copyright (c) 2012-2019, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"

end
