﻿note
	description: "Universe of natural numbers, i.e. ℕ."
	author: "Rosivaldo Fernandes Alves"
	date: "$Date$"
	revision: "$Revision$"

deferred class
	STS_NATURAL_UNIVERSE [N -> STS_NATURAL, EQ -> STS_NATURAL_EQUALITY [N]]

inherit

	STS_NATURAL_SET [N, EQ]
		rename
				-- Anchor
			superset_anchor as itself
		undefine
				-- Membership
			has,
				-- Anchor
			itself
		end

	STS_UNIVERSE [N, EQ]
		undefine
				-- Anchor
			set_anchor,
			subset_anchor
		end

feature -- Access

--	one: N
--			-- The number one
--		deferred
--		ensure
--			definition: eq (Result, Result.one)
--		end

feature -- Arithmetic

--	factorial (n: N): N
--			-- Product of all natural numbers from 1 to `n'
--			-- todo: redefine
--		do
--			Result := Current [one, n].reduced (one, agent {STS_NATURAL}.product)
--		ensure
--			definition: Result = Current [one, n].reduced (one, agent {STS_NATURAL}.product)
--		end

--feature -- Reduction

--	natural_product (acc,  m: STS_NATURAL): STS_NATURAL
--			-- `acc' times `m'
--		do
--			Result := acc *  m
--		ensure
--			class
--			definition: Result = acc *  m
--		end

note
	copyright: "Copyright (c) 2012-2019, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"

end
