﻿note
	description: "[
		{STT_ELEMENT_TESTS}, applied for {X}, {C -> STS_COMPLEX} and {B} generic parameters.
		]"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date$"
	revision: "$Revision$"
	testing: "type/manual"

deferred class
	STT_ELEMENT_TESTS_X_STC_B [
		X,
		C -> STS_COMPLEX,
		B,
		EQ_X -> STS_EQUALITY [X]
			create
				default_create
			end,
		EQ_C -> STS_COMPLEX_EQUALITY [C]
			create
				default_create
			end,
		EQ_B -> STS_EQUALITY [B]
			create
				default_create
			end
		]

--inherit
--	STT_ELEMENT_TESTS [X, C, B, EQ_X, EQ_C, EQ_B]
--		rename
--				-- {NONE} Factory (object)
--			some_object_a as some_complex
--		redefine
--				-- {NONE} Factory (element)
--			some_element
--		end

--feature {NONE} -- Factory (element)

--	some_element: STS_ELEMENT
--			-- <Precursor>
--		do
--			inspect
--				next_random_item \\ 2
--			when 0 then
--				Result := Precursor {STT_ELEMENT_TESTS}
--			else -- when 1 then
--				Result := some_complex
--			end
--		end

----feature {NONE} -- Factory (set [STS_ORDERED_PAIR [C, B, ...]])

----	some_set_c: STI_SET [STI_COMPLEX, STS_COMPLEX_EQUALITY [STI_COMPLEX]]
----			-- Randomly created set of complex numbers
----		do
----			inspect
----				next_random_item \\ 2
----			when 0 then
----				Result := Precursor {STT_ELEMENT_TESTS}
----			else -- when 1 then
----				Result := some_complex_set
----			end
----		end

----	same_set_c (s: STI_SET [STI_COMPLEX, STS_COMPLEX_EQUALITY [STI_COMPLEX]]): STI_SET [STI_COMPLEX, STS_COMPLEX_EQUALITY [STI_COMPLEX]]
----			-- <Precursor>
----		local
----			l_s: STI_SET [STI_COMPLEX, STS_COMPLEX_EQUALITY [STI_COMPLEX]]
----		do
----			inspect
----				next_random_item \\ 2
----			when 0 then
----				Result := Precursor {STT_ELEMENT_TESTS} (s)
----			else -- when 1 then
----				from
----					create {like some_complex_set} Result.make_empty
----					l_s := s
----				invariant
----					building_up: Result ≍ (s - l_s)
----				until
----					l_s.is_empty
----				loop
----						check
----							does_not_have: -- Result ≍ (s - l_s)
----								not Result.has (l_s.any)
----						end
----					Result := Result.extended (l_s.any)
----					l_s := l_s.others
----				variant
----					cardinality: (# l_s).as_integer_64
----				end
----			end
----		end

----	some_complex_set: STI_COMPLEX_SET
----			-- Randomly created complex set
----		do
----			across
----				1 |..| some_count.as_integer_32 as i
----			from
----				create Result.make_empty
----			loop
----				Result := Result & some_complex
----			end
----		end

--feature {NONE} -- Factory (object)

----	some_complex: STI_COMPLEX
----			-- Randomly created complex number
----		do
----			create Result.make (some_real, some_real)
----		end

--	same_complex (z: C): C
--			-- Complex number with the same value as `z'
--		deferred
--		ensure
--			real: Result.a ≍ z.a
--			imaginary: Result.b ≍ z.b
--		end

----	some_real: STI_REAL
----			-- Randomly created real number
----		do
----			Result := some_integer.to_real
----		end

note
	copyright: "Copyright (c) 2012-2019, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"
end
