﻿note
	description: "Test suite for {STI_INTEGER}"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date: Sat 2018-11-10 18:52:01 -0300 $"
	revision: "$Revision$"
	testing: "type/manual"

deferred class
	STT_INTEGER_TESTS

--inherit

--	STT_ELEMENT_TESTS
--		rename
--				-- Factory (element to be tested)
--			element_to_be_tested as integer_to_be_tested
--		redefine
--				-- Factory (element to be tested)
--			integer_to_be_tested
--		end

--feature -- Access

--	properties: STT_INTEGER_PROPERTIES
--			-- Object that checks the set-theory properties of {STI_INTEGER}
--		attribute
--			create Result
--		end

--feature -- Test routines (Initialization)

--	test_default_create
--			-- Test {STI_INTEGER}.default_create.
--		note
--			testing: "covers/{STI_INTEGER}.default_create"
--		do
--			assert ("default_create", attached (create {like integer_to_be_tested}))
--			assert ("default_create_ok", properties.default_create_ok)
--		end

--	test_make
--			-- Test {STI_INTEGER}.make.
--		note
--			testing: "covers/{STI_INTEGER}.make"
--		do
--			assert ("make", attached (create {like integer_to_be_tested}.make (next_random_item)))
--			assert ("convert_from_native_integer", attached integer_from_native_integer (next_random_item))
--		end

--	test_make_from_reference
--			-- Test {STI_INTEGER}.make_from_reference.
--		note
--			testing: "covers/{STI_INTEGER}.make_from_reference"
--		do
--			assert ("make_from_reference", attached (create {like integer_to_be_tested}.make_from_reference (next_random_item.to_reference)))
--			assert ("convert_from_reference", attached integer_from_reference (next_random_item.to_reference))
--		end

--	test_make_from_integer
--			-- Test {STI_INTEGER}.make_from_integer.
--		note
--			testing: "covers/{STI_INTEGER}.make_from_integer"
--		do
--			assert ("make_from_integer", attached (create {like integer_to_be_tested}.make_from_integer (integer_to_be_tested)))
--			assert ("convert_from_integer", attached integer_from_i (integer_to_be_tested))
--		end

--feature -- Test routines (Primitive)

--	test_value
--			-- Test {STI_INTEGER}.value.
--		note
--			testing: "covers/{STI_INTEGER}.value"
--		local
--			i: like integer_to_be_tested
--		do
--			i := integer_to_be_tested
--			assert ("value", attached i.value)
--			assert ("converted_to_native_integer", attached integer_as_native)
--			assert ("converted_to_native_ref", attached integer_as_native_ref)
--			assert ("converted_to_hashable", attached integer_as_hashable)
--		end

--feature -- Test routines (Access)

--	test_zero
--			-- Test {STI_INTEGER}.zero.
--		note
--			testing: "covers/{STI_INTEGER}.zero"
--		do
--			assert ("zero", attached {like integer_to_be_tested}.Zero) -- todo: assertions off. :-(
--			assert ("zero_ok", properties.zero_ok (integer_to_be_tested, new_integer))
--		end

--	test_one
--			-- Test {STI_INTEGER}.one.
--		note
--			testing: "covers/{STI_INTEGER}.one"
--		do
--			assert ("one", attached {like integer_to_be_tested}.One) -- todo: assertions off. :-(
--			assert ("one_ok", properties.one_ok (integer_to_be_tested, new_integer))
--		end

--feature -- Test routines (Status report)

--	test_divisible
--			-- Test {STI_INTEGER}.divisible.
--		note
--			testing: "covers/{STI_INTEGER}.divisible"
--		local
--			j: like new_integer
--		do
--			assert ("not_divisible_zero", not integer_to_be_tested.divisible ({STI_INTEGER}.Zero))
--			from
--				j := new_integer
--			until
--				j.value /= 0
--			loop
--				j := new_integer
--			end
--			assert ("divisible_j", integer_to_be_tested.divisible (j))
--			assert ("divisible", integer_to_be_tested.divisible (new_integer) implies True)
--		end

--	test_exponentiable
--			-- Test {STI_INTEGER}.exponentiable.
--		note
--			testing: "covers/{STI_INTEGER}.exponentiable"
--		local
--			e: NUMERIC
--		do
--			inspect
--				next_random_item \\ 4
--			when 0 then
--				e := some_natural
--			when 1 then
--				e := some_integer
--			when 2 then
--				e := Random_sequence.real_item -- todo: improve it.
--			else -- when 3 then
--				e := new_integer
--			end
--			assert ("exponentiable", integer_to_be_tested.exponentiable (e) implies True)
--		end

--feature -- Test routines (Output)

--	test_out
--			-- Test {STI_INTEGER}.out.
--		note
--			testing: "covers/{STI_INTEGER}.out"
--		do
--			assert ("out", attached integer_to_be_tested.out)
--		end

--feature -- Test routines (Comparison)

--	test_equals
--			-- Test {STI_INTEGER}.equals.
--		note
--			testing: "covers/{STI_INTEGER}.equals"
--		local
--			i: like integer_to_be_tested
--			j: like new_integer
--		do
--			i := integer_to_be_tested
--			assert ("same_entity", i ≍ i)
--			assert ("same_entity_ok", properties.equals_ok (i, i, i))
--			i := integer_to_be_tested
--			j := same_integer (i)
--			assert ("same_integer", i ≍ j)
--			assert ("same_integer_ok", properties.equals_ok (i, j, same_integer (j)))
--			i := integer_to_be_tested
--			j := new_integer
--			assert ("some_integer", i ≍ j implies True)
--			assert ("some_integer_ok", properties.equals_ok (i, j, new_integer))
--		end

--	test_is_less
--			-- Test {STI_INTEGER}.is_less.
--		note
--			testing: "covers/{STI_INTEGER}.is_less"
--		local
--			i: like integer_to_be_tested
--			j: like new_integer
--		do
--			i := integer_to_be_tested
--			assert ("same_entity", not (i < i))
--			assert ("same_entity_ok", properties.is_less_ok (i, i, i))
--			i := integer_to_be_tested
--			j := same_integer (i)
--			assert ("same_integer", not (i < j))
--			assert ("same_integer_ok", properties.is_less_ok (i, j, same_integer (j)))
--			i := integer_to_be_tested
--			j := new_integer
--			assert ("some_integer", i < j implies True)
--			assert ("some_integer_ok", properties.is_less_ok (i, j, new_integer))
--		end

--	test_is_less_equal
--			-- Test {STI_INTEGER}.is_less_equal.
--		note
--			testing: "covers/{STI_INTEGER}.is_less_equal"
--		local
--			i: like integer_to_be_tested
--			j: like new_integer
--		do
--			i := integer_to_be_tested
--			assert ("same_entity", i <= i)
--			assert ("same_entity_ok", properties.is_less_equal_ok (i, i, i))
--			i := integer_to_be_tested
--			j := same_integer (i)
--			assert ("same_integer", i <= j)
--			assert ("same_integer_ok", properties.is_less_equal_ok (i, j, same_integer (j)))
--			i := integer_to_be_tested
--			j := new_integer
--			assert ("some_integer", i <= j implies True)
--			assert ("some_integer_ok", properties.is_less_equal_ok (i, j, new_integer))
--		end

--feature -- Test routines (Basic operations)

--	test_plus
--			-- Test {STI_INTEGER}.plus.
--		note
--			testing: "covers/{STI_INTEGER}.plus"
--		local
--			i: like integer_to_be_tested
--			j: like new_integer
--		do
--			from
--				i := integer_to_be_tested
--				j := new_integer
--			until
--				i <= j
--			loop
--				i := integer_to_be_tested
--				j := new_integer
--			end
--			assert ("first_sum", attached (i + j))
--			assert ("homomorphism_ok", properties.plus_ok (i, j, new_integer))

--			from
--				i := integer_to_be_tested
--				j := new_integer
--			until
--				i < j
--			loop
--				i := integer_to_be_tested
--				j := new_integer
--			end
--			assert ("second_sum", attached (i + j))
--			assert ("isomorphism_ok", properties.plus_ok (i, j, new_integer))

--			i := integer_to_be_tested
--			j := new_integer
--			assert ("third_sum", attached (i + j))
--			assert ("plus_ok", properties.plus_ok (i, j, new_integer))
--		end

--	test_identity
--			-- Test {STI_INTEGER}.identity.
--		note
--			testing: "covers/{STI_INTEGER}.identity"
--		local
--			i: like integer_to_be_tested
--		do
--			i := integer_to_be_tested
--			assert ("identity", attached (+ i))
--			assert ("identity_ok", properties.identity_ok (i))
--		end

--	test_minus
--			-- Test {STI_INTEGER}.minus.
--		note
--			testing: "covers/{STI_INTEGER}.minus"
--		local
--			i: like integer_to_be_tested
--			j: like new_integer
--		do
--			from
--				i := integer_to_be_tested
--				j := new_integer
--			until
--				i <= j
--			loop
--				i := integer_to_be_tested
--				j := new_integer
--			end
--			assert ("first_subtraction", attached (i - j))
--			assert ("homomorphism_ok", properties.minus_ok (i, j, new_integer))

--			from
--				i := integer_to_be_tested
--				j := new_integer
--			until
--				i < j
--			loop
--				i := integer_to_be_tested
--				j := new_integer
--			end
--			assert ("second_subtraction", attached (i - j))
--			assert ("isomorphism_ok", properties.minus_ok (i, j, new_integer))

--			i := integer_to_be_tested
--			j := new_integer
--			assert ("third_subtraction", attached (i - j))
--			assert ("minus_ok", properties.minus_ok (i, j, new_integer))
--		end

--	test_opposite
--			-- Test {STI_INTEGER}.opposite.
--		note
--			testing: "covers/{STI_INTEGER}.opposite"
--		local
--			i: like integer_to_be_tested
--		do
--			i := integer_to_be_tested
--			assert ("opposite", attached (- i))
--			assert ("opposite_ok", properties.opposite_ok (i))
--		end

--	test_product
--			-- Test {STI_INTEGER}.product.
--		note
--			testing: "covers/{STI_INTEGER}.product"
--		local
--			i: like integer_to_be_tested
--			j: like new_integer
--		do
--			from
--				i := integer_to_be_tested
--				j := new_integer
--			until
--				i <= j
--			loop
--				i := integer_to_be_tested
--				j := new_integer
--			end
--			assert ("first_product", attached (i * j))
--			assert ("homomorphism_ok", properties.product_ok (i, j, new_integer))

--			from
--				i := integer_to_be_tested
--				j := new_integer
--			until
--				i < j
--			loop
--				i := integer_to_be_tested
--				j := new_integer
--			end
--			assert ("second_product", attached (i * j))
--			assert ("isomorphism_ok", properties.product_ok (i, j, new_integer))

--			i := integer_to_be_tested
--			j := new_integer
--			assert ("third_product", attached (i * j))
--			assert ("product_ok", properties.product_ok (i, j, new_integer))
--		end

--	test_integer_quotient
--			-- Test {STI_INTEGER}.integer_quotient.
--		note
--			testing: "covers/{STI_INTEGER}.integer_quotient"
--		local
--			i: like integer_to_be_tested
--			j: like new_integer
--		do
--			from
--				i := integer_to_be_tested
--				j := new_integer
--			until
--				i <= j and i.divisible (j)
--			loop
--				i := integer_to_be_tested
--				j := new_integer
--			end
--			assert ("first_quotient", attached (i // j))
--			assert ("homomorphism_ok", properties.integer_quotient_ok (i, j, new_integer))

--			from
--				i := integer_to_be_tested
--				j := new_integer
--			until
--				i < j and i.divisible (j)
--			loop
--				i := integer_to_be_tested
--				j := new_integer
--			end
--			assert ("second_quotient", attached (i // j))
--			assert ("isomorphism_ok", properties.integer_quotient_ok (i, j, new_integer))

--			i := integer_to_be_tested
--			j := new_integer
--			assert ("third_quotient", i.divisible (j) implies attached (i // j))
--			assert ("integer_quotient_ok", properties.integer_quotient_ok (i, j, new_integer))
--		end

--feature -- Test routines (Factory)

--	test_normalized_value
--			-- Test {STI_INTEGER}.normalized_value.
--		note
--			testing: "covers/{STI_INTEGER}.normalized_value"
--		do
--			assert ("normalized_value", attached {like integer_to_be_tested}.normalized_value (next_random_item))
--		end

--feature {NONE} -- Factory (element to be tested)

--	integer_to_be_tested: like new_integer
--			-- Integer meant to be under tests
--		do
--			check
--					-- `some_direct_instance' and `new_integer' definitions
--				i: attached {like new_integer} some_direct_instance (agent new_integer) as i
--				monomorphic: i.generating_type ~ {detachable like new_integer}
--			then
--				Result := i
--			end
--		end

--feature -- Factory (integer)

--	new_integer: STI_INTEGER
--			-- Randomly created integer number
--		do
--			Result := next_random_item
--		ensure
--			class
--		end

--	same_integer (i: STI_INTEGER): like new_integer
--			-- Integer number mathematically equal to `i', with type randomly chosen.
--		do
--			inspect next_random_item \\ 3
--			when 0 then
--				Result := i
--			when 1 then
--				Result := i.twin
--			else -- when 2 then
--				Result := i.value
--			end
--			if Result /= i then
--				check
--					does_not_have: not object_pool.has (Result) -- `Result' is a new reference.
--				end
--				set_object_pool (object_pool.extended (Result))
--			end
--		ensure
--			same_integer: Result ≍ i
--		end

--feature {NONE} -- Conversion

--	integer_from_native_integer (v: INTEGER): like integer_to_be_tested
--			-- `v' converted to an integer like `integer_to_be_tested'
--		do
--			Result := v
--		ensure
--			normalized_value: Result.value = {STI_INTEGER}.normalized_value (v)
--		end

--	integer_from_reference (v_ref: INTEGER_REF): like integer_to_be_tested
--			-- `v_ref' converted to an integer like `integer_to_be_tested'
--		do
--			Result := v_ref
--		ensure
--			normalized_value: Result.value = {STI_INTEGER}.normalized_value (v_ref.item)
--		end

--	integer_from_i (i: STS_INTEGER): like integer_to_be_tested
--			-- `i' converted to an integer like `integer_to_be_tested'
--		do
--			Result := i
--		ensure
--			normalized_value: Result.value = {STI_INTEGER}.normalized_value (i.value)
--		end

--	integer_as_native: INTEGER
--			-- Integer like `integer_to_be_tested' converted to an {INTEGER}
--		do
--			Result := integer_to_be_tested
--		end

--	integer_as_native_ref: INTEGER_REF
--			-- Integer like `integer_to_be_tested' converted to an {INTEGER_REF}
--		do
--			Result := integer_to_be_tested
--		end

--	integer_as_hashable: HASHABLE
--			-- Integer like `integer_to_be_tested' converted to a {HASHABLE}
--		do
--			Result := integer_to_be_tested
--		end

note
	copyright: "Copyright (c) 2012-2019, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"

end
