note
	description: "[
		{STT_INTEGER_TESTS}, made effective by inheriting  {STT_CORE_TESTS_RESOURCES_TERNARY_NCI}.
	]"
	author: "Rosivaldo Fernandes Alves"
	date: "$Date: Sat 2018-11-10 18:52:01 -0300 $"
	revision: "$Revision$"
	testing: "type/manual"

class
	STT_INTEGER_TESTS_NCI

--inherit

--	STT_INTEGER_TESTS
--		redefine
--				-- Test routines (Initialization)
--			test_default_create,
--			test_make,
--			test_make_from_reference,
--			test_make_from_integer,
--				-- Test routines (Primitive)
--			test_value,
--				-- Test routines (Membership)
--			test_is_in,
--				-- Test routines (Access)
--			test_zero,
--			test_one,
--				-- Test routines (Status report)
--			test_divisible,
--			test_exponentiable,
--				-- Test routines (Output)
--			test_out,
--				-- Test routines (Comparison)
--			test_equals,
--			test_is_less,
--			test_is_less_equal,
--				-- Test routines (Basic operations)
--			test_plus,
--			test_identity,
--			test_minus,
--			test_opposite,
--			test_product,
--			test_integer_quotient,
--				-- Test routines (Factory)
--			test_normalized_value
--		end

--	STT_CORE_TESTS_RESOURCES_TERNARY_NCI

--feature -- Test routines (Initialization)

--	test_default_create
--			-- Test {STI_INTEGER}.default_create.
--		note
--			testing: "covers/{STI_INTEGER}.default_create"
--		do
--			Precursor {STT_INTEGER_TESTS}
--		end

--	test_make
--			-- Test {STI_INTEGER}.make.
--		note
--			testing: "covers/{STI_INTEGER}.make"
--		do
--			Precursor {STT_INTEGER_TESTS}
--		end

--	test_make_from_reference
--			-- Test {STI_INTEGER}.make_from_reference.
--		note
--			testing: "covers/{STI_INTEGER}.make_from_reference"
--		do
--			Precursor {STT_INTEGER_TESTS}
--		end

--	test_make_from_integer
--			-- Test {STI_INTEGER}.make_from_integer.
--		note
--			testing: "covers/{STI_INTEGER}.make_from_integer"
--		do
--			Precursor {STT_INTEGER_TESTS}
--		end

--feature -- Test routines (Primitive)

--	test_value
--			-- Test {STI_INTEGER}.value.
--		note
--			testing: "covers/{STI_INTEGER}.value"
--		do
--			Precursor {STT_INTEGER_TESTS}
--		end

--feature -- Test routines (Membership)

--	test_is_in
--			-- Test {STI_INTEGER}.is_in.
--		note
--			testing: "covers/{STI_INTEGER}.is_in"
--		do
--			Precursor {STT_INTEGER_TESTS}
--		end

--feature -- Test routines (Access)

--	test_zero
--			-- Test {STI_INTEGER}.zero.
--		note
--			testing: "covers/{STI_INTEGER}.zero"
--		do
--			Precursor {STT_INTEGER_TESTS}
--		end

--	test_one
--			-- Test {STI_INTEGER}.one.
--		note
--			testing: "covers/{STI_INTEGER}.one"
--		do
--			Precursor {STT_INTEGER_TESTS}
--		end

--feature -- Test routines (Status report)

--	test_divisible
--			-- Test {STI_INTEGER}.divisible.
--		note
--			testing: "covers/{STI_INTEGER}.divisible"
--		do
--			Precursor {STT_INTEGER_TESTS}
--		end

--	test_exponentiable
--			-- Test {STI_INTEGER}.exponentiable.
--		note
--			testing: "covers/{STI_INTEGER}.exponentiable"
--		do
--			Precursor {STT_INTEGER_TESTS}
--		end

--feature -- Test routines (Output)

--	test_out
--			-- Test {STI_INTEGER}.out.
--		note
--			testing: "covers/{STI_INTEGER}.out"
--		do
--			Precursor {STT_INTEGER_TESTS}
--		end

--feature -- Test routines (Comparison)

--	test_equals
--			-- Test {STI_INTEGER}.equals.
--		note
--			testing: "covers/{STI_INTEGER}.equals"
--		do
--			Precursor {STT_INTEGER_TESTS}
--		end

--	test_is_less
--			-- Test {STI_INTEGER}.is_less.
--		note
--			testing: "covers/{STI_INTEGER}.is_less"
--		do
--			Precursor {STT_INTEGER_TESTS}
--		end

--	test_is_less_equal
--			-- Test {STI_INTEGER}.is_less_equal.
--		note
--			testing: "covers/{STI_INTEGER}.is_less_equal"
--		do
--			Precursor {STT_INTEGER_TESTS}
--		end

--feature -- Test routines (Basic operations)

--	test_plus
--			-- Test {STI_INTEGER}.plus.
--		note
--			testing: "covers/{STI_INTEGER}.plus"
--		do
--			Precursor {STT_INTEGER_TESTS}
--		end

--	test_identity
--			-- Test {STI_INTEGER}.identity.
--		note
--			testing: "covers/{STI_INTEGER}.identity"
--		do
--			Precursor {STT_INTEGER_TESTS}
--		end

--	test_minus
--			-- Test {STI_INTEGER}.minus.
--		note
--			testing: "covers/{STI_INTEGER}.minus"
--		do
--			Precursor {STT_INTEGER_TESTS}
--		end

--	test_opposite
--			-- Test {STI_INTEGER}.opposite.
--		note
--			testing: "covers/{STI_INTEGER}.opposite"
--		do
--			Precursor {STT_INTEGER_TESTS}
--		end

--	test_product
--			-- Test {STI_INTEGER}.product.
--		note
--			testing: "covers/{STI_INTEGER}.product"
--		do
--			Precursor {STT_INTEGER_TESTS}
--		end

--	test_integer_quotient
--			-- Test {STI_INTEGER}.integer_quotient.
--		note
--			testing: "covers/{STI_INTEGER}.integer_quotient"
--		do
--			Precursor {STT_INTEGER_TESTS}
--		end

--feature -- Test routines (Factory)

--	test_normalized_value
--			-- Test {STI_INTEGER}.normalized_value.
--		note
--			testing: "covers/{STI_INTEGER}.normalized_value"
--		do
--			Precursor {STT_INTEGER_TESTS}
--		end

note
	copyright: "Copyright (c) 2012-2019, Rosivaldo Fernandes Alves"
	license: "[
		Eiffel Forum License v2
		(see http://www.eiffel.com/licensing/forum.txt)
		]"
	source: "https://launchpad.net/set-theory"

end
